#!/bin/sh
#
# rlm          Start/Stop rlm
#

#----------------------------------------------------------------
#----------------------------------------------------------------
#----------------------------------------------------------------
# NOTE:
# NOTE: Configure these 5 variables for your system
# NOTE:

# Set rlmuser to the user under which rlm will run
rlmuser=rlm

# Set rlmdir to the directory where the rlm binary is found
rlmdir=/opt/rlm

# Set rlmdir to the directory where the rlmutil binary is found
rlmutildir=$rlmdir

# Set debuglog to the path to the debug log
debuglog=+$rlmdir/rlm.dl
#----------------------------------------------------------------
#----------------------------------------------------------------
#----------------------------------------------------------------

start() {
	cd "$rlmdir"
	su -p "$rlmuser" -c "$rlmdir/rlm -dlog $debuglog &"
}

stop() {
	su -p "$rlmuser" -c "$rlmutildir/rlmutil rlmdown -q RLM"
}	

case "$1" in
  start)
  	start
	;;
  stop)
  	stop
	;;
  restart)
	stop
	sleep 2
	start
	;;
  *)
	echo $"Usage: $0 {start|stop|restart}"
	exit 1
esac

exit 0
