'use strict';

import angular from  "angular";
import "angular-resource";

export default angular.module('fastx.Api',['ngResource'])
.factory('Api',['$resource',function($resource){
	function responseWasSuccessful(data){
		return data.hasOwnProperty('result');
	}

	function get(uri,params,success,error){
		success = success || function(d){};
		error   = error   || function(e){};
		$resource(uri,params).get(function(d){
			if(responseWasSuccessful(d)){
				var a = JSON.parse(angular.toJson(d.result));
				success(a);
			}else{
				error(d);
			}
		},function(e){
			error(e)
		});
	}
	function post(uri,params,body,success,error){
		success = success || function(d){};
		error   = error   || function(e){};
		$resource(uri,params).save(body,function(d){
			if(responseWasSuccessful(d)){
				success(JSON.parse(angular.toJson(d.result)));
			}else{
				error(d);
			}
		},function(e){
			error({
				error:{
					code:e.status,
					message:e.statusText
				}
			});
		});
	}
	function remove(uri,params,success,error){
		success = success || function(d){};
		error   = error   || function(e){};
		$resource(uri,params).remove(function(d){
			if(responseWasSuccessful(d)){
				success(JSON.parse(angular.toJson(d.result)));
			}else{
				error(d);
			}
		},function(e){
			error({
				error:{
					code:e.status,
					message:e.statusText
				}
			});
		});
	}
	return {
		get:get,
		post:post,
		remove:remove
	}
}]);
