'use strict';

import angular from "angular";

export default angular.module('fastx.Collection',[])
.factory('Collection',[function(){
	var f = function(){
		var that = this;
		var items = {};
		this.set = function(myItems,idKey){
			var that = this;
			idKey = idKey || "id";

			myItems.forEach(function(c){
				that.update(c[idKey],c);
			});

			var keys = myItems.map(function(c){
				return c[idKey];
			});

			Object.keys(items).filter(function(c){
				return keys.indexOf(c) <0;
			}).forEach(function(c){
				delete items[c]; //remove missing items
			});
		}
		this.update = function(id,item){
			if(!items[id]){
				items[id] = {
					selected:false,
				}
			}
			items[id].data = item;
		},

		this.remove = function(id){
			delete items[id];
		}
		this.selectAll = function(bool){
			for(var i in items){
				items[i].selected = Boolean(bool);
			}
			this.selectAllFlag =  Boolean(bool);
		}
		this.selectOne = function(id){
			this.selectAll(false);
			items[id].selected = true;
		}
		this.sort = {
			type:null,
			reverse:false,
			filter:''
		};
		this.selectAllFlag = false;
		this.get = function(id){
			return items[id];
		}
		Object.defineProperties(this,{
			items:{
				get:function(){return Object.keys(items).map(function(c){return items[c];});}
			},
			all:{
				get:function(){
					return Object.keys(items).every(function(c){return items[c].selected;});
				}
			},
			some:{
				get:function(){
					var k = Object.keys(items);
					k = k.filter(function(c){
						return items[c].selected;
					});
					return k.length;
				}
			},
			one:{
				get:function(){
					var k = Object.keys(items);
					k = k.filter(function(c){
						return items[c].selected;
					});
					if(k.length === 1){
						return items[k];
					}
				}
			},
			selected:{
				get:function(){
					var a = [];
					for(var i in items){
						if(items[i].selected){
							a.push(items[i]);
						}
					}
					return a;
				}
			},
			unselected:{
				get:function(){
					var a = [];
					for(var i in items){
						if(!items[i].selected){
							a.push(items[i]);
						}
					}
					return a;
				}
			}

		});
	}
	return f;
}]);
