'use strict';
import angular from "angular";
import "angular-route";

import "./Api";
import "./utils";

export default angular.module('fastx.command-module',['ngRoute','fastx.utils','fastx.Api'])
.factory('CommandModule',['$location','Token','$window','Api','Version',
function($location,Token,$window,Api,Version){
	var fac = {};
	var v;
	Version(function(d){
		v = d;
	})
	function noToken(){
		if(!Token.token){
			$window.location.reload();
		}
	}
	function responseWasSuccessful(data){
		return data.hasOwnProperty('result');
	}

	/****************************** FASTX SESSION COMMANDS*******************************/
	fac.list = function(query,success,error){
		noToken();
		var q = angular.extend(query);
		Api.get('api/list',{token:Token.token},q,success,error);
	};
	fac.getProfiles = function(query,success,error){
		noToken();
		var q = angular.extend(query);
		Api.get('api/session/profile',{token:Token.token},q,success,error);
	};
	fac.editSession = function(o,success,error){
		noToken();
		Api.post('api/params',{token:Token.token},o,success,error);
	};
	fac.connect = function(o,success,error){
		noToken();
		if(v && v.version){
			Api.post('api/params',{token:Token.token},{
				clientVersion:'web' + v.version
			});
		}
		Api.post('api/connect',{token:Token.token},o,success,error);
	};
	fac.disconnect = function(o,success,error){
		noToken();
		Api.post('api/disconnect',{token:Token.token},o,success,error);
	};
	fac.terminate = function(o,success,error){
		noToken();
		Api.post('api/terminate',{token:Token.token},o,success,error);
	};
	fac.schedule = function(o,success,error){
		noToken();
		Api.post('api/schedule',{token:Token.token},o,success,error);
	};
	fac.start = function(o,success,error){
		noToken();
		Api.post('api/start',{token:Token.token},o,success,error);
	};
	fac.startBookmark = function(o,success,error){
		noToken();
		Api.post('api/start/bookmark',{},o,success,error);
	};
	fac.shortcut = function(o,success,error){
		noToken();
		Api.post('api/connect/shortcut',{},o,success,error);
	};
	fac.screenshot = function(o,success,error){
		noToken();
		Api.post('api/screenshot',{token:Token.token},o,success,error);
	};
	fac.log = function(o,success,error){
		noToken();
		Api.post('api/log',{token:Token.token},o,success,error);
	};
	fac.share = function(o,success,error){
		Api.post('api/share',{},o,success,error);
	};
	return fac;
}]);
