'user strict';

import angular from "angular";

import "angular-sanitize";
import "../../lib/angular-foundation.min";

export default angular.module('fastx.connection-util',['mm.foundation','ngSanitize'])
.factory('ClosedDialog',['$modal',function($modal){
	return function(e){
		var mi = $modal.open({
			controller:'ConnectionClosedCtrl',
			templateUrl:'js/common/connection/closed-dialog.html',
			resolve:{e:function(){return e;}},
			backdrop:'static',
			size:'small'
		});
	}
}])
.controller('ConnectionClosedCtrl',['$scope','$modalInstance','$window','e',function($scope,$modalInstance,$window,e){
	//$scope.debug = true;
	if(!e){
		e = {
			message:'Your Connection has closed'
		};
	}else if(e.error && e.error.message){
		e.message = e.error.message;
	}else if(!e.reason && !e.message){
		e.message = 'Your Connection has closed'
	}
	$scope.e = e;
}])
.factory('NameDialog',['$window','$modal','$q',function($window,$modal,$q){
	return function(name){
		var q = $q.defer();
		var mi = $modal.open({
			controller:'NameDialogCtrl',
			templateUrl:'js/common/connection/name-dialog.html',
			backdrop:'static',
			size:'small',
			resolve:{
				name:function(){return $window.localStorage[name];}
			}
		});
		mi.result.then(function(username){
			$window.localStorage[name] = username;
			q.resolve(username);
		},function(e){
			q.reject({message:'Username is required'});
		});
		return q.promise;
	}
}])
.controller('NameDialogCtrl',['$scope','$modalInstance','name',
	function($scope,$modalInstance,name){
		$scope.username =name;
}])
