"use strict";

import angular from "angular";

export default angular.module('fastx.keyboardLayoutFactory',[])
.factory ('KeyboardLayouts', [function () {
	var f = {};
	f.layouts = [
		{name:'Arabic (101)',id:0x00000401},
		{name:'Bulgarian',id:0x00000402},
		{name:'Chinese (Traditional) - US Keyboard',id:0x00000404},
		{name:'Czech',id:0x00000405},
		{name:'Danish',id:0x00000406},
		{name:'German',id:0x00000407},
		{name:'Greek',id:0x00000408},
		{name:'US',id:0x00000409},
		{name:'Spanish',id:0x0000040a},
		{name:'Finnish',id:0x0000040b},
		{name:'French',id:0x0000040c},
		{name:'Hebrew',id:0x0000040d},
		{name:'Hungarian',id:0x0000040e},
		{name:'Icelandic',id:0x0000040f},
		{name:'Italian',id:0x00000410},
		{name:'Japanese',id:0x00000411},
		{name:'Korean',id:0x00000412},
		{name:'Dutch',id:0x00000413},
		{name:'Norwegian',id:0x00000414},
		{name:'Polish (Programmers)',id:0x00000415},
		{name:'Portuguese (Brazilian ABNT)',id:0x00000416},
		{name:'Romanian (Legacy)',id:0x00000418},
		{name:'Russian',id:0x00000419},
		{name:'Croatian',id:0x0000041a},
		{name:'Slovak',id:0x0000041b},
		{name:'Albanian',id:0x0000041c},
		{name:'Swedish',id:0x0000041d},
		{name:'Thai Kedmanee',id:0x0000041e},
		{name:'Turkish Q',id:0x0000041f},
		{name:'Urdu',id:0x00000420},
		{name:'Ukrainian',id:0x00000422},
		{name:'Belarusian',id:0x00000423},
		{name:'Slovenian',id:0x00000424},
		{name:'Estonian',id:0x00000425},
		{name:'Latvian',id:0x00000426},
		{name:'Lithuanian IBM',id:0x00000427},
		{name:'Tajik',id:0x00000428},
		{name:'Persian',id:0x00000429},
		{name:'Vietnamese',id:0x0000042a},
		{name:'Armenian Eastern',id:0x0000042b},
		{name:'Azeri Latin',id:0x0000042c},
		{name:'Macedonian (FYROM)',id:0x0000042f},
		{name:'Georgian',id:0x00000437},
		{name:'Faeroese',id:0x00000438},
		{name:'Devanagari-INSCRIPT',id:0x00000439},
		{name:'Maltese 47-Key',id:0x0000043a},
		{name:'Norwegian with Sami',id:0x0000043b},
		{name:'Kazakh',id:0x0000043f},
		{name:'Kyrgyz Cyrillic',id:0x00000440},
		{name:'Turkmen',id:0x00000442},
		{name:'Tatar',id:0x00000444},
		{name:'Bengali',id:0x00000445},
		{name:'Punjabi',id:0x00000446},
		{name:'Gujarati',id:0x00000447},
		{name:'Oriya',id:0x00000448},
		{name:'Tamil',id:0x00000449},
		{name:'Telugu',id:0x0000044a},
		{name:'Kannada',id:0x0000044b},
		{name:'Malayalam',id:0x0000044c},
		{name:'ASSAMESE - INSCRIPT',id:0x0000044d},
		{name:'Marathi',id:0x0000044e},
		{name:'Mongolian Cyrillic',id:0x00000450},
		{name:'Tibetan (People\'s Republic of China)',id:0x00000451},
		{name:'United Kingdom Extended',id:0x00000452},
		{name:'Khmer',id:0x00000453},
		{name:'Lao',id:0x00000454},
		{name:'Syriac',id:0x0000045a},
		{name:'Sinhala',id:0x0000045b},
		{name:'Nepali',id:0x00000461},
		{name:'Pashto (Afghanistan)',id:0x00000463},
		{name:'Divehi Phonetic',id:0x00000465},
		{name:'Bashkir',id:0x0000046d},
		{name:'Luxembourgish',id:0x0000046e},
		{name:'Greenlandic',id:0x0000046f},
		{name:'Uighur',id:0x00000480},
		{name:'Maori',id:0x00000481},
		{name:'Yakut',id:0x00000485},
		{name:'Chinese (Simplified) - US Keyboard',id:0x00000804},
		{name:'Swiss German',id:0x00000807},
		{name:'United Kingdom',id:0x00000809},
		{name:'Latin American',id:0x0000080a},
		{name:'Belgian French',id:0x0000080c},
		{name:'Belgian (Period)',id:0x00000813},
		{name:'Portuguese',id:0x00000816},
		{name:'Serbian (Latin)',id:0x0000081a},
		{name:'Azeri Cyrillic',id:0x0000082c},
		{name:'Swedish with Sami',id:0x0000083b},
		{name:'Uzbek Cyrillic',id:0x00000843},
		{name:'Mongolian (Mongolian Script)',id:0x00000850},
		{name:'Inuktitut - Latin',id:0x0000085d},
		{name:'Canadian French (Legacy)',id:0x00000c0c},
		{name:'Serbian (Cyrillic)',id:0x00000c1a},
		{name:'Canadian French',id:0x00001009},
		{name:'Swiss French',id:0x0000100c},
		{name:'Irish',id:0x00001809},
		{name:'Bosnian (Cyrillic)',id:0x0000201a},
		{name:'Arabic (102)',id:0x00010401},
		{name:'Bulgarian (Latin)',id:0x00010402},
		{name:'Czech (QWERTY)',id:0x00010405},
		{name:'German (IBM)',id:0x00010407},
		{name:'Greek (220)',id:0x00010408},
		{name:'United States - Dvorak',id:0x00010409},
		{name:'Spanish Variation',id:0x0001040a},
		{name:'Hungarian 101-key',id:0x0001040e},
		{name:'Italian (142)',id:0x00010410},
		{name:'Polish (214)',id:0x00010415},
		{name:'Portuguese (Brazilian ABNT2)',id:0x00010416},
		{name:'Romanian (Standard)',id:0x00010418},
		{name:'Russian (Typewriter)',id:0x00010419},
		{name:'Slovak (QWERTY)',id:0x0001041b},
		{name:'Thai Pattachote',id:0x0001041e},
		{name:'Turkish F',id:0x0001041f},
		{name:'Latvian (QWERTY)',id:0x00010426},
		{name:'Lithuanian',id:0x00010427},
		{name:'Armenian Western',id:0x0001042b},
		{name:'Sorbian Extended',id:0x0001042e},
		{name:'Macedonian (FYROM) - Standard',id:0x0001042f},
		{name:'Georgian (QWERTY)',id:0x00010437},
		{name:'Hindi Traditional',id:0x00010439},
		{name:'Maltese 48-key',id:0x0001043a},
		{name:'Sami Extended Norway',id:0x0001043b},
		{name:'Bengali - INSCRIPT (Legacy)',id:0x00010445},
		{name:'Syriac Phonetic',id:0x0001045a},
		{name:'Sinhala - wij 9',id:0x0001045b},
		{name:'Inuktitut - Naqittaut',id:0x0001045d},
		{name:'Divehi Typewriter',id:0x00010465},
		{name:'Belgian (Comma)',id:0x0001080c},
		{name:'Finnish with Sami',id:0x0001083b},
		{name:'Canadian Multilingual Standard',id:0x00011009},
		{name:'Gaelic',id:0x00011809},
		{name:'Arabic (102) AZERTY',id:0x00020401},
		{name:'Bulgarian (phonetic layout)',id:0x00020402},
		{name:'Czech Programmers',id:0x00020405},
		{name:'Greek (319)',id:0x00020408},
		{name:'United States - International',id:0x00020409},
		{name:'Romanian (Programmers)',id:0x00020418},
		{name:'Thai Kedmanee (non-ShiftLock)',id:0x0002041e},
		{name:'Ukrainian (Enhanced)',id:0x00020422},
		{name:'Lithuanian New',id:0x00020427},
		{name:'Georgian (Ergonomic)',id:0x00020437},
		{name:'Bengali - INSCRIPT',id:0x00020445},
		{name:'Sami Extended Finland-Sweden',id:0x0002083b},
		{name:'Bulgarian (phonetic layout)',id:0x00030402},
		{name:'Greek (220) Latin',id:0x00030408},
		{name:'United States-Devorak for left hand',id:0x00030409},
		{name:'Thai Pattachote (non-ShiftLock)',id:0x0003041e},
		{name:'Greek (319) Latin',id:0x00040408},
		{name:'United States-Dvorak for right hand',id:0x00040409},
		{name:'Greek Latin',id:0x00050409},
		{name:'Greek Polytonic',id:0x00060408}
		];

		f.types = [
			{name:'IBM PC/XT or compatible (83-key) keyboard',id:0x00000001},
			{name:'Olivetti "ICO" (102-key) keyboard',id:0x00000002},
			{name:'IBM PC/AT (84-key) and similar keyboards',id:0x00000003},
			{name:'IBM enhanced (101-key or 102-key) keyboard',id:0x00000004},
			{name:'Nokia 1050 and similar keyboards',id:0x00000005},
			{name:'Nokia 9140 and similar keyboards',id:0x00000006},
			{name:'Japanese keyboard',id:0x00000007}
		];
		f.layouts = f.layouts.sort(function(a,b){
			if(a.name.toLowerCase() > b.name.toLowerCase()){return 1;}
			if(b.name.toLowerCase() > a.name.toLowerCase()){return -1;}
			return 0;
		});

		return f
}])
