'use strict';
import angular from  "angular";
import "angular-route";

import "./components/nav";
import "./session/my-sessions/my-sessions";
import "../common/utils";

import "../lib/angular-foundation.min";

// Declare app level module which depends on views, and components
export default angular.module('fastx', [
  'ngRoute',
  'fastx.utils',
  'fastx.mySessions',
  'mm.foundation'
]).
config(['$locationProvider','$routeProvider',function($locationProvider,$routeProvider){
    $locationProvider.html5Mode(false);
    $routeProvider
        .otherwise({
            templateUrl:"js/fastx/session/my-sessions/session.html",
            controller:"MySessionsCtrl"
        });
}]).
run(['$rootScope','$location','$window','$interval','Token','Config','$modal','$sce',
	function($rootScope,$location,$window,$interval,Token,Config,$modal,$sce){
	$rootScope.rail = $window.FastXDefaults.rail;
	Config(function(s){
		$rootScope.config = s;
		if(s.motd && !$window.sessionStorage['motd']){
			$window.sessionStorage['motd'] = 1;
			var mi = $modal.open({
				templateUrl:'js/common/motd.html',
				controller:'MotdDialogCtrl',
				resolve:{
					motd:function(){
						return $sce.trustAsHtml(s.motd);
					}
				}
			});
			mi.result.then(function(){},function(){});
		}

	},function(e){
		$rootScope.config = {}
	});

	(function ref(){
		Token.refresh(function(){
			setTimeout(ref,60000);
		},function(e){});
	})();
}])
.controller('MotdDialogCtrl',['$scope','$modalInstance','motd',function($scope,$modalInstance,motd){
	$scope.close = $modalInstance.close;
	$scope.motd = motd;
}]);
