'use strict';

import angular from "angular";

import "../user-menu/bookmark";
import "../user-menu/settings";
import "../../common/Api";
import "../../common/utils";

import "../../lib/angular-foundation.min";

export default angular.module('fastx.Nav',['mm.foundation',
'fastx.Bookmark',
'fastx.Api',
'fastx.utils',
'fastx.settings'])
.run(['$rootScope','Upgrade',function($rootScope,Upgrade){
	Upgrade(function(d){
		$rootScope.update = d.update;
	});
}])
.controller('NavCtrl',['$scope','$modal','$window','Bookmark','Api',function($scope,$modal,$window,Bookmark,Api){
	$scope.bookmarkDialog = function(){
		var mi = $modal.open({
			templateUrl:'js/fastx/user-menu/bookmark-dialog.html',
			controller:'BookmarkDialogCtrl',
			size:'large'
		});
		mi.result.then(function(){},function(){});
	}
	$scope.settingsDialog = function(){
		var mi = $modal.open({
			templateUrl:'js/fastx/user-menu/settings-dialog.html',
			controller:'SettingsDialogCtrl'
		});
		mi.result.then(function(){},function(){});
	}

	function loggedOut(){
		//$scope.loggedIn = false;
		$window.location.reload();
	}
	$scope.logout = function(){
		Api.post('api/logout',{},loggedOut,loggedOut);
	}
}]);
angular.bootstrap(document.getElementById('nav'),['fastx.Nav']);
