'use strict';
import angular from "angular";

import "../../../common/share/share";
import "../../../common/command-module";

import "../../../lib/angular-foundation.min";

export default angular.module('fastx.session-info-sharing',[
	'fastx.Share',
	'fastx.command-module',
	'mm.foundation'
])
.factory('createUrl',[function(){
	return function(o){
		console.log(o)
		if(o){
			var uri = btoa(JSON.stringify(o));
			return [
				window.location.protocol,
				'//',
				window.location.hostname,
				':',
				window.location.port?(window.location.port):((window.location.protocol === 'http:')?80:443),
				'/share#',
				uri
			].join('');
		}
	}
}])
.controller('SharingMenuCtrl',['$scope','$rootScope','Share','createUrl',function($scope,$rootScope,Share,createUrl){

	$scope.getKeys = function(s){
		Share.list({id:s.id},function(d){
			$scope.sharingEnabled = Boolean(d.keys.length);

			$scope.shareUrl = createUrl(
				Object.assign({id:s.id}, (d.keys.find(function(c){return c.perms.indexOf('viewer') >=0;})||{}) )
			);
			$scope.grantUrl = createUrl(
				Object.assign({id:s.id}, (d.keys.find(function(c){return c.perms.indexOf('granter') >=0;})||{}) )
			);
		});
	}
	$scope.toggleSharing = function(n,s){
		if(n){
			Share.update({id:s.id,perms:['viewer']},function(d){
				console.log(s,d);
				$scope.shareUrl = createUrl(
					Object.assign({id:s.id},
						d.keys.find(function(c){return c.perms.indexOf('viewer') >=0;})  ||{}));
			},function(e){
				console.log(s,e)
			});
			Share.update({id:s.id,perms:['granter']},function(d){
				$scope.grantUrl = createUrl(
					Object.assign({id:s.id},
						d.keys.find(function(c){return c.perms.indexOf('granter') >=0;})||{} ) );
			},function(e){
				console.log(e)
			});
		}else{
			Share.reset({id:s.id});
			$scope.shareUrl = null;
			$scope.grantUrl = null;
			$scope.sharingEnabled = false;
		}
	}
}]);
