'use strict';
import angular from "angular";

import "../../../common/collection";
import "../../../common/command-module";
import "../../../common/utils";
import "../start/start";
import "../session";

export default angular.module('fastx.mySessions',[
	'fastx.session',
	'fastx.start-session',
	'fastx.command-module',
	'fastx.utils',
	'fastx.Collection'
])
.factory('Sessions',['Collection','CommandModule','WsList','$timeout','SessionImages',

		 function(Collection,CommandModule,WsList,$timeout,imgs){
	var Sessions = new Collection();

	Sessions.screenshot = function(s){
		screenshot(s.id,false);
	}

	function screenshot(id,all){
		if(!id){return;}
		var s = Sessions.get(id);
		s.img = s.img || {src:'js/fastx/session/img/image.png'};
		CommandModule.screenshot({id:id,width:'320',height:'240',keep_aspect:"1"},function(d){
			d.lastUpdated = Date.now();
			s.img = d;
			if(all){
				screenshot(imgs.ids.shift(),all);
			}
		},function(e){
			if(all){
				screenshot(imgs.ids.shift(),all);
			}
		});
	}
	WsList.create('api/list',function(d){
		if(!d.data){
			Sessions.remove(d.id);
		}else{
			if(Sessions.get(d.id)){
				Sessions.update(d.id,d.data);
			}else{
				Sessions.update(d.id,d.data);
			}
		}
	});

	var list = function(){
		CommandModule.list(function(s){
			Sessions.set(s);
			s.forEach(function(c,i,a){
				if(!imgs.ids.find(function(i){
					return c.id === i;
				})){
					imgs.ids.push(c.id);
				}
			});
			screenshot(imgs.ids.shift(),true);
		},function(e){
			console.log(e,window.localStorage['token'],document.cookie);
		});
	}

	var refresh = function(){
		$timeout(function(){
			list();
			refresh();
		},30000);
	}
	list();
	refresh();
	return Sessions;
}])
.controller('MySessionsCtrl', ['$scope','$controller','Sessions','$rootScope','$window','$location',
			function($scope,$controller,Sessions,$rootScope,$window,$location) {
	$controller('SessionActionCtrl', {$scope: $scope});
	$scope.sessions = Sessions;
	$scope.testSelectAll = function(){
		Sessions.selectAllFlag = Sessions.all;
	}
	$scope.layouts = ['grid','list'];
	$scope.initLayout = function(){
		return $location.search().layout || $window.localStorage['sessionView'] || (
		$rootScope.config && $rootScope.config.screenshot?'grid':'list') || $scope.layouts[0];
	}
}])
