'use strict';

import angular from "angular";

import "../../common/filters";
import "../../common/directives";
import "./start/start";
import "./terminate/terminate";
import "./table/session-table";
import "./info/session-info";

import "../../lib/angular-foundation.min";

export default angular.module('fastx.session', [
	//'fastx.start-session',
	'fastx.session-table',
	'fastx.session-info',
	'fastx.command-module',
	'fastx.utils',
	'fastx.Filters',
	'mm.foundation',
	'fastx.Directives'])
.run([function(){

}])
.factory('SessionImages',[function(){
	var imgs = [];
	var f = {};
	Object.defineProperty(f,'ids',{
		get:function(){return imgs;}
	});
	return f;

}])
.controller('SessionLayoutCtrl',['$scope','$rootScope','$location','$window',function($scope,$rootScope,$location,$window){

	$scope.$watch('layout',function(n,o){
		if(!n){
			n = ($rootScope.config && $rootScope.config.screenshot)?'grid':'list';
		}
		$window.localStorage['sessionView'] = n;

	});
	$scope.setLayout = function(n){
		$scope.layout = n ;
		if( n !== 'grid'){
			$location.search('layout',n);
		}else{
			$location.search('layout',null);
		}
	}
}])
.factory('GoToSession',['$modal',function($modal){
	var popupBlockerChecker = {
        check: function(popup_window,error){
            var _scope = this;
            if (popup_window) {
                if(/chrome/.test(navigator.userAgent.toLowerCase())){
                    setTimeout(function () {
                        _scope._is_popup_blocked(_scope, popup_window,error);
                     },200);
                }else{
                    popup_window.onload = function () {
                        _scope._is_popup_blocked(_scope, popup_window);
                    };
                }
            }else{
                error();
            }
        },
        _is_popup_blocked: function(scope, popup_window){
            if ((popup_window.innerHeight > 0)==false){ error(); }
        }
    };
	function popupBlocked(id){
		var popupBlockedDlg = $modal.open({
			templateUrl:'js/fastx/session/session-popup-blocked-dialog.html',
			controller:'PopupBlockedDialogCtrl',
			resolve:{
				id:function(){return id;}
			},
		});
	}

	function goToSession(id){
		var popup = window.open('connect#' + id);
		popupBlockerChecker.check(popup,function(){popupBlocked(id);});
	}

	return goToSession;
}])
.controller('SessionActionCtrl',['$scope','GoToSession',
	function($scope,GoToSession){

	$scope.connect = function(id){
		GoToSession(id);
	}
}])
.controller('PopupBlockedDialogCtrl',['$scope','$modalInstance','$timeout','id',function($scope,$modalInstance,$timeout,id){
	$scope.id = id;
	//$scope.$parent.getSessions();
	$timeout(function(){
		$modalInstance.close();
	},5000);
}])

.controller('SessionImgCtrl',['$scope',function($scope){}])
