'use strict';
import angular from "angular";

import "../../../common/filters";
import "../terminate/terminate";
import "../../../common/utils";

import "../../../lib/angular-foundation.min";

export default angular.module('fastx.session-table',['mm.foundation',
	'fastx.utils',
	'fastx.session-terminate',
	'fastx.Filters'
])
.factory('SessionTableColumns',[function(){
	var columnMap ={
		"id":"Session Id",
		"display":"DISPLAY",
		"appPid":"Process Id",
	}

	var columns ={};

	var keyTitle = function(i){
		return i.charAt(0).toUpperCase() + i.slice(1).split(/([A-Z]+[^A-Z]*)/).join(" ");
	}
	var  mapColumn = function(c){
		return (columnMap[c])?columnMap[c]:keyTitle(c);
	}
	var o ={
		keyTitle:keyTitle,
		mapColumn:mapColumn
	};
	Object.defineProperty(o,'columns',{
		get:function(){return Object.keys(columns).filter(function(c){return columns[c];});}
	});

	return o;
}])

.controller('SessionListHeaderCtrl',['$scope','$modal',function($scope,$modal){
	$scope.sessionColumnsDialog = function(){
		var mi = $modal.open({
			templateUrl:'js/fastx/session/table/columns-dialog.html',
			controller:'SessionTableColumnsDialogCtrl',
		});
		mi.result.then(function(){},function(){

		});

	}
}])
.controller('SessionTableColumnsDialogCtrl',['$scope',function($scope){
	$scope.columns ={};

}])
.controller('SessionTableCtrl',['$scope','SiteUtils','$rootScope',
			function($scope,SiteUtils,$rootScope){
	//$scope.sort.searchFilter = SiteUtils.getQueryVariable('searchFilter');
}])
.controller('SessionRowHeaderCtrl',['$scope',function($scope){
	$scope.orderByName = function(session){
		return  ((session.data.params && session.data.params.name)?session.data.params.name:session.data.command).toLowerCase();
	};
}])
.controller('SessionRowCtrl',['$scope',function($scope){
	$scope.elapsed = function(t){
		return Date.now() - Date.parse(t);
	}
	$scope.showLastDisconnected = function(lastDisconnect){
		var e = $scope.elapsed(lastDisconnect);
		return (e < 120000);
	}
}])
