'use strict';

import angular from "angular";

import "../../../common/command-module";

import "../../../lib/angular-foundation.min";

export default angular.module('fastx.session-terminate',['mm.foundation',
'fastx.command-module'
])
.controller('SessionTerminateCtrl',['$scope','$modal','CommandModule',function($scope,$modal,CommandModule){
	$scope.terminateDlg = function(sessions){
		sessions = (Array.isArray(sessions))?sessions:[sessions];
		var mi = $modal.open({
			templateUrl:'js/fastx/session/terminate/dialog.html',
			controller:'TerminateSessionDialogCtrl',
			size:'tiny',
			resolve:{
				sessions:function(){
					return sessions;
				}
			}
		});
		mi.result.then(function(){
			sessions.forEach(function(s){
				CommandModule.terminate({id:s.data.id});
			});
		},function(o){/*cancelled*/});
	}
}])
.controller('TerminateSessionDialogCtrl',['$scope','$modalInstance','sessions',function($scope,$mi,sessions){
	$scope.sessions = sessions;
}]);
