'use strict';
import angular from "angular";

import "../../common/Api";
import "../../common/Token";

export default angular.module('fastx.Bookmark',['fastx.Api','Token'])
.factory('Bookmark',['Api','Token',function(Api,Token){
	var b = {};
	b.list = function(success,error){
		Api.get('api/bookmark',{},success,error);
	};
	b.delete = function(o,success,error){
		Api.post('api/bookmark/delete',{},o,success,error);
	};
	b.edit = function(o,success,error){
		Api.post('api/bookmark/edit',{},o,success,error);
	};
	return b;
}])
.controller('BookmarkDialogCtrl',['$scope','$modalInstance','Bookmark',function($scope,$modalInstance,Bookmark){
		(function listBookmarks(){
			Bookmark.list(function(data){
				$scope.bookmarks = data;
			},function(e){
				$scope.bookmarks = {};
				$scope.error = e.error;
			});
		})();

		$scope.params = {
			name:' ',
			command:' ',
			id:' '
		};
		$scope.newBookmark ={
			name:'',
			command:''
		};
		$scope.cancel = function(){
			$modalInstance.close();
			$scope.error ={};
		}
		$scope.editBookmarkForm;
		$scope.showNew = false;
		$scope.$watch('showNew',function(newValue,oldValue){
			if(newValue){
				$scope.newBookmark ={
					name:'',
					command:''
				};
			}
		});

		$scope.showNewForm = function(bool){
			$scope.showNew = bool;
		}

		$scope.submitNewBookmark = function(b){
			if(!b.command){
				return;
			}
			Bookmark.edit({
				name:b.name,
				command:b.command
			},function(data){
				$scope.bookmarks = data;
				$scope.showNew = false;
			},function(e){
				$scope.alert = {type:'alert',msg:e.error.message,close:function(){delete $scope.alert;}};
			});
		};
		$scope.setParams = function(o){
			$scope.params.name = o.name;
			$scope.params.command = o.command;
			$scope.params.id = o.id;
		};

		$scope.editBookmark = function(o){
				delete o.visible;
				Bookmark.edit(o,function(data){
					$scope.bookmarks = data;
				},function(e){
					$scope.alert = {type:'alert',msg:e.error.message,close:function(){delete $scope.alert;}};
				});
		};

		$scope.deleteBookmark = function(id){
			Bookmark.delete({id:id},function(data){
				$scope.bookmarks = data;
			},function(e){
				$scope.alert = {type:'alert',msg:e.error.message,close:function(){delete $scope.alert;}};
			});
		};
}]);
