'use strict';
import angular from "angular";

import "ng-tags-input";

import "../../common/Api";
import "../../common/Token";

export default angular.module('System.Admin',['fastx.Api','Token','ngTagsInput'])
.factory('System.Admin',['Api','Token',function(Api,Token){
	var a = {};
	a.addAdmin = function(o,success,error){
		Api.post('system/admin/add',{},o,success,error);
	}
	a.deleteAdmin = function(o,success,error){
		Api.post('system/admin/delete',{},o,success,error);
	}
	a.getAdmins = function(success,error){
		Api.get('system/admin',{},success,error);
	}
	a.setAdmins = function(o,success,error){
		Api.post('system/admin',{},o,success,error);
	}
	return a;
}])
.factory('array_unique',[function(){
	function array_unique(arr) {
		var result = [];
		for (var i = 0; i < arr.length; i++) {
			if (result.indexOf(arr[i]) == -1) {
				result.push(arr[i]);
			}
		}
		return result;
	}
	return array_unique;
}])
.controller('SystemAdminCtrl',['$scope','System.Admin',function($scope,Admin){
	($scope.getAdmins = function(){
		Admin.getAdmins(function(a){
			var u = [],g=[];
			a.users.forEach(function(c){
				if(c && u.indexOf(c) < 0){
					u.push(c);
				}
			});
			a.groups.forEach(function(c){
				if(c && g.indexOf(c) < 0){
					g.push(c);
				}
			});
			$scope.admins = {users:u,groups:g};
		},function(e){
			$scope.alert ={type:'alert',msg: e.error.message};
		});
	})();
	$scope.setAdmins = function(o){
		o.users = o.users.map(function(c){
			return c.text;
		});

		o.groups = o.groups.map(function(c){
			return c.text;
		});
		Admin.setAdmins(o,function(d){
			$scope.alert = {type:'success',msg:'Changes Saved Successfully',close:function(){delete $scope.alert;}};
		},function(e){
			$scope.alert ={type:'alert',msg: e.error.message,close:function(){delete $scope.alert;}};
		});
	}
	$scope.removeTag = function($tag,username){
		return $tag.text !== username;
	}
}])
.controller('AdminUserCtrl',['$scope','array_unique',function($scope,array_unique){
	$scope.addUser = function(admins){
		if(!admins.users){admins.users = [];}
		admins.users.push('');
		admins.users = array_unique(admins.users);
	}
	$scope.deleteUser = function(a,admins){
		var i = admins.users.indexOf(a);
		if(i >=0){admins.users.splice(i,1);}
	}
}])
.controller('AdminGroupCtrl',['$scope','array_unique',function($scope,array_unique){
	$scope.addGroup = function(admins){
		if(!admins.groups){admins.groups = [];}
		admins.groups.push('');
		admins.groups = array_unique(admins.groups);
	}
	$scope.deleteGroup = function(a,admins){
		var i = admins.groups.indexOf(a);
		if(i >=0){admins.groups.splice(i,1);}
	}
}])
