'use strict';

import angular from "angular";
import "angular-route";

import "../lib/angular-foundation.min";

import "../fastx/components/nav";

import "./dashboard/dashboard";
import "./auth-methods/auth-methods"
import "./admin/admin";
import "./network/network";
import "./system-config/system-config.js";
import "./www/network-www.js";
import "./fastx-defaults/fastx-defaults.js";
import "./email/email.js";
import "./theme/theme.js";
import "./upload/upload.js";
import "./bookmark/bookmark.js";
import "./profile/session.js";
import "./profile/profile.js";
import "./command/command.js";
import "./motd/motd.js";
import "./log/log.js";
import "./license/license.js";
import "./ldap/ldap.js";
import "./auth-methods/auth-methods.js";


export default angular.module('fastx.system', ['mm.foundation','ngRoute',
	'Admin',
	'System.Theme',
	'System.Network',
	'System.Admin',
	'System.Bookmark',
	'System.Command',
	'System.NetworkSettings',
	'System.WWW',
	'System.FastXDefaults',
	'System.Motd',
	'System.Email',
	'System.Profile',
	'System.License',
	'System.Ldap',
	'System.AuthMethods',,
	'System.Upload',
	'fastx.adminSession',
	'fastx.adminServer',
	'fastx.dashboard',,
	'fastx.SystemLog'
	])
.controller('SystemCtrl',['$scope','$location','Admin',function($scope,$location,Admin){
	$scope.nav = $location.search().nav || 'sessions';
	$scope.$on('$locationChangeStart', function(event, newUrl, oldUrl) {
		$scope.nav = $location.search().nav || 'sessions';
	});
	$scope.view = function(v,filter){
		$scope.nav = v || 'sessions';

		$location.search('nav',v);
		$location.search('filter',filter);
	}

	$scope.navs =  {
		//"dashboard":"Dashboard",
		"sessions":"Sessions",
		"servers":"Servers",
		"settings":"Configuration",
		"www":"Http",
		"network":"Clustering",
		"theme":"Themes",
		"profile":"Profiles",
		"bookmark":"Bookmarks",
		"command":"Commands",
		"fastx-defaults":"Client Settings",
		"auth-methods":"Authentication",
		"admins":"Administrators",
		"motd":"Message of the Day",
		"log":"System Log",
		"upload":"Uploads",
		"license":"Licenses"
	}

	$scope.menu = function(nav,type){
		switch(nav){
			case "settings":
			case "www":
			case "network":
			case "theme":
			case "profile":
			case "bookmark":
			case "command":
			case "fastx-defaults":
			case "auth-methods":
			case "admins":
			case "motd":
				return "configuration";
			case "log":
			case "license":
			case "upload":
				return "tools";
			case "sessions":
			case "servers":
			default:
		}
	}
}])

.controller('ConfigAlertDialogCtrl',['$scope','$modalInstance','$window',function($scope,$modalInstance,$window){
	$scope.close = function(dontShow){
		$modalInstance.close();
		if(dontShow){
			$window.localStorage['hideSystemConfigAlertDialog'] = true;
		}
	}
}])
.filter('ucfirst', function() {
	return function(input,arg) {
		if(typeof input === 'string'){
			return input.replace(/(?:^|\s)\S/g, function(a) { return a.toUpperCase(); });
		}
	};
})
.filter('prettyJSON', function () {
    function syntaxHighlight(json) {
      return JSON ? JSON.stringify(json, null, '  ') : 'your browser doesnt support JSON so cant pretty print';
    }
    return syntaxHighlight;
})
.directive('ngVisible', function () {
    return function (scope, element, attr) {
        scope.$watch(attr.ngVisible, function (visible) {
            element.css('visibility', visible ? 'visible' : 'hidden');
        });
    };
});
angular.bootstrap(document.getElementById('system'),['fastx.system']);
