'use strict';
import angular from "angular";

import "ngclipboard";

import "../../lib/angular-foundation.min";

import "../../common/utils";

import "../../common/Api";
import "../../common/Token";


export default angular.module('System.Bookmark',['fastx.Api','Token',
'fastx.utils','mm.foundation','ngclipboard'])
.run([function(){

}])
.factory('System.Bookmark',['Api','Token',function(Api,Token){
	var b = {};
	b.getBookmarks = function(success,error){
		Api.get('system/bookmark',{},success,error);
	}
	b.setBookmarks = function(o,success,error){
		Api.post('system/bookmark',{},o,success,error);
	}
	b.deleteBookmark = function(o,success,error){
		Api.post('system/bookmark/delete',{},o,success,error);
	}
	b.editBookmark = function(o,success,error){
		Api.post('system/bookmark/edit',{},o,success,error);
	}
	b.getProfiles = function(success,error){
		Api.get('api/session/profile',{},success,error);
	}
	return b;
}])
.controller('BookmarkDeleteDialogCtrl',['$scope','bookmarks',function($scope,bookmarks){
	$scope.bookmarks = bookmarks;
}])
.controller('BookmarkEditDialogCtrl',['$scope','$modalInstance','bookmark','System.Bookmark',function($scope,$mi,bookmark,Bookmark){
	$scope.b = bookmark;
	if(!$scope.b.hasOwnProperty('startParams')){
			$scope.b.startParams = {};
	}
	$scope.startParams = [];
	for(var k in $scope.b.startParams){
		$scope.startParams.push({k:k,v:$scope.b.startParams[k]});
	}
	$scope.profiles = [];
	Bookmark.getProfiles(function(p){
		$scope.profiles = p;
	});
	$scope.windowMode = function(b){
		if(b.windowMode){
			b.geometry = '';
		}else if(b.windowMode === 'rootless'){
			b.geometry = 'rootless';
		}
	}
	$scope.addStartParam = function(b){
		$scope.startParams.push({k:"",v:""});
	}
	$scope.file_changed = function(element,i) {
		$scope.$apply(function(scope) {
			var file = element.files[0];
			var reader = new FileReader();
			reader.onload = function() {
				$scope.$apply(function(s){
					document.getElementById('bookmark-edit-icon').src =  reader.result;
					$scope.b.icon = reader.result;
				});

			};
			if(file){
				reader.readAsDataURL(file);
			}
		});
		};
	$scope.close = function(b){
		if(b.windowMode === 'rootless'){ b.geometry = 'rootless'; }
		$mi.close(b);
	}
}])
.controller('SystemBookmarkShortcutCtrl',['$scope','$window',function($scope,$window) {
	$scope.getShortcutLink = function (id) {
		return [$window.location.protocol,'//',$window.location.host,'/shortcut#',id].join('')
	}
	$scope.onSuccess = function (s) {

	}
}])
.controller('SystemBookmarkCtrl',['$scope','System.Bookmark','RandomString','$modal',
			function($scope,Bookmark,RandomString,$modal){
	$scope.tags =[];

	$scope.remove = function (b){
		var mi = $modal.open({
			templateUrl:'js/system/bookmark/delete.html',
			controller:'BookmarkDeleteDialogCtrl',
			size:'tiny',
			resolve:{
				bookmarks:function(){return [b];}
			}
		});

		mi.result.then(function(nb){
			Bookmark.deleteBookmark({
				id:b.id
			},set,function(e){
				$scope.alert ={type:'alert',msg: e.error.message,close:function(){delete $scope.alert;}};
			});
		},function(e){});
	}
	$scope.add = function(){
		var b = {
			icon: 'img/suggestion.png',
			id: RandomString(32),
			windowMode: '',
			tags: []
		};
		$scope.edit (b);

	}
	$scope.edit = function(b){
		var mi = $modal.open({
			templateUrl:'js/system/bookmark/edit.html',
			controller:'BookmarkEditDialogCtrl',
			resolve:{
				bookmark:function(){
					return b;
				},
				tags:function(){
					return $scope.tags.map(function(c) {
						return (typeof c === 'string')?c:c.text;
					});
				}
			}
		});
		mi.result.then(function(b){
			b.tags = (b.tags || []).map(function (c) {
				return (typeof c === 'string')?c:c.text;
			});
			Bookmark.editBookmark(b,set,function(e){
				$scope.alert ={type:'alert',msg: e.error.message,close:function(){delete $scope.alert;}};
			});
		},function(){});
	}

	$scope.getShortcut = function (b) {
		return ""
	}


	function set(b){
		b.forEach(function(c,i,a){
			if(c.geometry === 'rootless'){
				c.windowMode ='rootless';
				c.geometry ='';
			}
		});
		$scope.bookmarks = b;
		$scope.tags = b.map (function (c) {
			return (c.tags || []).map (function (a) {
				return (typeof a === 'string') ? a : a.text;
			});
		});
		if ($scope.tags.length) {
			$scope.tags = $scope.tags.reduce (function (a,b) {
				return a.concat(b);
			}).filter (function (value, index, self) {
  			return self.indexOf (value) === index;
			});
		}
	}
	$scope.setBookmarks = function(o){
		o.forEach(function(c,i,a){
			if(c.windowMode === 'rootless'){
				c.geometry = 'rootless';
			}
			delete c.windowMode;
		});
		Bookmark.setBookmarks(o,function(b){
			$scope.alert = {type:'success',msg:'Bookmarks saved successfully',close:function(){delete $scope.alert;}};
			set(b);
		},function(e){
			$scope.alert ={type:'alert',msg: e.error.message,close:function(){delete $scope.alert;}};
			$scope.refresh();
		});
	}
	$scope.refresh = function(){
		Bookmark.getBookmarks(set,function(e){
			$scope.error = e.error;
		});
	};
	$scope.refresh();
}]);
