'use strict';
import angular from "angular";

import "../../lib/angular-foundation.min";

import "../profile/profile";

import "../../common/Api";
import "../../common/Token";

export default angular.module('System.Command',[
	'fastx.Api',
	'Token',
	'System.Profile',
	'mm.foundation'])
.factory('Command',['Api','Token',function(Api,Token){
	var t = {};
	t.get= function(success,error){
		Api.get('system/command',{},success,error);
	}
	t.set = function(o,success,error){
		Api.post('system/command',{},o,success,error);
	}
	return t;
}])
.controller('CommandCtrl',['$scope','Command','$modal',function($scope,Command,$modal){




	Command.get(function(c){
		$scope.commands = c;
		$scope.restrict = c.hasOwnProperty('allow');
	},function(e){
		$scope.alert ={type:'alert',msg: e.error.message,close:function(){delete $scope.alert;}};
	});
	$scope.restrictCommand = function(r){
		console.log(r);
		Command.set(r?{allow:[]}:{},function(d){
			$scope.commands = d;
		},function(e){
			$scope.alert ={type:'alert',msg: e.error.message,close:function(){delete $scope.alert;}};
		});
	}
	$scope.newCommand = function(){
		$scope.editCommand({
			regex:''
		},function(){},function(e){
			$scope.alert ={type:'alert',msg: e.error.message,close:function(){delete $scope.alert;}};
		});
	}
	$scope.editCommand = function(c,$index){
		if(typeof c === 'string'){
			c = {regex:c};
		}
		var $mi = $modal.open({
			templateUrl:'js/system/command/edit.html',
			controller:'CommandDialogCtrl',
			resolve:{
				cmd:function(){
					return c;
				}
			}
		});
		$mi.result.then(function(d){
			if(typeof $index === 'number'){
				$scope.commands.allow[$index] = d;
			}else{
				$scope.commands.allow.push(d);
			}
			Command.set($scope.commands,function(c){
				$scope.commands = c;
			},function(e){
				$scope.alert ={type:'alert',msg: e.error.message,close:function(){delete $scope.alert;}};
			});
		},function(){});
	}
	$scope.deleteCommand = function($index){
		var $mi = $modal.open({
			templateUrl:'js/system/command/delete.html',
			controller:'CommandDeleteDialogCtrl',
			size:'tiny',
			resolve:{
				cmds:function(){
					return [$scope.commands.allow[$index]];
				}
			}
		});
		$mi.result.then(function(d){
			$scope.commands.allow.splice($index,1);
			Command.set($scope.commands,function(c){
				$scope.commands = c;
			},function(e){
				$scope.alert ={type:'alert',msg: e.error.message,close:function(){delete $scope.alert;}};
			});
		},function(){});
	}
}])
.controller('CommandDialogCtrl',['$scope','System.Profile','cmd',function($scope,Profile,cmd){
	$scope.cmd = cmd;
	Profile.getUserData(function(p){
		$scope.profiles = p;
	},function(e){
		$scope.alert ={type:'alert',msg: e.error.message,close:function(){delete $scope.alert;}};
	});
}])
.controller('CommandDeleteDialogCtrl',['$scope','cmds',function($scope,cmds){
	$scope.cmds = cmds;
}])
.controller('AllowCtrl',['$scope',function($scope){

}]);
