'use strict';
import angular from "angular";

import "../../../lib/angular-foundation.min";

import "../../../common/collection";
import "./admin";

// Declare app level module which depends on views, and components
export default angular.module('fastx.adminServer', ['fastx.Collection',
  'Admin',
  'mm.foundation'
]).
run(['$rootScope',function($rootScope){
	$rootScope.isAdmin = true;
	if (typeof Object.assign != 'function') {
		Object.assign = function(target) {
			'use strict';
			if (target == null) {
			throw new TypeError('Cannot convert undefined or null to object');
			}

			target = Object(target);
			for (var index = 1; index < arguments.length; index++) {
			var source = arguments[index];
			if (source != null) {
				for (var key in source) {
				if (Object.prototype.hasOwnProperty.call(source, key)) {
					target[key] = source[key];
				}
				}
			}
			}
			return target;
		};
	}
	if (!Array.prototype.findIndex) {
		Array.prototype.findIndex = function(predicate) {
			if (this === null) {
			throw new TypeError('Array.prototype.findIndex called on null or undefined');
			}
			if (typeof predicate !== 'function') {
			throw new TypeError('predicate must be a function');
			}
			var list = Object(this);
			var length = list.length >>> 0;
			var thisArg = arguments[1];
			var value;

			for (var i = 0; i < length; i++) {
			value = list[i];
			if (predicate.call(thisArg, value, i, list)) {
				return i;
			}
			}
			return -1;
		};
	}
}])
.factory('AdminServers',['Collection','Admin','WsList','$timeout',function(Collection,Admin,WsList,$timeout){
	var Servers = new Collection();
	WsList.create('api/admin/server',function(d){
		if(!d.data){
			Servers.remove(d.id);
		}else{
			if(Servers.get(d.id)){
				Servers.update(d.id,d.data);
			}else{
				Servers.update(d.id,d.data);
			}
		}
	});

	var list = function(){
		Admin.server({},function(s){
			Servers.set(s)
		},function(e){
			console.log(e,window.localStorage['token'],document.cookie);
		});
	}

	var refresh = function(){
		$timeout(function(){
			list();
			refresh();
		},30000);
	}
	list();
	refresh();
	return Servers;
}])
.controller('AdminServerCtrl',['$scope','AdminServers','$location',function($scope,AdminServers,$location){
	$scope.AdminCtrl = true;

	$scope.servers = AdminServers;
	$scope.servers.sort.type ='id';
	
}])
angular.bootstrap(document.getElementById('admin-server'),['fastx.adminServer']);
