'use strict';

import angular from "angular";

import "../../../common/collection";
import "../../../fastx/session/session";

import "../../../common/Token";

// Declare app level module which depends on views, and components
export default angular.module('fastx.adminSession', ['fastx.session','fastx.Api','fastx.Collection'
])
.factory('AdminSessions',['Collection','CommandModule','WsList','$timeout','Api',
		 function(Collection,CommandModule,WsList,$timeout,Api){
	var Sessions = new Collection();

	Sessions.screenshot = function(s){
		screenshot(s.id,false);
	}

	function screenshot(id,all){
		if(!id){return;}
		var s = Sessions.get(id);
		s.img = s.img || {src:'js/fastx/session/img/image.png'};
		CommandModule.screenshot({id:id,width:'320',height:'240',keep_aspect:"1"},function(d){
			d.lastUpdated = Date.now();
			s.img = d;
			if(all){
				screenshot(imgs.ids.shift(),all);
			}
		},function(e){
			if(all){
				screenshot(imgs.ids.shift(),all);
			}
		});
	}

	WsList.create('api/admin/session',function(d){
		if(!d.data){
			Sessions.remove(d.id);
		}else{
			if(Sessions.get(d.id)){
				Sessions.update(d.id,d.data);
			}else{
				Sessions.update(d.id,d.data);
			}
		}
	});

	var list = function(){
		Api.get('api/admin/session',{},function(s){
			Sessions.set(s)
		},function(e){
			console.log(e,window.localStorage['token'],document.cookie);
		});
	}

	var refresh = function(){
		$timeout(function(){
			list();
			refresh();
		},30000);
	}
	list();
	refresh();
	return Sessions;
}])
.controller('AdminSessionCtrl',['$scope','$controller','AdminSessions','$location',
			function($scope,$controller,AdminSessions,$location){
	$controller('SessionActionCtrl', {$scope: $scope}); //This works
	$scope.sessions = AdminSessions;
	$scope.layouts = ['list'];
	$scope.initLayout = function(){return 'list'}
	$scope.sessions.selectAll(false);
	$scope.sessions.sort.filter = $location.search().filter;
}]);
angular.bootstrap(document.getElementById('admin-session'),['fastx.adminSession']);
