'use strict';
import angular from "angular";

import "../../lib/angular-foundation.min";

import "../../common/Api";
import "../../common/Token";
import "../../common/utils";

export default angular.module('System.FastXDefaults',[
	'fastx.Api',
	'Token',
	'mm.foundation',
	'fastx.utils'
])
.factory('FastXDefaults',['Api','Token',function(Api,Token){
	var t = {};
	t.get = function(success,error){
		Api.get('system/fastx-defaults',{},success,error);
	}
	t.set = function(o,success,error){
		Api.post('system/fastx-defaults',{},o,success,error);
	}
	return t;
}])
.controller('FastXDefaultsEditDialogCtrl',['$scope','cfg','$modalInstance',function($scope,cfg,$mi){
	$scope.cfg = cfg;
}])
.controller('FastXDefaultsCtrl',['FastXDefaults','$window','$scope','$modal','RandomString',
			function(FastXDefaults,$window,$scope,$modal,RandomString){
	FastXDefaults.get(function(o){
		if(!o.MouseQuantum){o.MouseQuantum = 50;}
		$scope.cfg = o;
	},function(e){
		$scope.cfg = [{

		}];
		$scope.alert ={type:'alert',msg: e.error.message,close:function(){delete $scope.alert;}};
	});

	$scope.add = function(){
		$scope.edit();
	}
	$scope.edit = function(i){
		var c;
		if(typeof i !== 'number'){
			c = {};
		}else{
			c= $scope.cfg[i];
		}
		var mi = $modal.open({
			controller:'FastXDefaultsEditDialogCtrl',
			templateUrl:'js/system/fastx-defaults/defaults.html',
			resolve:{
				cfg:function(){return Object.assign({
					name:'',
					description:'',
					"Compression":0,
					"FrameAcknowledgeWindow":30,
					"FPSLimit":30,
					"MouseQuantum":1,
					"id":RandomString(32)
					},c);
				}
			}
		});
		mi.result.then(function(cfg){
			if(typeof i !== 'number'){
				$scope.cfg.push(cfg);
			}else{
				$scope.cfg[i] = cfg;
			}
			$scope.submit($scope.cfg);
		},function(){

		});
	}
	$scope.clone = function(i){
		$scope.cfg.push(Object.assign({},$scope.cfg[i]));
		delete $scope.cfg[$scope.cfg.length -1].id;
		$scope.edit($scope.cfg.length -1);
	}
	$scope.remove = function(cfgs){
		if(!Array.isArray(cfgs)){
			cfgs = [cfgs];
		}
		var mi = $modal.open({
			controller:'FastXDefaultsDeleteDialogCtrl',
			templateUrl:'js/system/fastx-defaults/delete.html',
			size:'tiny',
			resolve:{
				cfgs:function(){return cfgs;}
			}
		});
		mi.result.then(function(){
			$scope.submit($scope.cfg.filter(function(c){
					return cfgs.find(function(i){return i.id !== c.id;});
				}));
		},function(){});
	}
	$scope.submit = function(config){
		FastXDefaults.set(config,function(c){
			//$scope.alert ={type:'success',msg:'Changes Saved Successfully',close:function(){delete $scope.alert;}};
			$scope.cfg = c;
		},function(e){
			$scope.alert ={type:'alert',msg: e.error.message,close:function(){delete $scope.alert;}};
		});
	};
}])
.controller('FastXDefaultsDeleteDialogCtrl',['$scope','cfgs',function($scope,cfgs){
	$scope.cfgs = cfgs;
}])
.directive('stringToInt', function() {
  return {
    require: 'ngModel',
    link: function(scope, element, attrs, ngModel) {
      ngModel.$parsers.push(function(value) {
        return '' + value;
      });
      ngModel.$formatters.push(function(value) {
        return parseInt(value, 10);
      });
    }
  }
});
