'use strict';
import angular from "angular";
import "../../lib/angular-foundation.min";

import "../../common/Api";


export default angular.module('System.License',['fastx.Api','mm.foundation'])
.factory('License',['Api',function(Api){
	var l = {};
	l.get = function(success,error){
		Api.get('system/license',{},success,error);
	}
	l.reread = function(success,error){
		Api.get('system/license/reread',{},success,error);
	}
	l.getFiles = function(success,error){
		Api.get('system/license/file',{},success,error);
	}
	l.getFiles = function(success,error){
		Api.get('system/license/file',{},success,error);
	}
	l.postFile = function(filename,o,success,error){
		Api.post('system/license/file/:filename',{
			filename:filename
		},o || {},success,error);
	}
	l.removeFile = function(o,success,error){
		Api.remove('system/license/file/:filename',o,success,error);
	}
	return l;
}])
.controller('LicenseCtrl',['$scope','License','$modal','$q',function($scope,License,$modal,$q){
	License.get(function(l){
		$scope.license = l;
	},function (e) {
		console.log (e.error);
	});
	License.getFiles(function(l){
		$scope.licenseFiles = l;
	});
	$scope.viewLicense = function(l){
		var mi = $modal.open({
			controller:'ViewLicenseDialogCtrl',
			templateUrl:'js/system/license/view-license-dialog.html',
			size:'small',
			resolve:{
				l:function(){return l;}
			}
		});
		mi.result.then(function(){

		},function(){

		});
	}
	$scope.reread = function(){
		License.reread(function(l){
			$scope.license = l;
		},function(e){
			$scope.alert = {type:'alert',msg:e.error.message,close:function(){delete $scope.alert;}};
		});
	}
	$scope.newLicense = function(){
		var mi = $modal.open({
			controller:'NewLicenseDialogCtrl',
			templateUrl:'js/system/license/new-license-dialog.html',
			resolve:{
				license:function(){return $scope.license;}
			}
		});
		mi.result.then(function(lic){
			License.postFile(lic.filename,{content:lic.content},function(l){
				$scope.licenseFiles = l;
				License.reread(function(l){
					$scope.license = l;
				},function(e){
					$scope.alert = {type:'alert',msg:e.error.message,close:function(){delete $scope.alert;}};
				});
			});
		},function(e){});
	}
	$scope.removeLicenseFile = function(f){
		var mi = $modal.open({
			controller:'RemoveLicenseDialogCtrl',
			templateUrl:'js/system/license/remove-license-dialog.html',
			resolve:{
				files:function(){return Array.isArray(f)?f:[f];}
			}
		});
		mi.result.then(function(files){
			var f;
			var promises = [];
			while(f = files.shift()){
				promises.push($q.defer());
				License.removeFile({filename:f.name},function(){
					promises[promises.length -1].resolve({});
				},function(e){
					promises[promises.length -1].reject(e);
				});
			}
			$q.all(promises).then(function(){
				License.getFiles(function(l){
					$scope.licenseFiles = l;
				},function(e){
					$scope.alert = {type:'alert',msg:e.error.message,close:function(){delete $scope.alert;}};
				});
			},function(e){
				$scope.alert = {type:'alert',msg:e.error.message,close:function(){delete $scope.alert;}};
			});
		},function(){});
	}
}])
.controller('RemoveLicenseDialogCtrl',['$scope','files','$sce',function($scope,files,$sce){
	$scope.files = files;
	$scope.fileLengthText = files.length >1?"these license files":"this license file";
}])
.controller('ViewLicenseDialogCtrl',['$scope','l',function($scope,l){
	$scope.l = l;
}])
.controller('NewLicenseDialogCtrl',['$scope','license',function($scope,license){
	$scope.license = license;
	$scope.lic = {
		opts:[]
	}
	if(license && license.hostids.length){
		$scope.lic.opts.push({v:'Activation Key',k:'akey'});
	}
	$scope.lic.opts.push({v:'License Server',k:'server'},{v:'License File',k:'file'});
	$scope.lic.type = $scope.lic.opts [0].k;
}])
.controller('AkeyCtrl',['$scope','$http','$sce','License',function($scope,$http,$sce,License){
	$scope.getCount = function(akey,hostid){
		$http.jsonp($sce.trustAsResourceUrl('https://license.starnet.com/activate/2.1'),{
			params:{
				akey:akey,
				lic_name:'FastX2',
				hostid:hostid
			}
		}).then(function(res){
			if(res.status !== 200){
				$scope.alert = {type:'alert',msg:'HTTP ERROR: ' + res.status,close:function(){delete $scope.alert;}};
				return;
			}
			if(res.data.error){
				$scope.alert = {type:'alert',msg:res.data.error.message || res.data.error.type,close:function(){delete $scope.alert;}};
				return;
			}if(!res.data.result.products){
				$scope.alert = {type:'alert',msg:'No products found',close:function(){delete $scope.alert;}};
				return;
			}

			if(res.data.result.filename){
				License.postFile(res.data.result.filename,{
					content:res.data.result.lic_file,
					nooverride:true
				});
			}

			var p = res.data.result.products.filter(function(c){
					return c.lic_name === 'FastX2';
			}).map (function (c) {
				var m = parseInt(c.count || 0, 10) - parseInt(c.used || 0, 10);
				return {
					maxCount: m,
					total: parseInt(c.count || 0, 10),
					count: m,
					used: parseInt(c.used || 0, 10)
				}
			});
			$scope.activate = Object.assign ($scope.activate, (p.length)? p[0] : {
				maxCount: 0,
				total: 0,
				count: 0,
				used: 0
			});
	});
}
}]).controller('ActivateLicenseCtrl',['$scope','$http','$sce','License',function($scope,$http,$sce,License){
	$scope.activateLicense = function(akey,hostid,count,cb){
		$http.jsonp($sce.trustAsResourceUrl('https://license.starnet.com/activate/2.1'),{
			params:{
				akey:akey,
				lic_name:'FastX2',
				hostid:hostid,
				count:count
			}
		}).then(function(res){
			if(res.status !== 200){
				console.log(res);
				return;
			}else{
				if(res.data.error){
					$scope.alert = {type:'alert',msg:res.data.error.message,close:function(){delete $scope.alert;}};
				}if(res.data){
					if(res.data.success){
						cb(res.data.success);
					}
				}
			}
		});
	}
}])
.controller('LicenseServerCtrl',['$scope','License','$filter',function($scope,License,$filter){
	$scope.licServer = function(serv,success,error){
		License.postFile( $filter('date')(Date.now(),'yyyy-MM-dd.lic'),{
			content:['HOST',serv.hostname,'00000000',serv.port].join(' ')
		},success,error);
	}
}])
.controller('LicenseFileCtrl',['$scope','License','$filter',function($scope,License,$filter){
	$scope.lic = {file:''};
	$scope.readFile = function(e,cb){
		$scope.$apply(function(scope) {
			var file = e.files[0];
			var reader = new FileReader();
			reader.onload = function() {
				License.postFile(file.name,{
					content:reader.result
				},cb,cb);
			};
			if(file){
				reader.readAsText(file);
			}
		});
	}
}]);
