'use strict';
import angular from "angular";

import "../../common/Api";
import "../../common/Token";

export default angular.module('System.Command',['fastx.Api','Token'])
.factory('Command',['Api','Token',function(Api,Token){
	var t = {};
	t.get= function(success,error){
		Api.get('/system/command',{token:Token.token},success,error);
	}
	t.set = function(o,success,error){
		Api.post('/system/command',{token:Token.token},o,success,error);
	}
	return t;
}])
.controller('CommandCtrl',['$scope','Command',function($scope,Command){
	Command.get(function(c){
		if(!c.allow){c.allow = []};
		if(!c.deny){c.deny = []};
		$scope.command = c;
	},function(e){
		$scope.error = e.error;
	});
	$scope.save = function(c){
		var a = [], d = [], i;
		if(c.allow){
			while(c.allow.length){
				i = c.allow.shift();
				if(i !== '' && a.indexOf(i) < 0){a.push(i);}
			}
			if(!a.length){
				delete c.allow;
			}else{
				c.allow = a;
			}
		}
		if(c.deny){
			while(c.deny.length){
				i = c.deny.shift();
				if(i !== '' && d.indexOf(i) < 0){d.push(i);}
			}
			if(!d.length){
				delete c.deny;
			}else{
				c.deny = d;
			}
		}
		Command.set(c,function(){
			$scope.command = c;
			$scope.message = 'Changes saved successfully';
			$scope.error = null;
		},function(e){
			$scope.message = null;
			$scope.error = e.error;
		});
	}

	$scope.addAllow = function(){
		if(!$scope.command){
			$scope.command ={};
		}
		if(!Array.isArray($scope.command.allow)){
			$scope.command.allow = [];
		}
		$scope.command.allow.push('');
	}
	$scope.addDeny = function(){
		if(!$scope.command){
			$scope.command ={};
		}
		if(!Array.isArray($scope.command.deny)){
			$scope.command.deny = [];
		}
		$scope.command.deny.push('');
	}
}])
.controller('AllowCtrl',['$scope',function($scope){

}])
.controller('DenyCtrl',['$scope',function($scope){

}])
;
