'use strict';
import angular from "angular";

import "../../common/Api";
import "../../common/Token";

export default angular.module('System.Session',['fastx.Api','Token'])
.factory('System.Session',['Api','Token',function(Api,Token){
	var s = {};
	s.getSession = function(success,error){
		Api.get('/system/session',{token:Token.token},success,error);
	}
	s.setSession = function(o,success,error){
		Api.post('/system/session',{token:Token.token},o,success,error);
	}
	return s;
}])
.controller('SystemSessionConfigCtrl',['$rootScope','$scope','System.Session', function($rootScope,$scope,Session){

	Session.getSession(function(s){
		$scope.session = s.session;
		$scope.session.videoRam = parseInt(s.session.videoRam,10);
		$scope.session.cpuPercentage = parseInt(s.session.cpuPercentage || 50,10);
		$scope.session.disconnectTimeout = parseInt(s.session.disconnectTimeout || 0,10);
		for(var i in $scope.session){
			if($scope.session[i] === 'off'){
				$scope.session[i] = false;
			}else if($scope.session[i] === 'on'){
				$scope.session[i] = true;
			}
		}
	},function(e){
		$scope.session = {
			"clipmgr":true,
			"sharing":true,
			"offlineSharing":false,
			"iglx":false,
			"listenTCP":false,
			"videoRam":0x20000,
			"cpuPercentage":50,
			"disconnectTimeout":0,
			"maxSessions":0,
		};
	});
}])
.directive('stringToInt', function() {
  return {
    require: 'ngModel',
    link: function(scope, element, attrs, ngModel) {
      ngModel.$parsers.push(function(value) {
        return '' + value;
      });
      ngModel.$formatters.push(function(value) {
        return parseInt(value, 10);
      });
    }
  };
});;
