'use strict';
import angular from "angular";

import "../../lib/angular-foundation.min";

import "../../common/Api";
import "../../common/Token";
import "../../common/keyboard-layouts";

export default angular.module('System.NetworkSettings',[
	'fastx.Api',
	'Token',
	'mm.foundation',
	'fastx.keyboardLayoutFactory'
])
.factory('NetworkSettings',['Api','Token',function(Api,Token){
	var t = {};
	t.getSettings = function(success,error){
		Api.get('system/settings',{},success,error);
	}
	t.setSettings = function(o,success,error){
		Api.post('system/settings',{},o,success,error);
	}
	return t;
}])
.controller('NetworkSettingsCtrl',['NetworkSettings','$window','$scope','$modal','KeyboardLayouts',
	function(NetworkSettings,$window,$scope,$modal,KeyboardLayouts){
	NetworkSettings.getSettings(function(o){
		$scope.system = angular.extend({
			settings:{
				maxSessions:0,
				keepAliveInterval:0,
				sshport:22,
				enableSudoUser:false
			},
			client:{
				disableStart:false,
				schedule:false,
				screenshot:true,
				keyboardLayout: 0x00000409,
				keyboardType: 0x00000004
			}
		},o);
		$scope.system.client.keyboardLayout = KeyboardLayouts.layouts.find (function (c) {
			return c.id === $scope.system.client.keyboardLayout
		});
		$scope.system.client.keyboardType = KeyboardLayouts.types.find (function (c) {
			return c.id === $scope.system.client.keyboardType
		});
		console.log ($scope.system.client);
	},function(e){
		$scope.alert ={type:'alert',msg: e.error.message,close:function(){delete $scope.alert;}};
	});

	$scope.keyboardLayouts = KeyboardLayouts;

	$scope.submit = function(system){
		system.client.keyboardLayout = system.client.keyboardLayout.id;
		system.client.keyboardType = system.client.keyboardType.id;

		NetworkSettings.setSettings(system,function(d){
			$scope.system = d;
			$scope.system.client.keyboardLayout = KeyboardLayouts.layouts.find (function (c) {
				return c.id === $scope.system.client.keyboardLayout
			});
			$scope.system.client.keyboardType = KeyboardLayouts.types.find (function (c) {
				return c.id === $scope.system.client.keyboardType
			});
			$scope.alert ={type:'success',msg:'Changes Saved Successfully',close:function(){delete $scope.alert;}};
		},function(e){
			$scope.alert ={type:'alert',msg: e.error.message,close:function(){delete $scope.alert;}};
		});
	};

}])

.directive('stringToInt', function() {
  return {
    require: 'ngModel',
    link: function(scope, element, attrs, ngModel) {
      ngModel.$parsers.push(function(value) {
        return '' + value;
      });
      ngModel.$formatters.push(function(value) {
        return parseInt(value, 10);
      });
    }
  }
});
