'use strict';
import angular from "angular";

import "../../common/Api";
import "../../common/Token";

export default angular.module('System.Theme',[
	'fastx.Api',
	'Token'
])
.factory('System.Theme',['Api','Token',function(Api,Token){
	var t = {};
	t.getTheme = function(success,error){
		Api.get('system/theme',{},success,error);
	}
	t.setTheme = function(o,success,error){
		Api.post('system/theme',{},o,success,error);
	}
	return t;
}])

.controller('ThemeConfigCtrl',['$scope','System.Theme','$window',function($scope,Theme,$window){
	Theme.getTheme(function(o){
		$scope.theme ={
			button:{
				background:o['button-background'],
				color:o['button-color']
			},
			logo:o.logo,
			backgroundImage:o.backgroundImage,
			backgroundImageRepeat:o.backgroundImageRepeat,
			debrand:o.debrand,
		}
		$scope.file_changed = function(element) {
			$scope.$apply(function(scope) {
				var file = element.files[0];
				var reader = new FileReader();
				reader.onload = function() {
					$scope.$apply(function(s){
						$scope.theme[element.getAttribute('data-img')] = '"' + reader.result +'"';
					});

				};
				if(file){
					reader.readAsDataURL(file);
				}
			});
		};
	},function(e){

	});
	$scope.defaults = function(){
			$scope.theme = {
				button:{
					background:'#4682b4',
					color:'#FFFFFF'
				},
				active:{
					background:'#D2ECF6',
					color:'#008CBA'
				},
				"debrand":false,
				"backgroundImage":"img/body.png",
				"backgroundImageRepeat":"repeat",
				"logo":"'img/fastx-logo-light.png'"
			}
	}

	$scope.bg={
		background:'url("./css/body.png")'
	};
	$scope.save = function(o){
		Theme.setTheme({
			"button-background":o.button.background,
			"button-color":o.button.color,
			"active-background":(o.active)?o.active.background:"",
			"active-color":(o.active)?o.active.color:"",
			"logo":o.logo,
			"backgroundImage":o.backgroundImage,
			"backgroundImageRepeat":o.backgroundImageRepeat,
			"backgroundColor":o.backgroundColor,
			"foregroundColor":o.foregroundColor,
			"navMenu":o.navMenu,
			"debrand":o.debrand,
			"textColor":o.textColor
		},function(){
			$window.location.reload();
		},function(e){
			$scope.alert ={type:'alert',msg: e.error.message,close:function(){delete $scope.alert;}};
		});
	}

}]);
