'use strict';
import angular from "angular";

import "../../common/Api";
import "../../common/Token";

export default angular.module('System.WWW',[
	'fastx.Api',
	'Token'
])
.factory('WWW',['Api','Token',function(Api,Token){
	var t = {};
	t.get = function(success,error){
		Api.get('system/www',{},success,error);
	}
	t.set = function(o,success,error){
		Api.post('system/www',{},o,success,error);
	}
	return t;
}])
.controller('WWWCtrl',['WWW','$scope',function(WWW,$scope){
	WWW.get(function(o){
		$scope.config = o;
	},function(e){})

	$scope.submit = function(config){
		WWW.set(config,function(){
			$scope.alert ={type:'success',msg:'Changes saved successfully. Changes will take effect when you restart your server',close:function(){delete $scope.alert;}};
		},function(e){
			$scope.alert ={type:'alert',msg: e.error.message,close:function(){delete $scope.alert;}};
		});
	};
}])
.directive('stringToInt', function() {
  return {
    require: 'ngModel',
    link: function(scope, element, attrs, ngModel) {
      ngModel.$parsers.push(function(value) {
        return '' + value;
      });
      ngModel.$formatters.push(function(value) {
        return parseInt(value, 10);
      });
    }
  }
});
