'use strict'
import angular from 'angular';

import "../../lib/angular-foundation.min";


export default angular.module('fastx.Clipboard',['mm.foundation'])
.factory('Clipboard',['$rootScope',function($rootScope){
	var cd = '';
	var clip = {};
	Object.defineProperty(clip,'data',{
		get:function(){return cd;},
		set:function(n){
			cd = n;
			$rootScope.$broadcast('clipboard:dataReady',cd);
		}
	});
	return clip;
}])
.controller('ClipboardCtrl',['$rootScope','$scope',function($rootScope,$scope){
	$scope.clipboard = function(){
		document.dispatchEvent(new CustomEvent('snRequestRemoteClipboardData'));
	}
}])
.controller('ClipboardDialogCtrl',['$rootScope','$scope',function($rootScope,$scope){

	$scope.clip = {
		data:""
	};

	$scope.sendClipboardData = function(text){
		document.dispatchEvent(new CustomEvent('snSetRemoteClipboardData',{
			detail:text || ''
		}));
	}
	$scope.setClipData = function(n){
		$scope.clip.data = n;
	}
	$scope.getClipboardData = function(){
		document.dispatchEvent(new CustomEvent('snRequestRemoteClipboardData'));
	}
	$scope.$on('clipboard:dataReady',function(e,d){
		$scope.clip.data = d;
	});
}])
