'use strict';

import angular from "angular";

import Config from "./connection.config";
import Init from "./init.directive";

import * as ConnectionUtil from "../../common/connection/util";
import * as Token from "../../common/Token";
import * as angularFoundation from "../../lib/angular-foundation.min";

import * as TouchOptions from '../touch/touch';
import * as Clipboard from '../clipboard/clipboard';
import * as WindowManager  from '../rail/window-manager';

import FastXObject from "./fastx-object.service";
import Parse from "./parse.service";

export default angular.module('fastx.Connection',[
	'Token',
	'fastx.connection-util',
	'mm.foundation',
	'fastx.Touch',
	'fastx.Clipboard',
	'fastx.WindowManager'])
	.config(Config)
	.directive('fxInit',Init)
	.factory('FastXObject',FastXObject)
	.factory('Parse',Parse);
