"use strict";

export default Parse;

Parse.$inject = ['$location','$window','ClosedDialog'];

function Parse ($location,$window,ClosedDialog) {
	var f = {};

	function createWs(o){
		if(o.id && (o.port || o.RdpPort)){
			var basePath = location.href.replace(/\/[^\/]+$/,"").replace(/\/$/,"").replace(/https?:\/\//,"");
			var uri = '/connect?' + btoa(JSON.stringify({id:o.id,port:o.RdpPort || o.port}));
			return [(location.protocol === 'https:')?'wss://':'ws://',basePath,uri].join('');
		}else{
			throw new Error('Not enough data to create websocket');
		}
	}

	/* returns a promise with the data; on reject, returns id if exists ****/
	f.getQuery = function(){
		return new Promise (function (resolve, reject){
			var hash = $location.hash();
			try{
				if(!hash.length){
					reject(new Error('Query String missing'));
				}
				var json = atob(hash);

				var fastx =  JSON.parse(json);
				if(typeof fastx !== 'object'){
					reject(new Error('Invalid Query String'));
				}
				//is there enough data
				fastx.ws = createWs(fastx);
				try{
					fastx.WebGL = JSON.parse($window.localStorage['snCfg']).WebGL;
				}catch(e){
					fastx.WebGL = true;
				}
				console.log('Session id:',fastx.id);
				resolve(Object.assign(fastx,$location.search()));
			}catch(e){
				reject(e);
			}
		});
}
	f.xrdp = function(){
		return new Promise (function (resolve, reject) {
			f.getQuery().then(function(fastx){
				fastx.ws = createWs(fastx);
				//fastx.closed = ClosedDialog;
				resolve(fastx);
			})
			.catch (reject);
		});
	}
	return f;
}
