 'use strict';
 import angular from 'angular';

 export default angular.module('fastx.Keyboard',[])
 .directive('fxNumlock',['MenuButton',function(MenuButton){
	function link($scope,el,attr){
		var numlock;
		$scope.keys = setNumlockKeys(false);
		$scope.evt = MenuButton;
		function setNumlockKeys(numlock){
		if(numlock){
			return[
				[
					{code:"NumpadDivide",name:'/'},
					{code:"NumpadMultiply",name:'*'},
					{code:"NumpadSubtract",name:'-'},
				],
				[
					{code:"Numpad7",name:'7'},
					{code:"Numpad8",name:'8'},
					{code:"Numpad9",name:'9'},
					{code:"NumpadAdd",name:'+'},

				],
				[
					{code:"Numpad4",name:'4'},
					{code:"Numpad5",name:'5'},
					{code:"Numpad6",name:'6'},
				],
				[
					{code:"Numpad1",name:'1'},
					{code:"Numpad2",name:'2'},
					{code:"Numpad3",name:'3'},

				],
				[
					{code:"Numpad0",name:'0'},
					{code:"NumpadDecimal",name:'.'},
					{code:"NumpadEnter",name:'Ent'}

				]
			];
		}else{
			return [
				[
					{code:"NumpadDivide",name:'/'},
					{code:"NumpadMultiply",name:'*'},
					{code:"NumpadSubtract",name:'-'},

				],
				[
					{code:"Numpad7",name:'Home'},
					{code:"Numpad8",name:'KP_Up',icon:'ion-arrow-up-b'},
					{code:"Numpad9",name:'PgUp'},
					{code:"NumpadAdd",name:'+'},
				],
				[
					{code:"Numpad4",name:'KP_Left',icon:'ion-arrow-left-b'},
					{code:"Numpad5",name:'Begin'},
					{code:"Numpad6",name:'KP_Right',icon:'ion-arrow-right-b'},
				],
				[
					{code:"Numpad1",name:'End'},
					{code:"Numpad2",name:'KP_Down',icon:'ion-arrow-down-b'},
					{code:"Numpad3",name:'PgDn'},
				],
				[
					{code:"Numpad0",name:'Ins'},
					{code:"NumpadDecimal",name:'Del'},
					{code:"NumpadEnter",name:'Ent'}
				]
			];
		}
	}


		el.on('click',function(e){
			MenuButton.sendKeyDown( {code:'NumLock'});
			MenuButton.sendKeyUp( {code:'NumLock'});
			numlock = !numlock;
			el.toggleClass('active',numlock);
			$scope.keys = setNumlockKeys(numlock);
		});
		$(document).on('blur',function(){
			 numlock = false;
			 $scope.keys  = setNumlockKeys(numlock);
		});
	}
	return{
		link:link
	}
}])
 .controller("MenuButtonCtrl",['$scope','$rootScope',function($scope,$rootScope){

}])
.controller('MouseCtrl',['$scope','MouseButton',function($scope,MouseButton){
	$scope.mouse = MouseButton;
}])
.controller('ModCtrl',['$scope','MenuButtonToggle',function($scope,MenuButtonToggle){
	//$scope.more = 'input';
	$scope.mods = MenuButtonToggle;
	$scope.keys = [
		{code:'ControlLeft',name:'Ctrl L',location:KeyboardEvent.DOM_KEY_LOCATION_LEFT},
		{code:'AltLeft',name:'Alt L',location:KeyboardEvent.DOM_KEY_LOCATION_LEFT},
		//{code:"OSLeft",name:'Win L',location:KeyboardEvent.DOM_KEY_LOCATION_LEFT},
		{code:"ShiftLeft",name:'Shift L',location:KeyboardEvent.DOM_KEY_LOCATION_LEFT},


		{code:'ControlRight',name:'Ctrl R',location:KeyboardEvent.DOM_KEY_LOCATION_RIGHT},
		{code:'AltRight',name:'Alt R',location:KeyboardEvent.DOM_KEY_LOCATION_RIGHT},
		//{code:'OSRight',name:'Win R',location:KeyboardEvent.DOM_KEY_LOCATION_RIGHT},
		{code:'ShiftRight',name:'Shift R',location:KeyboardEvent.DOM_KEY_LOCATION_RIGHT},

	];
}])
.controller('KeysCtrl',['$scope',function($scope){
	$scope.inputFocus = function(){
		document.getElementById('myText').focus();
	}
}])
.controller('EscDelCtrl',['$scope','MenuButton',function($scope,MenuButton){
	//$scope.more = 'input';
	$scope.evt = MenuButton;
	$scope.keys = [
		{name:'Esc',code:'Escape'},
		{code:'Insert'},
		{code:'Delete'},
		{code:'Tab'},
		{code:"End"},
		{code:"Home"},
		{code:"PgUp"},
		{code:"PgDn"},
		{code:'ArrowUp',icon:'ion-arrow-up-b'},
		{code:'ArrowDown',icon:'ion-arrow-down-b'},
		{code:'ArrowLeft',icon:'ion-arrow-left-b'},
		{code:'ArrowRight',icon:'ion-arrow-right-b'}

	];
}])
.controller('FKeysCtrl',['$scope','MenuButton',function($scope,MenuButton){
	//$scope.more = 'input';
	$scope.evt = MenuButton;
	$scope.keys = [
		{code:'F1'},
		{code:'F2'},
		{code:'F3'},
		{code:'F4'},
		{code:'F5'},
		{code:'F6'},
		{code:'F7'},
		{code:'F8'},
		{code:'F9'},
		{code:'F10'},
		{code:'F11'},
		{code:'F12'}
	];
}])

.controller('ArrowsCtrl',['$scope','$rootScope','MenuButton',function($scope,$rootScope,MenuButton){
	//$scope.more = 'input';
	$scope.evt = MenuButton;
	$scope.keys = [

	];
}])
.controller('NumPadCtrl',['$scope','$rootScope','MenuButton',function($scope,$rootScope,MenuButton){
	//$scope.more = 'input';
}]);
