
function DrawQueue(w,h) {
    var canvas = document.createElement("canvas");
    var ctx = canvas.getContext('2d');
    var queue = [];
    var renderQueue = {};
    var next = 0;

    canvas.width  = w;
    canvas.height = h;
    canvas.style.display = 'none';

    Object.defineProperty(this,"canvas",{get:function(){return canvas;}});

    this.enqueue = function () {
        var i = next;
        queue.push(i);
        next++;
        return i;
    }
    this.done = function (id,cb) {
        renderQueue[id] = cb;
    }
    function draw () {
        while (queue.length && renderQueue[queue[0]]) {
            renderQueue[queue[0]]();
            delete renderQueue[queue[0]];
            queue.shift();
        }
        requestAnimationFrame(draw);
    }
    draw();


}


module.exports = DrawQueue;
