'use strict';

    var Clipboard   = require('./clipboard');
    var Sndesk      = require('./sndesk');
    var Input     = require('./input/input');
    var Sncfg       = require('./sncfg');
    var Snshare2    = require('./snshare2');
    var Rail        = require('./rail');
    var Snrail      = require('./snrail');
    var Screen      = require('xrdp/canvas/screen');
    var Offscreen     = require('xrdp/cache/offscreen-bitmap');

	function Channels(canvas,socket,userChannelId,channelIds,channels){
		//this.canvas = canvas;
		this.input = new Input(socket,Screen.canvas);
		this.clipboard = new Clipboard(socket,userChannelId,channelIds[channels.indexOf('cliprdr')],Screen.canvas);
		this.sndesk = new Sndesk(socket,userChannelId,channelIds[channels.indexOf('sndesk')],Screen.canvas);
		this.sncfg = new Sncfg(socket,userChannelId,channelIds[channels.indexOf('sncfg')],Screen.canvas);
		this.snshare2 = new Snshare2(socket,userChannelId,channelIds[channels.indexOf('snshar2')],Screen.canvas);
		this.rail = new Rail(socket,userChannelId,channelIds[channels.indexOf('rail')],Screen.canvas);
		this.snrail = new Snrail(socket,userChannelId,channelIds[channels.indexOf('snrail')],Screen.canvas);

		var that = this;
		Object.defineProperty(that,'cb',{
			get:function(){
				return  Object.assign({},
				that.input.callbacks,
				that.clipboard.callbacks,
				that.sndesk.callbacks,
				that.sncfg.callbacks,
				that.snshare2.callbacks,
				that.rail.callbacks,
				that.snrail.callbacks
			);
			}
		});
        if(channels.indexOf('rail') >= 0){
    		that.cb.sendResizeRequest(window.screen.width,window.screen.height);
    		(Offscreen.primary()).width = window.screen.width;
    		(Offscreen.primary()).height = window.screen.height;
    	}else{
    		document.dispatchEvent(new CustomEvent('snSwm'));
    	}
	}
	Channels.prototype.process = function(channel,userData){
		switch(channel){
			case 'sndesk':
				this.sndesk.processMessage(userData);
				break;
			case 'cliprdr':
				this.clipboard.processMessage(userData);
				break
			case 'sncfg':
				this.sncfg.processMessage(userData);
				break;
			case 'snshar2':
				this.snshare2.processMessage(userData);
				break;
			case 'rail':
				this.rail.processMessage(userData);
				break;
			default:
				console.log('Unknown Channel',channel);
				break;
			}
	}
module.exports = Channels;
