'use strict';
/*
 * RDP Scancodes 
 */

var dom3_codes = {
	"Backquote":		{ scancode: 0x29 },
	"Backslash":		{ scancode: 0x2B },
	"Backspace":		{ scancode: 0x0E }, 
	"BracketLeft":		{ scancode: 0x1A },
	"BracketRight":		{ scancode: 0x1B },
	"Comma":		{ scancode: 0x33 },
	"Digit1":		{ scancode: 0x02 },
	"Digit2":		{ scancode: 0x03 },
	"Digit3":		{ scancode: 0x04 },
	"Digit4":		{ scancode: 0x05 },
	"Digit5":		{ scancode: 0x06 },
	"Digit6":		{ scancode: 0x07 },
	"Digit7":		{ scancode: 0x08 },
	"Digit8":		{ scancode: 0x09 },
	"Digit9":		{ scancode: 0x0A },
	"Digit0":		{ scancode: 0x0B },
	"Equal":		{ scancode: 0x0D },
//	"IntlBackslash":
//	"IntlHash":
	"IntlRo": 		{ scancode:0x73 }, //Japanese
	"IntlYen": 		{ scancode:0x0 }, //Japanese
	"KeyA":			{ scancode: 0x1E },
	"KeyB":			{ scancode: 0x30 },
	"KeyC":			{ scancode: 0x2E },
	"KeyD":			{ scancode: 0x20 },
	"KeyE":			{ scancode: 0x12 },
	"KeyF":			{ scancode: 0x21 },
	"KeyG":			{ scancode: 0x22 },
	"KeyH":			{ scancode: 0x23 },
	"KeyI":			{ scancode: 0x17 },
	"KeyJ":			{ scancode: 0x24 },
	"KeyK":			{ scancode: 0x25 },
	"KeyL":			{ scancode: 0x26 },
	"KeyM":			{ scancode: 0x32 },
	"KeyN":			{ scancode: 0x31 },
	"KeyO":			{ scancode: 0x18 },
	"KeyP":			{ scancode: 0x19 },
	"KeyQ":			{ scancode: 0x10 },
	"KeyR":			{ scancode: 0x13 },
	"KeyS":			{ scancode: 0x1F },
	"KeyT":			{ scancode: 0x14 },
	"KeyU":			{ scancode: 0x16 },
	"KeyV":			{ scancode: 0x2F },
	"KeyW":			{ scancode: 0x11 },
	"KeyX":			{ scancode: 0x2D },
	"KeyY":			{ scancode: 0x15 },
	"KeyZ":			{ scancode: 0x2C },
	"Minus":		{ scancode: 0x0C },
	"Period":		{ scancode: 0x34 },
	"Quote":		{ scancode: 0x28 },
	"Semicolon":	{ scancode: 0x27 },
	"Slash":		{ scancode: 0x35 },

	"AltLeft":		{ scancode: 0x38 },
	"AltRight":		{ scancode: 0x138 },
	"CapsLock":		{ scancode: 0x3A, is_lock: true },
//	"ContextMenu":
	"ControlLeft":	{ scancode: 0x1D },
	"ControlRight":	{ scancode: 0x11D },
	"Enter":		{ scancode: 0x1C },
	"OSLeft":		{ scancode: 0x5C },
	"OSRight":		{ scancode: 0x15C },
	"ShiftLeft":	{ scancode: 0x2A },
	"ShiftRight":	{ scancode: 0x36 },
	"Space":		{ scancode: 0x39 },
	"Tab":			{ scancode: 0x0F },
	"IntlBackslash":{ scancode: 0x56 },//swiss german fix <
	"Convert": 		{ scancode:0x79 }, //Japanese
	"KanaMode":   	{ scancode:0x72 }, //Japanese
//	"Lang1":
//	"Lang2":
//	"Lang3":
//	"Lang4":
//	"Lang5":
	"NonConvert":	{ scancode:0x7B }, //Japanese
	

	"Delete":		{ scancode: 0x153 },
	"End":			{ scancode: 0x14F },
//	"Help":
	"Home":			{ scancode: 0x147 },
	"Insert":		{ scancode: 0x152 },
	"PageDown":		{ scancode: 0x151 },
	"PageUp":		{ scancode: 0x149 },

	"ArrowDown":	{ scancode: 0x150 },
	"ArrowLeft":	{ scancode: 0x14B },
	"ArrowRight":	{ scancode: 0x14D },
	"ArrowUp":		{ scancode: 0x148 },

	"NumLock":		{ scancode: 0x45, is_lock: true },
	"Numpad0":		{ scancode: 0x52 },
	"Numpad1":		{ scancode: 0x4F },
	"Numpad2":		{ scancode: 0x50 },
	"Numpad3":		{ scancode: 0x51 },
	"Numpad4":		{ scancode: 0x4B },
	"Numpad5":		{ scancode: 0x4C },
	"Numpad6":		{ scancode: 0x4D },
	"Numpad7":		{ scancode: 0x47 },
	"Numpad8":		{ scancode: 0x48 },
	"Numpad9":		{ scancode: 0x49 },
	"NumpadAdd":	{ scancode: 0x4E },
//	"NumpadBackspace":
//	"NumpadClear":
//	"NumpadClearEntry":
//	"NumpadComma":
	"NumpadDecimal":{ scancode: 0x53 },
	"NumpadDivide":	{ scancode: 0x135 },
	"NumpadEnter":	{ scancode: 0x11C },
//	"NumpadEqual":
//	"NumpadMemoryAdd":
//	"NumpadMemoryClear":
//	"NumpadMemoryRecall":
//	"NumpadMemoryStore":
//	"NumpadMemorySubtract":
	"NumpadMultiply":{ scancode: 0x37 },
//	"NumpadParenLeft":
//	"NumpadParenRight":
	"NumpadSubtract":{ scancode: 0x4A },

	"Escape":		{ scancode: 0x01 },
	"F1":			{ scancode: 0x3B },
	"F2":			{ scancode: 0x3C },
	"F3":			{ scancode: 0x3D },
	"F4":			{ scancode: 0x3E },
	"F5":			{ scancode: 0x3F },
	"F6":			{ scancode: 0x40 },
	"F7":			{ scancode: 0x41 },
	"F8":			{ scancode: 0x42 },
	"F9":			{ scancode: 0x43 },
	"F10":			{ scancode: 0x44 },
	"F11":			{ scancode: 0x57 },
	"F12":			{ scancode: 0x58 },
//	"Fn":
//	"FLock":
//	"PrintScreen":
//	"ScrollLock":
//	"Pause":

//	Extra Keys
}

var ie_keyCodes = {
	192:			{ scancode: 0x29 },
	220:			{ scancode: 0x2B },
	8:			{ scancode: 0x0E },
	219:			{ scancode: 0x1A },
	221:			{ scancode: 0x1B },
	188:			{ scancode: 0x33 },
	49:			{ scancode: 0x02 },
	50:			{ scancode: 0x03 },
	51:			{ scancode: 0x04 },
	52:			{ scancode: 0x05 },
	53:			{ scancode: 0x06 },
	54:			{ scancode: 0x07 },
	55:			{ scancode: 0x08 },
	56:			{ scancode: 0x09 },
	57:			{ scancode: 0x0A },
	48:			{ scancode: 0x0B },
	187:			{ scancode: 0x0D },
	61:			{ scancode: 0x0D },
//
//
//
//
	65:			{ scancode: 0x1E },
	66:			{ scancode: 0x30 },
	67:			{ scancode: 0x2E },
	68:			{ scancode: 0x20 },
	69:			{ scancode: 0x12 },
	70:			{ scancode: 0x21 },
	71:			{ scancode: 0x22 },
	72:			{ scancode: 0x23 },
	73:			{ scancode: 0x17 },
	74:			{ scancode: 0x24 },
	75:			{ scancode: 0x25 },
	76:			{ scancode: 0x26 },
	77:			{ scancode: 0x32 },
	78:			{ scancode: 0x31 },
	79:			{ scancode: 0x18 },
	80:			{ scancode: 0x19 },
	81:			{ scancode: 0x10 },
	82:			{ scancode: 0x13 },
	83:			{ scancode: 0x1F },
	84:			{ scancode: 0x14 },
	85:			{ scancode: 0x16 },
	86:			{ scancode: 0x2F },
	87:			{ scancode: 0x11 },
	88:			{ scancode: 0x2D },
	89:			{ scancode: 0x15 },
	90:			{ scancode: 0x2C },
	189:			{ scancode: 0x0C },
	173:			{ scancode: 0x0C },
	190:			{ scancode: 0x34 },
	222:			{ scancode: 0x28 },
	186:			{ scancode: 0x27 },
	59:			{ scancode: 0x27 },
	191:			{ scancode: 0x35 },

	18:			{ scancode_left: 0x38, scancode_right: 0x138 },
	20:			{ scancode: 0x3A, is_lock: true },
//
	17:			{ scancode_left: 0x1D, scancode_right: 0x11D },
	13:			{ scancode: 0x1C, scancode_lock: 0x11C },
	91:			{ scancode_left: 0x15B },
	92:			{ scancode_right: 0x15C },
	93:			{ scancode: 0x15C },
	16:			{ scancode_left: 0x2A, scancode_right: 0x36 },
	32:			{ scancode: 0x39 },
	9:			{ scancode: 0x0F },

//
//
//
//
//
//
//
//

	46:			{ scancode: 0x153, scancode_lock: 0x53 },
	35:			{ scancode: 0x14F, scancode_lock: 0x4F },
//
	36:			{ scancode: 0x147 },
	45:			{ scancode: 0x152, scancode_lock: 0x52 },
	33:			{ scancode: 0x149, scancode_lock: 0x49 },
	34:			{ scancode: 0x151, scancode_lock: 0x51 },

	37:			{ scancode: 0x14B, scancode_lock: 0x4B },
	38:			{ scancode: 0x148, scancode_lock: 0x48 },
	39:			{ scancode: 0x14D, scancode_lock: 0x4D },
	40:			{ scancode: 0x150, scancode_lock: 0x50 },


	144:			{ scancode: 0x45, is_lock: true },
	96:			{ scancode_lock: 0x52 },
	97:			{ scancode_lock: 0x4F },
	98:			{ scancode_lock: 0x50 },
	99:			{ scancode_lock: 0x51 },
	100:			{ scancode_lock: 0x4B },
	101:			{ scancode_lock: 0x4C },
	102:			{ scancode_lock: 0x4D },
	103:			{ scancode_lock: 0x47 },
	104:			{ scancode_lock: 0x48 },
	105:			{ scancode_lock: 0x49 },
	107:			{ scancode_lock: 0x4E },
//
//
//
//
	110:			{ scancode_lock: 0x53 },
	111:			{ scancode_lock: 0x135 },
//
//
//
//
//
//
	106:			{ scancode_lock: 0x37 },
//
//
	109:			{ scancode_lock: 0x4A },

	27:			{ scancode: 0x01 },
	112:			{ scancode: 0x3B },
	113:			{ scancode: 0x3C },
	114:			{ scancode: 0x3D },
	115:			{ scancode: 0x3E },
	116:			{ scancode: 0x3F },
	117:			{ scancode: 0x40 },
	118:			{ scancode: 0x41 },
	119:			{ scancode: 0x42 },
	120:			{ scancode: 0x43 },
	121:			{ scancode: 0x44 },
	122:			{ scancode: 0x57 },
	123:			{ scancode: 0x58 },
	164:			{ scancode: 0x2B },//swiss german fix $
	60:				{ scancode: 0x56 },//swiss german fix <
	
	28:				{ scancode: 0x79 },//Japanese Convert
	29:				{ scancode: 0x7B },//Japanese NonConvert
	226:			{ scancode: 0x73 }, //Japanese IntlRo
	242:			{ scancode: 0x72 },//Japanese KanaMode
	193:                   { scancode: 0x2B}//Japanese IntlRo again
//
//
//
//
//

//	Extra Keys
}

module.exports = function(e) {
    if (typeof e.code !== "undefined") {
            if (e.code in dom3_codes) return dom3_codes[e.code];
    }
    else {
            if (e.keyCode in ie_keyCodes) return ie_keyCodes[e.keyCode];
    }

    return undefined;
}

