'use strict';
	/*************** INPUT EVENTS ********************/
	
        var DataStream  = require('DataStream');
        
        
	function writeFpInputHeader(numEvents,secFlags){
		return secFlags | (numEvents > 15)?0:numEvents << 2 ;
	}
	function wrapInput(events,secFlags){
		secFlags = secFlags | 0;
		var ds = new DataStream(4);
		var len = 3;
		ds.writeUint8(secFlags  | (events.length > 15)?0:(events.length << 2) );
		ds.seek(3);
		
		if(events.length > 15){
			len++;
			ds.writeUint8(events.length);
		}
		while(events.length){
			len += events[0].byteLength; 
			ds.writeUint8Array(new Uint8Array(events.shift()));
		}
		ds.seek(1);
		ds.writeUint8Array( [ 0x80 |( (len & 0x7F00) >> 8),len & 0x00FF]);
		return ds.buffer;
	}
	
	function inputEventMouse(pointerFlags,pos,X){
		X = X | false;
		var dv = new DataView(new ArrayBuffer(7));
		dv.setUint8(0,((X)?0x02:0x01) << 5); //mouse or extended mouse
		dv.setUint16(1,pointerFlags,true);
		dv.setUint16(3,pos[0],true);
		dv.setUint16(5,pos[1],true);
		return dv.buffer;
	}
	function mouseButton(button,pos,isDown){
		var X = false;
		var flags = (isDown)?0x8000:0x0000;
		
		switch(button){
			case 1:
				flags |= 0x1000;
				break;
			case 2:
				flags |= 0x2000;
				break;
			case 3:
				flags |= 0x4000;
				break;
			case 4:
				flags |= 0x0001;
				X = true;
				break;
			case 5:
				flags |= 0x0002;
				X=true;
				break;
			default:
				console.log('Unknown Button press');
				break;
		}
		return inputEventMouse(flags,pos,X);
	}
	function mouseMove(pos){
		return inputEventMouse(0x0800,pos,false);
	}
	function key(keyCode,keyUp){//scancode. unicode not supported
		var dv = new DataView(new ArrayBuffer(3));
		dv.setUint8(0,(keyCode & 0x100 ? 0x02 : 0) | (keyUp ? 0x01 : 0));
		dv.setUint8(1,keyCode & 0xFF);
		return dv.buffer;
	}
	function mouseWheel(rotation,pos){
		var flags = 0x0200 | (0x0FF & rotation) | ((rotation < 0)?0x0100:0x0000);
		return inputEventMouse(flags,pos);
	}
	
	function sync(scroll,numlock,capslock,kana){
			var flags = 0;
			flags |= (scroll)?0x01:0x00;
			flags |= (numlock)?0x02:0x00;
			flags |= (capslock)?0x04:0x00;
			flags |= (kana)?0x08:0x00;
			var dv = new DataView(new ArrayBuffer(1));
			dv.setUint8(0,0x03 << 5 | flags );
			return dv.buffer;
		}
	function writeInputEventPdu(events){
		return wrapInput(events,0);
	}
module.exports = {
		wrapInput:wrapInput,
	    mouseMove:mouseMove,
		mouseButton:mouseButton,
	    mouseWheel:mouseWheel,
		key:key,
		sync:sync,
	    writeInputEventPdu:writeInputEventPdu
	}