'use strict';
    var reconnect       = require('xrdp/connection/reconnect');
    var slowPath        = require('xrdp/slow-path/slow-path-pdu');
    var securityHeader  = require('xrdp/security/header/reader');


    function IOChannel(socket,Client){
            slowPath.init(
                Client.store.userChannelId,
                Client.store.ioChannelId,
                Client.store.shareId,0x00,
                Client.store.receivedServerData.encryptionLevel,
                Client.settings.sessionKeys);
        this.encryptionLevel = Client.store.receivedServerData.encryptionLevel;
        this.encryptionMethods = Client.settings.encryptionMethods;
        this.socket = socket;
        this.Client = Client;

    }
    function process(dv,clientConnected){
        var data,sec,len;
        if(this.encryptionLevel){
                //decode security header
                sec= securityHeader.process(dv,this.encryptionLevel,this.encryptionMethods);
                len = dv.byteLength;
                data = slowPath.decodePduType(sec.data);
        }else{
                data = slowPath.decodePduType(dv);
        }

        switch(data.pduType){
                case 0x01://demand active
                        console.log('Connecting: demand_active');
                        reconnect(this.socket,this.Client,data,clientConnected);
                        break;
                case 0x06://deactivate all
                        console.log('Connecting: deactivate_all ');

                        break;
                case 0x07://dataPDU
                        //dataPDU.process();
                        break;
        }
        return len;
    }
    IOChannel.prototype.process = process;
module.exports = IOChannel;
