'use strict';
    var virtualChannel  = require('./virtual-channel');
    var Offscreen = require("xrdp/cache/offscreen-bitmap");
    var Screen  = require("xrdp/canvas/screen");

	var vc,canvas,tmpcanvas;
	var widthRange = [];
	var heightRange =[];

	function minMaxInfo(dv){
		widthRange =  [dv.getUint16(0,true),dv.getUint16(4,true)];
		heightRange = [dv.getUint16(2,true),dv.getUint16(6,true)];
	}
	function resizeNotify(dv){
		resizeCanvas( dv.getUint16(0,true) , dv.getUint16(2,true) );
	}
	function sendResizeRequest(width,height){
		if(width < widthRange[0] || width > widthRange[1]){console.log('Width out of Range');return;}
		if(height < heightRange[0] || height > heightRange[1]){console.log('Height out of Range');return;}
		var buf = new ArrayBuffer(12);
		var dv = new DataView(buf);
		dv.setUint16(0,1,true);//STARNET_RESIZE
		dv.setUint16(2,0,true);//flags
		dv.setUint32(4,4,true);//payload len
		dv.setUint16(8,width,true);
		dv.setUint16(10,height,true);
		vc.send(buf);
	}

	function resizeCanvas(width,height){
        Offscreen.primary().done(Offscreen.primary().enqueue(),function(){
            var ctx = Offscreen.primary().canvas.getContext('2d')
            var imdata = ctx.getImageData(0,0,Offscreen.primary().canvas.width,Offscreen.primary().canvas.height);
            Offscreen.primary().canvas.width = width;
            Offscreen.primary().canvas.height = height;

            ctx.save();
            ctx.beginPath();
            ctx.rect(0,0,width,height);
            ctx.fillStyle = "black";
            ctx.fill();
            ctx.restore();

            ctx.putImageData(imdata,0,0);
            Screen.canvas.width = width;
            Screen.canvas.height = height;

            Screen.canvas.getContext('2d').drawImage(Offscreen.primary().canvas,0,0);

            document.dispatchEvent(new CustomEvent('snResize',{
                detail:{
                    width:width,
                    height:height
                }
            }));
        });
	}
module.exports = function(socket,userChannelId,channelId,Canvas){
			canvas = Canvas;
			vc = new virtualChannel(socket,userChannelId,channelId);
		return {
			processMessage:function(dv){
			var header = vc.processMessage(dv);
			if(!header.type){return;}
			switch(header.type){
				case 1://resize notify
					resizeNotify(header.data);
					break;
				case 2://minmaxinfo
					minMaxInfo(header.data);
					break;
				default:
					console.log('Unknown message type');
					break;
			}
		},
			callbacks:{
				sendResizeRequest:sendResizeRequest
			}
		}
	}
