'use strict';

    var mcs             = require('xrdp/core/mcs');
    var tpkt            = require('xrdp/core/tpkt');
    var x224            = require('xrdp/core/x224');
    var slowPath        = require('xrdp/slow-path/slow-path-pdu');
    var FastPath        = require('xrdp/fast-path/fast-path-pdu');
    var Scene           = require('xrdp/canvas/scene');
    var MessageChannel  = require('xrdp/channels/message-channel');
    var IOChannel       = require('xrdp/channels/io-channel');


    var isConnected,myScene,fastx = {};
    var messageChannel,ioChannel,fastPath ;
    function clientConnected(socket,Client){
            if(isConnected){return;}
            isConnected = true;
                slowPath.init(
                    Client.store.userChannelId,
                    Client.store.ioChannelId,
                    Client.store.shareId,0x00,
                    Client.store.receivedServerData.encryptionLevel,
                    Client.settings.sessionKeys);

            myScene = new Scene(Client,socket,fastx.ready);
            fastPath = new FastPath(Client,myScene.canvas);
            messageChannel = new MessageChannel(socket,Client);
            function processTile(e){
                    myScene.process(e.data);
            }
            document.addEventListener('frame-acknowledge',function(e){
                    socket.send(slowPath.frameAcknowledge(e.detail));
            });
            document.addEventListener('visibilitychange',function(e){
                    if(document['hidden']){
                            socket.send(slowPath.suppressOutput());
                    }else{
                            socket.send(slowPath.unsuppressOutput([0,0,window.width,window.height]));
                    }
            });
    }

    function processMessage(socket,Client,dv){
            if(dv.byteLength < 1){
                    return 0;
            }
            var firstByte = dv.getUint8(0);
            var bytesRead = 0;
            if((firstByte & 0x03) === 0x00){
                    data = fastPath.readHeader(dv);
                    if(data){
                            fastPath.process(data.data);
                            Client.store.networkCharacteristicsByteCount += data.byteLength;
                            return data.byteLength;
                    }
            }else if((firstByte& 0x03) === 0x03){
                    var len;
                    var data = tpkt.parsePacket(dv);
                    if(!data.payload){
                            return 0;
                    }
                    data = x224.parseDataPDU(data.payload);
                    var d2 = mcs.parse(data.data);
                    if(typeof d2 !== 'undefined'){
                            switch(d2.type){
                                    case 26:
                                            data = slowPath.parseHeader(dv);
                                            switch(data.channelId){
                                                    case Client.store.ioChannelId:
                                                            if(!ioChannel){
                                                                    ioChannel = new IOChannel(socket,Client);
                                                            }
                                                            len = ioChannel.process(data.userData,clientConnected);
                                                            break;
                                                    case Client.store.messageChannelId:
                                                            len = messageChannel.process(data.userData);
                                                            break;
                                                    default:
                                                            myScene.processChannel(
                                                                    Client.settings.channels[Client.store.staticVirtualChannelIds.indexOf(data.channelId)],
                                                                    data.userData);
                                                            break;
                                            }
                                            break;
                                    case 8:
                                            console.log(d2);
                                            throw new Error('Server sent disconnect message: ' + d2.reason);
                                            break;
                            }
                    }
                    Client.store.networkCharacteristicsByteCount += (len)?len:dv.getUint16(2,false);
                    return dv.getUint16(2,false);
            }else{
                    throw new Error('Invalid Message Format');
            }
    }
module.exports = function(fx){
            fastx = fx;
            fastx.ready = fastx.ready || function(canvas,cb){};
            return {
                    processMessage:processMessage
            };
    }
