'use strict';
/*
 * Capability Sets
 */



    var DataStream  = require('DataStream');
module.exports = {
    writeGeneral:function(ds,extraFlags,refreshRectSupport,suppressOutputSupport){
	ds.writeUint16(0x0001);
	ds.writeUint16(24);
	ds.writeUint16(0x0000);//unspecified platform
	ds.writeUint16(0x0000);//unspecified platform -- minor
	ds.writeUint16(0x0200);//protocolVersion
	ds.writeUint16(0x0000);//padding
	ds.writeUint16(0x0000);//generalCompressionTypes
	ds.writeUint16(extraFlags);
	ds.writeUint16(0x0000);//updateCapabilityFlag
	ds.writeUint16(0x0000);//remoteUnshareFlag
	ds.writeUint16(0x0000);//generalCompressionLevel
	ds.writeUint8(refreshRectSupport);
	ds.writeUint8(suppressOutputSupport);
	return 1;
    },
    writeBitmap:function(ds,preferredBitsPerPixel,desktopWidth,desktopHeight,desktopResizeFlag,drawingFlags){
	ds.writeUint16(0x0002);
	ds.writeUint16(28);
	ds.writeUint16(preferredBitsPerPixel);
	ds.writeUint16(0x0001);
	ds.writeUint16(0x0001);
	ds.writeUint16(0x0001);
	ds.writeUint16(desktopWidth);
	ds.writeUint16(desktopHeight);
	ds.writeUint16(0x0000);//padding
	ds.writeUint16(desktopResizeFlag);
	ds.writeUint16(0x0001);//bitmapCompressionFlag
	ds.writeUint8(0x00);//hightColorFlags
	ds.writeUint8(drawingFlags);
	ds.writeUint16(0x0001);
	ds.writeUint16(0x0000);//padding
	return 1;
    },
    writeOrder:function(ds,orderFlags,orderSupport,orderSupportExFlags){
	ds.writeUint16(0x0003);
	ds.writeUint16(88);
	ds.writeUint8Array([0,0,0,0,
			    0,0,0,0,
			    0,0,0,0,
			    0,0,0,0]);
	ds.writeUint32(0x00000000);
	ds.writeUint16(1);
	ds.writeUint16(20);
	ds.writeUint16(0x0000);//padding
	ds.writeUint16(1); //maximum order level
	ds.writeUint16(0x0000);
	ds.writeUint16(orderFlags);
	ds.writeUint8Array(orderSupport);
	ds.writeUint16(0x0000);
	ds.writeUint16(orderSupportExFlags);
	ds.writeUint32(0x00000000); //padding
	ds.writeUint32(230400);//480 * 480
	ds.writeUint16(0x0000);
	ds.writeUint16(0x0000);
	ds.writeUint16(0x0000);
	ds.writeUint16(0x0000);
	return 1;
    },
    writeBitmapCacheRev1:function(ds,cache0Entries,cache0MaximumCellSize,
		cache1Entries,cache1MaximumCellSize,cache2Entries,cache2MaximumCellSize
	){
      ds.writeUint16(0x0004);
      ds.writeUint16(40);
      ds.writeUint32(0);
      ds.writeUint32(0);
      ds.writeUint32(0);
      ds.writeUint32(0);
      ds.writeUint32(0);
      ds.writeUint32(0);
      ds.writeUint16(cache0Entries); //max 200
      ds.writeUint16(cache0MaximumCellSize);
      ds.writeUint16(cache1Entries); //max 600
      ds.writeUint16(cache1MaximumCellSize);
      ds.writeUint16(cache2Entries); //max 65535
      ds.writeUint16(cache2MaximumCellSize);
      return 1;
    },
    writeControl:function(ds){
	ds.writeUint16(0x0005);
	ds.writeUint16(12);
	ds.writeUint16(0);
	ds.writeUint16(0);
	ds.writeUint16(0x0002);
	ds.writeUint16(0x0002);
	return 1;
    },
    writeActivation:function(ds){
	ds.writeUint16(0x0007);
	ds.writeUint16(12);
	ds.writeUint16(0);
	ds.writeUint16(0);
	ds.writeUint16(0);
	ds.writeUint16(0);
	return 1;
    },
    writePointer:function(ds,colorPointerCacheSize,pointerCacheSize){
	ds.writeUint16(0x0008);
	ds.writeUint16(10);
	ds.writeUint16(0x0001);
	ds.writeUint16(colorPointerCacheSize);
	ds.writeUint16(pointerCacheSize);
	return 1;
    },
    writeShare:function(ds){
      ds.writeUint16(0x0009);
      ds.writeUint16(8);
      ds.writeUint16(0);
      ds.writeUint16(0);
      return 1;
    },
    writeColorCache:function(ds){
      ds.writeUint16(0x000A);
      ds.writeUint16(8);
      ds.writeUint16(0x0006);
      ds.writeUint16(0);
      return 1;
    },
    writeSound:function(ds,soundFlags){
	ds.writeUint16(0x000C);
	ds.writeUint16(8);
	ds.writeUint16(soundFlags);
	ds.writeUint16(0);
	return 1;
    },
    writeInput:function(ds,inputFlags,keyboardLayout,keyboardType,
			keyboardSubtype,keyboardFunctionKey,imeFileName){
        ds.writeUint16(0x000D);
	ds.writeUint16(88);
	ds.writeUint16(inputFlags);
	ds.writeUint16(0);
	ds.writeUint32(keyboardLayout);
	ds.writeUint32(keyboardType);
	ds.writeUint32(keyboardSubtype);
	ds.writeUint32(keyboardFunctionKey);
	ds.writeUCS2String(imeFileName,DataStream.LITTLE_ENDIAN,31);
	ds.writeUint16(0x0000);
	return 1;
    },
    writeFont:function(ds){
	ds.writeUint16(0x000E);
	ds.writeUint16(8);
	ds.writeUint16(0x0001);
	ds.writeUint16(0x0000);
	return 1;
    },
    writeBrush:function(ds,brushSupportLevel){
	ds.writeUint16(0x000F);
	ds.writeUint16(8);
	ds.writeUint32(brushSupportLevel);
	return 1;
    },
    writeGlyphCache:function(ds,cacheDefinitions,fragCache,glyphSupportLevel){
	ds.writeUint16(0x0010);
	ds.writeUint16(52);
	if(cacheDefinitions.length !== 10){
	  console.log('10 Cache Definitions required');
	  return undefined;
	}
	var def =[];
	while(cacheDefinitions.length > 0){
	  def = cacheDefinitions.shift();
	  if(def[0] > 254){
	    console.log('Invalid CacheEntries value');
	    return undefined;
	  }
	  if(def[1] > 2048){
	    //http://msdn.microsoft.com/en-us/library/cc240566.aspx
	    console.log('Cache MAx Cell Size invalid > 2048');
	    return undefined;
	  }
	  ds.writeUint16(def[0]);
	  ds.writeUint16(def[1]);
	}
	if(fragCache[0] > 256){
	  console.log('invalid fragCacheEntries value');
	  return undefined;
	}
	if(fragCache[1] > 256){
	  console.log('invalid fragCache size');
	  return undefined;
	}
	ds.writeUint16(fragCache[0]);
	ds.writeUint16(fragCache[1]);

	ds.writeUint16(glyphSupportLevel);
	ds.writeUint16(0x0000);
	return 1;
    },
    writeOffscreenCache:function(ds,offscreenSupportLevel,offscreenCacheSize,offscreenCacheEntries){
	ds.writeUint16(0x0011);
	ds.writeUint16(12);
	ds.writeUint32(offscreenSupportLevel);
	ds.writeUint16(offscreenCacheSize);
	ds.writeUint16(offscreenCacheEntries);
	return 1;
    },
    writeBitmapCacheHostSupport:function(ds){
      ds.writeUint16(0x0012);
      ds.writeUint16(8);
      ds.writeUint8(0x01);
      ds.writeUint8(0x00);
      ds.writeUint16(0x0000);
      return 1;
    },
    writeBitmapCacheRev2:function(ds,cacheFlags,cellCaches){
	ds.writeUint16(0x0013);
	ds.writeUint16(40);
	ds.writeUint16(cacheFlags);
	ds.writeUint8(0x00);
	if(typeof cellCaches === 'undefined' || cellCaches.length > 5){
	  console.log('Invalid number of Cell Caches');
	  return undefined;
	}
	ds.writeUint8(cellCaches.length);
	if(cellCaches.length > 0 ){
	  if(cellCaches[0].numEntries > 600){
	    console.log('Invalid Number of Cell Cache 0 Entries');
	    return undefined;
	  }
	  ds.writeUint32(cellCaches[0].numEntries << 1 | cellCaches[0].k);
	}else{
	  ds.writeUint32(0x00000000);
	}
	if(cellCaches.length > 1 ){
	   if(cellCaches[1].numEntries > 600){
	      console.log('Invalid Number of Cell Cache 1 Entries');
	    return undefined;
	  }
	 ds.writeUint32(cellCaches[1].numEntries << 1 | cellCaches[1].k);
	}else{
	  ds.writeUint32(0x00000000);
	}
	if(cellCaches.length > 2 ){
	   if(cellCaches[2].numEntries > 65536){
	    console.log('Invalid Number of Cell Cache 2 Entries');
	    return undefined;
	  }
	 ds.writeUint32(cellCaches[2].numEntries << 1 | cellCaches[2].k);
	}else{
	  ds.writeUint32(0x00000000);
	}
	if(cellCaches.length > 3 ){
	   if(cellCaches[3].numEntries > 4096){
	    console.log('Invalid Number of Cell Cache 3 Entries');
	    return undefined;
	  }
	  ds.writeUint32(cellCaches[3].numEntries << 1 | cellCaches[3].k);
	}else{
	  ds.writeUint32(0x00000000);
	}
	if(cellCaches.length > 4 ){
	   if(cellCaches[4].numEntries > 2048){
	    console.log('Invalid Number of Cell Cache 4 Entries');
	    return undefined;
	  }
	  ds.writeUint32(cellCaches[4].numEntries << 1 | cellCaches[4].k);
	}else{
	  ds.writeUint32(0x00000000);
	}
	ds.writeUint8Array([0,0,0,0,
			    0,0,0,0,
			    0,0,0,0]);
	return 1;
    },
    writeVirtualChannel:function(ds,flags,vCChunkSize){
	ds.writeUint16(0x0014);
	if(typeof vCChunkSize === undefined){
		ds.writeUint16(8);
		ds.writeUint32(flags);
	}else{
		ds.writeUint16(12);
		ds.writeUint32(flags);
		ds.writeUint32(vCChunkSize);
	}
	return 1;
    },
    writeDrawNineGridCache:function(ds,drawNineGridSupportLevel,drawNineGridCacheSize,drawNineGridCacheEntries){
	ds.writeUint16(0x0015);
	ds.writeUint16(12);
	ds.writeUint32(drawNineGridSupportLevel);
	ds.writeUint16(drawNineGridCacheSize);
	ds.writeUint16(drawNineGridCacheEntries);
	return 1;
    },
    writeDrawGdiPlus:function(ds,drawGDIPlusSupportLevel,gdipVersion,drawGdiplusCacheLevel,gdipCacheEntries,gdipCacheChunkSize,gdipImageCacheProperties){
      ds.writeUint16(0x0016);
      ds.writeUint16(40);
      ds.writeUint32(drawGDIPlusSupportLevel);
      ds.writeUint32(gdipVersion);
      ds.writeUint32(drawGdiplusCacheLevel);
      ds.writeUint16(gdipCacheEntries.gdipGraphicsCacheEntries);
      ds.writeUint16(gdipCacheEntries.gdipBrushCachEntries);
      ds.writeUint16(gdipCacheEntries.gdipPenCacheEntries);
      ds.writeUint16(gdipCacheEntries.gdipImageCacheEntries);
      ds.writeUint16(gdipCacheEntries.gdipImageAttributesCacheEntries);
      ds.writeUint16(gdipCacheChunkSize.gdipGraphicsCacheChunkSize);
      ds.writeUint16(gdipCacheChunkSize.gdipObjectBrushCacheChunkSize);
      ds.writeUint16(gdipCacheChunkSize.gdipObjectPenCacheChunkSize);
      ds.writeUint16(gdipCacheChunkSize.gdipObjectImageAttributesCacheChunkSize);
      ds.writeUint16(gdipImageCacheProperties.gdipObjectImageCacheChunkSize);
      ds.writeUint16(gdipImageCacheProperties.gdipObjectImageCacheTotalSize);
      ds.writeUint16(gdipImageCacheProperties.gdipObjectImageCacheMaxSize);
      return 1;
    },
    writeRail:function(ds,S,L,I){
      ds.writeUint16(0x0017);
      ds.writeUint16(8);
      var railSupport = 0;
      if(S === 1){
		railSupport |= 0x00000001;
      }
      if(L === 1){
		railSupport |= 0x00000002;
      }
      if(I === 1){
		railSupport |= 0x00000008;
      }
      ds.writeUint32(railSupport);
      return 1;
    },
    writeWindow:function(ds,wndSupportLevel,numIconCaches,numIconCacheEntries){
	ds.writeUint16(0x0018);
	ds.writeUint16(11);
	ds.writeUint32(wndSupportLevel);
	ds.writeUint8(numIconCaches);
	ds.writeUint16(numIconCacheEntries);
	return 1;
    },
    writeCompDesk:function(ds,compDeskSupportLevel){
      ds.writeUint16(0x0019);
      ds.writeUint16(6);
      ds.writeUint16(compDeskSupportLevel);
      return 1;
    },
    writeMultiFragmentUpdate:function(ds,maxRequestSize){
	ds.writeUint16(0x001A);
	ds.writeUint16(8);
	ds.writeUint32(maxRequestSize);
	return 1;
    },
    writeLargePointer:function(ds,largePointerSupportFlags){
      ds.writeUint16(0x001B);
      ds.writeUint16(6);
      ds.writeUint16(largePointerSupportFlags);
      return 1;
    },
    writeSurfaceCommands:function(ds,cmdFlags){
	ds.writeUint16(0x001C);
	ds.writeUint16(12);
	ds.writeUint32(cmdFlags);
	ds.writeUint32(0x00000000);
	return 1;
    },

    writeBitmapCodecs:function(ds,bitmapCodecs){
      ds.writeUint16(0x001D);
      if(Object.keys(bitmapCodecs).length> 0){
			var d = new DataStream();
			d.writeUint8((Object.keys(bitmapCodecs)).length);
			for(var i in bitmapCodecs){
				d.writeUint8Array(new Uint8Array(bitmapCodecs[i].buffer));
			}
			ds.writeUint16(d.byteLength + 4);
			ds.writeUint8Array(new Uint8Array(d.buffer));
		}else{
			ds.writeUint16(5);
			ds.writeUint8(0);
		}
		return 1;
    },
    writeFrameAcknowledge:function(ds,maxUnacknowledgedFrameCount){
      ds.writeUint16(0x001E);
      ds.writeUint16(8);
      ds.writeUint32(maxUnacknowledgedFrameCount);
      return 1;
    },

	
}
