'use strict';

    var connectionRequest       = require('./connection-request');
    var connectionConfirm       = require('./connection-confirm');
    var basicSettingsExchange   = require('./basic-settings-exchange');
    var attachUser              = require('./attach-user');
    var channelJoin             = require('./channel-join');
    var licensing               = require( './license-error-valid-client');

            var connection = {
			state:'init',
			channelsJoined:0
		}

		/********** Process Server Functions ******************/
module.exports =  {
        init:function(socket,Client){
        connection.state = connectionRequest(socket);
        Client.store.connectionStartTime = (new Date()).getTime();
        },
        processMessage:function(socket,Client,dv){
                console.log('Connecting:', connection.state);
                switch(connection.state){
                        case 'connection_confirm':
                                connection.state ='basic_settings_exchange';
                                return connectionConfirm.process(socket,Client,dv);
                                break;
                        case 'basic_settings_exchange':
                                connection.state ='attach_user';
                                return basicSettingsExchange.process(socket,Client,dv);
                                break;
                        case 'attach_user': //channel connection
                                connection.state ='channel_connection_user_channel';
                                return attachUser.process(socket,Client,dv);
                                break;
                        case 'channel_connection_user_channel': //channel connection
                        case 'channel_connection_io_channel':
                        case 'channel_connection_message_channel':
                        case 'channel_connection_virtual_channel':
                                return channelJoin.process(socket,Client,connection,dv);
                                break;
                        case 'licensing':
                                Client.state = 'connected';
                                return licensing.process(socket,Client,dv);
                                break;
                        default:
                                socket.close(1000,"Could not process Connection Sequence, Unknown state");
                                break;
                }
        }
}
