'use strict';

    var DataStream      = require('DataStream');
    var slowPath        = require('xrdp/slow-path/slow-path-pdu');
    var clientCaps      = require('./client-supported-capabilities');


    function confirmActive(settings,store){
            var capStream = new DataStream();
            var capsetCount = clientCaps(capStream,settings,store);
            if(! capsetCount){return undefined;}
            console.log('Sending confirmActive');
            return slowPath.confirmActivePdu('fastxjs',capsetCount,new Uint8Array(capStream.buffer));
    }
    function syncronize(userChannelId){
            var dv = new DataView(new ArrayBuffer(4));
            dv.setUint16(0,0x0001,true);
            dv.setUint16(2,userChannelId,true);
            console.log('Sending Synchronize');
            return slowPath.dataPdu(0x1F,0x02, 0x00,new Uint8Array(dv.buffer));
    }
    function controlCooperate(){
            var dv = new DataView(new ArrayBuffer(8));
            dv.setUint32(0,0x0004,true);//action
            dv.setUint16(2,0x0000,true);//grantId
            dv.setUint16(4,0x0000,true);//controlId
            console.log('Sending Controll Cooperate');
            return slowPath.dataPdu(0x14,0x02,0x00,new Uint8Array(dv.buffer));
    }
    function controlRequestControl(){
            var dv = new DataView(new ArrayBuffer(8));
            dv.setUint32(0,0x0001,true);//action
            dv.setUint16(2,0x0000,true);//grantId
            dv.setUint16(4,0x0000,true);//controlId
            console.log('Sending ControlRequestControl');
            return slowPath.dataPdu(0x14,0x02,0x00,new Uint8Array(dv.buffer));
    }
    function persistentKeyList(){
            //only if server supports bitmap rev 2
    }
    function fontList(){
            var dv = new DataView(new ArrayBuffer(8));
            dv.setUint16(0,0x0000,true);//number fonts
            dv.setUint16(2,0x0000,true);//totalNumFonts
            dv.setUint16(4,0x0000,true);//listFlags
            dv.setUint16(6,0x0000,true);//entrySize
            console.log('Sending FontList');
            return slowPath.dataPdu(0x27,0x02, 0x00,new Uint8Array(dv.buffer));
    }

    function demandActive(socket,Client,data,clientConnected){
            var capStream = new DataStream();
            var capsetCount = clientCaps(capStream,Client.settings,Client.store);
            if(!capsetCount){return undefined;}
                    Client.store.serverCapabilities = data.serverCapabilities;
                    Client.store.shareId = data.shareId;
                    Client.store.serverChannelId = data.pduSource;
                    clientConnected(socket,Client);

                    slowPath.init(Client.store.userChannelId,Client.store.ioChannelId,Client.store.shareId,0x00,Client.store.receivedServerData.encryptionLevel,Client.store.sessionKeys);
                    socket.send(confirmActive(Client.settings,Client.store));
                    socket.send(syncronize(Client.store.userChannelId));
                    socket.send(controlCooperate());
                    socket.send(controlRequestControl());
                    socket.send(fontList());
    }
module.exports = demandActive;
