'use strict';
/* 
 * RDP constants 
 */
    
module.exports = {
        RESTRICTED_ADMIN_MODE_REQUIRED: 0x01,
        CORRELATION_INFO_PRESENT: 0x08,
        
        PROTOCOL_RDP: 0x00000000,
        PROTOCOL_SSL: 0x00000001,
        PROTOCOL_HYBRID: 0x00000002,
        PROTOCOL_HYBRID_EX: 0x00000008,

        EXTENDED_CLIENT_DATA_SUPPORTED: 0x01,
        DYNVC_GFX_PROTOCOL_SUPPORTED: 0x02,
        NEGRSP_FLAG_RESERVED: 0x04,
        RESTRICTED_ADMIN_MODE_SUPPORTED: 0x08,

        SSL_REQUIRED_BY_SERVER: 0x00000001,
        SSL_NOT_ALLOWED_BY_SERVER: 0x00000002,
        SSL_CERT_NO_ON_SERVER: 0x00000003,
        INCONSISTENT_FLAGS: 0x00000004,
        HYBRID_REQUIRED_BY_SERVER: 0x00000005,
        SSL_WITH_USER_AUTH_REQUIRED_BY_SERVER: 0x00000006,
        
        SEC_EXCHANGE_PKT:0x0001,
        SEC_TRANSPORT_REQ:0x0002,
        RDP_SEC_TRANSPORT_RSP:0x0004,
        SEC_ENCRYPT:0x0008,
        SEC_RESET_SEQNO:0x0010,
        SEC_IGNORE_SEQNO:0x0020,
        SEC_INFO_PKT:0x0040,
        SEC_LICENSE_PKT:0x0080,
        SEC_LICENSE_ENCRYPT_CS:0x0200,
        SEC_LICENSE_ENCRYPT_SC:0x0200,
        SEC_REDIRECTION_PKT:0x0400,
        SEC_SECURE_CHECKSUM:0x0800,
        SEC_AUTODETECT_REQ:0x1000,
        SEC_AUTODETECT_RSP:0x2000,
        SEC_HEARTBEAT:0x4000,
        SEC_FLAGSHI_VALID:0x8000,
        
        INFO_MOUSE:0x00000001,
        INFO_DISABLECTRLALTDEL:0x00000002,
        INFO_AUTOLOGON:0x00000008,
        INFO_UNICODE:0x00000010,
        INFO_MAXIMIZESHELL:0x00000020,
        INFO_LOGONNOTIFY:0x00000040,
        INFO_COMPRESSION:0x00000080,
        CompressionTypeMask:0x00001E00,
        INFO_ENABLEWINDOWSKEY:0x00000100,
        INFO_REMOTECONSOLEAUDIO:0x00002000,
        INFO_FORCE_ENCRYPTED_CS_PDU:0x00004000,
        INFO_RAIL:0x00008000,
        INFO_LOGONERRORS:0x00010000,
        INFO_MOUSE_HAS_WHEEL:0x00020000,
        INFO_PASSWORD_IS_SC_PIN:0x00040000,
        INFO_NOAUDIOPLAYBACK:0x00080000,
        INFO_USING_SAVED_CREDS:0x00100000,
        INFO_AUDIOCAPTURE:0x00200000,
        INFO_VIDEO_DISABLE:0x00400000,
        INFO_HIDEF_RAIL_SUPPORTED:0x02000000,
        
        PACKET_COMPR_TYPE_8K:0x0,
        PACKET_COMPR_TYPE_64K:0x1,
        PACKET_COMPR_TYPE_RDP6:0x2,
        PACKET_COMPR_TYPE_RDP61:0x3,
        
        AF_INET:0x00002,
        AF_INET6:0x0017,
        
        FALSE:0x0000,
        TRUE:0x0001,
        
        PDUTYPE_DEMANDACTIVEPDU:0x1,
        PDUTYPE_CONFIRMACTIVEPDU:0x3,
        PDUTYPE_DEACTIVATEALLPDU:0x6,
        PDUTYPE_DATAPDU:0x7,
        PDUTYPE_SERVER_REDIR_PKT:0xA,
        
        STREAM_UNDEFINED:0x0,
        STREAM_LOW:0x1,
        STREAM_MED:0x2,
        STREAM_HI:0x4,
        
        PDUTYPE2_UPDATE:0x02,
        PDUTYPE2_CONTROL:0x14,
        PDUTYPE2_POINTER:0x1B,
        PDUTYPE2_INPUT:0x1C,
        PDUTYPE2_SYNCHRONIZE:0x1F,
        PDUTYPE2_REFRESH_RECT:0x21,
        PDUTYPE2_PLAY_SOUND:0x22,
        PDUTYPE2_SUPPRESS_OUTPUT:0x23,
        PDUTYPE2_SHUTDOWN_REQUEST:0x24,
        PDUTYPE2_SHUTDOWN_DENIED:0x25,
        PDUTYPE2_SAVE_SESSION_INFO:0x26,
        PDUTYPE2_FONTLIST:0x27,
        PDUTYPE2_FONTMAP:0x28,
        PDUTYPE2_SET_KEYBOARD_INDICATORS:0x29,
        PDUTYPE2_BITMAPCACHE_PERSISTENT_LIST:0x2B,
        PDUTYPE2_BITMAPCACHE_ERROR_PDU:0x2C,
        PDUTYPE2_SET_KEYBOARD_IME_STATUS:0x2D,
        PDUTYPE2_OFFSCRCACHE_ERROR_PDU:0x2E,
        PDUTYPE2_SET_ERROR_INFO_PDU:0x2F,
        PDUTYPE2_DRAWNINEGRID_ERROR_PDU:0x30,
        PDUTYPE2_DRAWGDIPLUS_ERROR_PDU:0x31,
        PDUTYPE2_ARC_STATUS_PDU:0x32,
        PDUTYPE2_STATUS_INFO_PDU:0x36,
        PDUTYPE2_MONITOR_LAYOUT_PDU:0x37,
        
        
        
        //rfx Constants
        CBT_TILE:0xCAC3,
        CBY_CAPS:0xCBC0,
        CBY_CAPSET:0xCBC1,
        WBT_SYNC:0xCCC0,
        WBT_CODEC_VERSIONS:0xCCC1,
        WBT_CHANNELS:0xCCC2,
        
        //sync
        WF_MAGIC:0xCACCACCA,
        WF_VERSION_1_0:0x0100,
         
        //codecChannelT
        WBT_CONTEXT:0xCCC3,
        WBT_FRAME_BEGIN:0xCCC4,
        WBT_FRAME_END:0xCCC5,
        WBT_REGION:0xCCC6,
        WBT_EXTENSION:0xCCC7,
        
        CBT_REGION:0xCAC1,
        CBT_TILESET:0xCAC2,
        
        CODEC_MODE:0x02,
        
        CLW_ENTROPY_RLGR1:0x01,
        CLW_ENTROPY_RLGR3:0x04,
        
        CLW_COL_CONV_ICT:0x1,
        CLW_XFORM_DWT_53_A:0x1,
        CLY_CAPSET:0xCFC0,
        
        ENCRYPTION_FLAG_40BIT:0x00000001,
        ENCRYPTION_FLAG_128BIT:0x00000002,
        ENCRYPTION_FLAG_56BIT:0x00000008,
        FIPS_ENCRYPTION_FLAG:0x00000010,
        
        RNS_UD_CS_SUPPORT_ERRINFO_PDU:0x0001,
        RNS_UD_CS_WANT_32BPP_SESSION:0x0002,
        RNS_UD_CS_SUPPORT_STATUSINFO_PDU:0x0004,
        RNS_UD_CS_STRONG_ASYMMETRIC_KEYS:0x0008,
        RNS_UD_CS_UNUSED:0x0010,
        RNS_UD_CS_VALID_CONNECTION_TYPE:0x0020,
        RNS_UD_CS_SUPPORT_MONITOR_LAYOUT_PDU:0x0040,
        RNS_UD_CS_SUPPORT_NETCHAR_AUTODETECT:0x0080,
        RNS_UD_CS_SUPPORT_DYNVC_GFX_PROTOCOL:0x0100,
        RNS_UD_CS_SUPPORT_DYNAMIC_TIME_ZONE:0x0200,
        RNS_UD_CS_SUPPORT_HEARTBEAT_PDU:0x0400,
        
        
        CONNECTION_TYPE_MODEM:0x01,
        CONNECTION_TYPE_BROADBAND_LOW:0x02,
        CONNECTION_TYPE_SATELLITE:0x03,
        CONNECTION_TYPE_BROADBAND_HIGH:0x04,
        CONNECTION_TYPE_WAN:0x05,
        CONNECTION_TYPE_LAN:0x06,
        CONNECTION_TYPE_AUTODETECT:0x07,
        
        
        CHANNEL_OPTION_INITIALIZED:0x80000000,
        CHANNEL_OPTION_PRI_HIGH:0x08000000,
        CHANNEL_OPTION_PRI_MED:0x04000000,
        CHANNEL_OPTION_PRI_LOW:0x02000000,
        CHANNEL_OPTION_COMPRESS_RDP:0x00800000,
        CHANNEL_OPTION_COMPRESS:0x00400000,
        REMOTE_CONTROL_PERSISTENT:0x00100000
    }

