'use strict';
/*
 * TPKT
 */
var DataStream      = require('DataStream');


module.exports = {
	writePacket: function(packet) {
		if (packet.byteLength > 65531) throw new Error("Bad TPKT length");

		var ds = new DataStream;

		ds.writeUint8(3);
		ds.writeUint8(0);
		ds.writeUint16(4 + packet.byteLength,DataStream.BIG_ENDIAN);
		ds.writeUint8Array(new Uint8Array(packet));

		return ds.buffer;
	},
	parsePacket: function(dv) {
		if (dv.byteLength < 4) return {};

		if (dv.getUint8(0) != 3) {
			throw new Error("Bad TPKT version");
		}

		if (dv.getUint8(1) != 0) {
			throw new Error("Bad TPKT byte 2");
		}

		var packetLength = dv.getUint16(2,false);

		if (dv.byteLength < packetLength) return {};

		var o = {};

		o.payload = new DataView(dv.buffer,dv.byteOffset + 4,
			packetLength - 4);

		return o;
	}
}