'use strict';
    
	function pixel1(im,i,on){
		im.data[i] = on?255:0;
		im.data[i + 1] = on?255:0;
		im.data[i + 2] = on?255:0;
		im.data[i + 3] = 255;
	}
	function createMonoBrush(brushData){
		var c = document.createElement('canvas');
		c.width = 8;
		c.height =8;
		var ctx = c.getContext('2d');
		var im = ctx.createImageData(8,8);
		var u;
		for(var i=0;i<256;i+=32){
			u = brushData.getUint8(i/32);
			pixel1(im,224 - i + 0,u & 0x01);
			pixel1(im,224 - i + 4,u & 0x02);
			pixel1(im,224 - i + 8,u & 0x04);
			pixel1(im,224 - i + 12,u & 0x08);
			pixel1(im,224 - i + 16,u & 0x10);
			pixel1(im,224 - i + 20,u & 0x20);
			pixel1(im,224 - i + 24,u & 0x40);
			pixel1(im,224 -i + 28,u & 0x80);
		}
		ctx.putImageData(im,0,0);
		return c;
	}
	function colorTablePixel(im,i,c){
		im.data[i] 	  = c[0];
		im.data[i + 1] = c[1];
		im.data[i + 2] = c[2];
		im.data[i + 3] = c[3];
	}
	function createCompressedColorBrush(brushData,bpp){
		var c = document.createElement('canvas');
		var ctx = c.getContext('2d');
		c.width = 8;
		c.height =8;
		var im = ctx.createImageData(8,8);
		var colorTable = new Array(4);
		var color;
		switch(bpp){
			case 8:
				colorTable[0] = [brushData.getUint8(16),brushData.getUint8(16),brushData.getUint8(16),255];
				colorTable[1] = [brushData.getUint8(17),brushData.getUint8(17),brushData.getUint8(17),255];
				colorTable[2] = [brushData.getUint8(18),brushData.getUint8(18),brushData.getUint8(18),255];
				colorTable[3] = [brushData.getUint8(19),brushData.getUint8(19),brushData.getUint8(19),255];
				break;
			case 16:
				color = brushData.getUint16(16,true);
				colorTable[0] = [color & 0x001F,(color & 0x03E0) >>> 5,(color & 0xF800) >>> 10 ,255];
				color = brushData.getUint16(18,true);
				colorTable[1] = [color & 0x001F,(color & 0x03E0) >>> 5,(color & 0xF800) >>> 10 ,255];
				color = brushData.getUint16(20,true);
				colorTable[2] = [color & 0x001F,(color & 0x03E0) >>> 5,(color & 0xF800) >>> 10 ,255];
				color = brushData.getUint16(22,true);
				colorTable[3] = [color & 0x001F,(color & 0x03E0) >>> 5,(color & 0xF800) >>> 10 ,255];
				break;
			case 24:
				colorTable[0] = [brushData.getUint8(16),brushData.getUint8(17),brushData.getUint8(18),255];
				colorTable[1] = [brushData.getUint8(19),brushData.getUint8(20),brushData.getUint8(21),255];
				colorTable[2] = [brushData.getUint8(22),brushData.getUint8(23),brushData.getUint8(24),255];
				colorTable[4] = [brushData.getUint8(25),brushData.getUint8(26),brushData.getUint8(27),255];
				break;
			case 32:
				colorTable[0] = [brushData.getUint8(16),
						brushData.getUint8(17),
						brushData.getUint8(18),
						brushData.getUint8(19)];
				colorTable[1] = [brushData.getUint8(20),
						brushData.getUint8(21),
						brushData.getUint8(22),
						brushData.getUint8(23)];
				colorTable[2] = [brushData.getUint8(24),
						brushData.getUint8(25),
						brushData.getUint8(26),
						brushData.getUint8(27)];
				colorTable[4] = [brushData.getUint8(28),
						brushData.getUint8(29),
						brushData.getUint8(30),
						brushData.getUint8(31)];
				break;
			
		}
		var co,j=0;
		for(var i=0;i<16;i++){
			co= dv.getUint8(i);
			colorTablePixel(im,j,colorTable[co & 0x03]);
			j+=4;
			colorTablePixel(im,j,colorTable[(co & 0x0C) >>> 2]);
			j+=4;
			colorTablePixel(im,j,colorTable[(co & 0x30) >>> 4]);
			j+=4;
			colorTablePixel(im,j,colorTable[(co & 0xC0) >>> 6]);
			j+=4;
		}
		ctx.putImageData(im,0,0);
		return c;
	}
	function createUncompressed8(brushData){
		var c = document.createElement('canvas');
		c.width = 8;
		c.height =8;
		var ctx = c.getContext('2d');
		var im = ctx.createImageData(8,8);
		for(var i = 0; i<8; i++){
			for(var j=0; j<8;j++){
				im.data[i*j] = brushData.getUint8(i*j);
				im.data[i*j +1] = brushData.getUint8(i*j);
				im.data[i*j + 2] = brushData.getUint8(i*j);
				im.data[i*j] = 255;
			}
		}
		ctx.putImageData(im,0,0);
		return c;
	}
	function createUncompressed16(brushData){
		var c = document.createElement('canvas');
		var ctx = c.getContext('2d');
		c.width = 8;
		c.height =8;
		var im = ctx.createImageData(8,8);
		var u,j=0;
		for(var i = 0; i<imdata.data.length; i+=4){
			u = brushData.getUint16(j);
			im.data[i] 		= u & 0x001F;
			im.data[i +1] 	= (u & 0x03E0) >>> 5;
			im.data[i + 2]	= (u & 0xF800) >>> 10;
			im.data[i +3] 	= 255;
			j+=2;
		}
		ctx.putImageData(im,0,0);
		return c;
	}
	function createUncompressed24(brushData){
		var c = document.createElement('canvas');
		c.width = 8;
		c.height =8;
		var ctx = c.getContext('2d');
		var im = ctx.createImageData(8,8);
		for(var i = 0; i<brushData.byteLength; i+=3){
			im.data[i] = brushData.getUint8(i);
			im.data[i +1] = brushData.getUint8(i + 1);
			im.data[i + 2] = brushData.getUint8(i + 2);
			im.data[i +3] = 255;
		}
		ctx.putImageData(im,0,0);
		return c;
	}
	function createUncompressed32(brushData){
		var c = document.createElement('canvas');
		c.width = 8;
		c.height =8;
		var ctx = c.getContext('2d');
		var im = ctx.createImageData(8,8);
		for(var i = 0; i<brushData.byteLength; i+=4){
			im.data[i] = brushData.getUint8(i);
			im.data[i +1] = brushData.getUint8(i + 1);
			im.data[i + 2] = brushData.getUint8(i + 2);
			im.data[i +3] = brushData.getUint8(i + 3);;
		}
		ctx.putImageData(im,0,0);
		return c;
	}
	function createUncompressedBrush(brushData,bpp){
		switch(bpp){
			case 8:
				return createUncompressed8(brushData);
				break;
			case 16:
				return createUncompressed16(brushData);
				break;
			case 24:
				return createUncompressed24(brushData);
				break;
			case 32: 
				return createUncompressed32(brushData);
				break;
		}
	}
	function createBrush(brushData,bpp){
			if(bpp === 0x01){
				return createMonoBrush(brushData);
			}else if(bpp === 8){
				if(brushData.byteLength ===  20){
					return createCompressedColorBrush(brushData,bpp);
				}else{
					return createUncompressedBrush(brushData,bpp);
				}
			}else if(bpp === 16){
				if(brushData.byteLength ===  24){
					return createCompressedColorBrush(brushData,bpp);
				}else{
					return createUncompressedBrush(brushData,bpp);
				}
			}else if(bpp === 24){
				if(brushData.byteLength ===  28){
					return createCompressedColorBrush(brushData,bpp);
				}else{
					return createUncompressedBrush(brushData,bpp);
				}
			}else{//32
				if(brushData.byteLength ===  32){
					return createCompressedColorBrush(brushData,bpp);
				}else{
					return createUncompressedBrush(brushData,bpp);
				}
			}
	}
module.exports = {
		create:createBrush
	}