'use strict';
    
    var BitmapCache         = require('xrdp/cache/bitmap');
    var ColorTableCache     = require('xrdp/cache/color-table');
    var GlyphCache          = require('xrdp/cache/glyph');
    var BrushCache          = require('xrdp/cache/brush');
    
	function secondary(o){
		switch(o.orderType){
			/*
			case 0x00://TS_CACHE_BITMAP_UNCOMPRESSED
				this.BitmapCache[o.cacheIndex] = o;
				break;
			case 0x02://TS_CACHE_BITMAP_COMPRESSED
				this.BitmapCache[o.cacheIndex] = o;
				break;
			*/
			case 0x01://TS_CACHE_COLOR_TABLE
				ColorTableCache[o.cacheIndex] = o.colors;
				break;
			case 0x03://TS_CACHE_GLYPH
				GlyphCache[o.cacheIndex] = o;
				break;
			case 0x04://TS_CACHE_BITMAP_UNCOMPRESSED_REV2
				BitmapCache[o.cacheIndex] = o;
				break;
			case 0x05://TS_CACHE_BITMAP_COMPRESSED_REV2
				BitmapCache[o.cacheIndex] = o;
				break;
			case 0x07://TS_CACHE_BRUSH
				BrushCache[o.cacheEntry] = Brush.create(o.brushData,o.bpp);
				break;
			case 0x08://TS_CACHE_BITMAP_COMPRESSED_REV3
				//TODO: Persistent Bitmaps
				if(o.cacheIndex === 32767){
					BitmapCache[o.cacheId][this.BitmapCache[o.cacheId].length-1] = Bitmap.create(o.bitmap,{
						cacheId:o.cacheId,
						cacheIndex:o.cacheIndex
					});
				}else{
					BitmapCache[o.cacheId][o.cacheIndex] = Bitmap.create(o.bitmap,{
						cacheId:o.cacheId,
						cacheIndex:o.cacheIndex
					});
				}
				break;
			default:
				console.log('Unknown Secondary order type');
		}
	}
module.exports = secondary;
