'use strict';

    var DataStream      = require('DataStream');
    var settings        = require('xrdp/capability-settings');
    
    
	function decompress(dv){
		return dv;
	}
	function AlternateSecondaryDrawingOrder(){
		this.Client;
	}
	AlternateSecondaryDrawingOrder.prototype.package = function(o,dv,offset){
		o.orderClass = 0x02;
		return {
			data:o,
			dv:new DataView(dv.buffer,dv.byteOffset+offset)
		};
	}
	AlternateSecondaryDrawingOrder.prototype.switchSurface = function(dv){
		var o ={};
		var offset =1;
		o.bitmapId = dv.getUint16(offset,true);
		if(o.bitmapId !== 0xFFFF){
			if(o.bitmapId < 0 || o.bitmapId >= settings[0x0011].offscreenCacheEntries){
				throw new Error('Invalid Offscreen Bitmap Id');
			}
		}
		offset+=2;
		return this.package(o,dv,offset);
	}
	AlternateSecondaryDrawingOrder.prototype.createOffscreenBitmap = function(dv){
		var o ={};
		var offset = 1;
		var flags = dv.getUint16(offset,true);
		o.bitmapId = flags & 0x7FFF;
		if(o.bitmapId < 0 || o.bitmapId >= settings[0x0011].offscreenCacheEntries){
			throw new Error('Invalid Offscreen Bitmap Id');
		}
		offset+=2;
		o.width = dv.getUint16(offset,true);
		offset+=2;
		o.height = dv.getUint16(offset,true);
		offset+=2;
		o.deleteList = [];
		if(flags & 0x8000){
			var i = dv.getUint16(offset);
			offset+=2;
			while(i--){
				o.deleteList.push(dv.getUint16(offset));
				offset+=2;
			}
		}
		return this.package(o,dv,offset);
	}
	AlternateSecondaryDrawingOrder.prototype.streamBitmapFirst = function(dv){
		var o ={};
		var offset = 1;
		o.bitmapFlags = dv.getUint8(offset++);
		o.bitmapBpp = dv.getUint8(offset++);
		o.bitmapType = dv.getUint16(offset,true);
		offset+=2;
		o.bitmapWidth = dv.getUint16(offset,true);
		offset+=2;
		o.bitmapHeight= dv.getUint16(offset,true);
		offset+=2;
		if(o.bitmapFlags & 0x04){
			o.bitmapSize = dv.getUint32(offset,true);
			offset+=4;
		}else{
			o.bitmapSize = dv.getUint16(offset,true);
			offset+=2;
		}
		o.bitmapBlockSize = dv.getUint16(offset,true);
		offset+=2;
		if(o.bitmapFlags & 0x02){//compressed
			o.bitmapBlock = decompress(new DataView(dv.buffer,dv.byteOffset+offset,o.bitmapBlockSize));
		}else{
			o.bitmapBlock = new DataView(dv.buffer,dv.byteOffset+offset,o.bitmapBlockSize);
		}
		return this.package(o,dv,offset);
	}
	AlternateSecondaryDrawingOrder.prototype.streamBitmapNext = function(dv){
		var o ={};
		var offset = 1;
		o.bitmapFlags = dv.getUint8(offset++);
		o.bitmapType = dv.getUint16(offset,true);
		offset+=2;
		o.bitmapBlockSize = dv.getUint16(offset,true);
		offset+=2;
		o.bitmapBlock = new DataView(dv.buffer,dv.byteOffset+offset,o.bitmapBlockSize);
		return this.package(o,dv,offset);
	}
	AlternateSecondaryDrawingOrder.prototype.createNineGridBitmap = function(dv){
		var o ={};
		var offset = 1;
		o.bitmapBpp = dv.getUint8(offset++);
		o.bitmapId = dv.getUint16(offset,true);
		offset+=2;
		o.cx = dv.getUint16(offset,true);
		offset+=2;
		o.cy = dv.getUint16(offset,true);
		o.nineGridInfo = new DataView(dv.buffer,dv.byteOffset+offset,16);
		return this.package(o,dv,offset);
	}
	AlternateSecondaryDrawingOrder.prototype.drawGDIFirst = function(dv){
		var o ={};
		var offset = 2;//pad 1 octet
		o.cbSize = dv.getUint16(offset,true);
		offset+=2;
		o.cbTotalSize = dv.getUint32(offset,true);
		offset+=4;
		o.cbTotalEmfSize = dv.getUint32(offset,true);
		offset +=4;
		o.emfRecords = new DataView(dv.buffer,dv.byteOffset+offset,o.cbSize);
		return this.package(o,dv,offset);
	}
	AlternateSecondaryDrawingOrder.prototype.drawGDICacheFirst = function(dv){
		var o ={};
		var offset = 1;
		o.flags = dv.getUint8(offset);
		o.cacheType = dv.getUint16(offset,true);
		offset+=2;
		o.cacheIndex = dv.getUint16(offset,true);
		offset+=2;
		o.cbSize = dv.getUint16(offset,true);
		offset+=2;
		o.cbTotalSize = dv.getUint32(offset,true);
		offset+=4;
		o.emfRecords = new DataView(dv.buffer,dv.byteOffset+offset,o.cbSize);
		return this.package(o,dv,offset);
	}
	AlternateSecondaryDrawingOrder.prototype.drawGDINext = function(dv){
		var o ={};
		var offset = 2;//pad 1 octet
		o.cbSize = dv.getUint16(offset,true);
		offset+=2;
		o.emfRecords = new DataView(dv.buffer,dv.byteOffset+offset,o.cbSize);
		return this.package(o,dv,offset);
	}
	AlternateSecondaryDrawingOrder.prototype.drawGDICacheNext = function(dv){
		var o ={};
		var offset = 1;
		o.flags = dv.getUint8(offset);
		o.cacheType = dv.getUint16(offset,true);
		offset+=2;
		o.cacheIndex = dv.getUint16(offset,true);
		offset+=2;
		o.cbSize = dv.getUint16(offset,true);
		offset+=2;
		o.emfRecords = new DataView(dv.buffer,dv.byteOffset+offset,o.cbSize);
		return this.package(o,dv,offset);
	}
	AlternateSecondaryDrawingOrder.prototype.drawGDIEnd = function(dv){
		var o ={};
		var offset = 2;//pad 1 octet
		o.cbSize = dv.getUint16(offset,true);
		offset+=2;
		o.cbTotalSize = dv.getUint32(offset,true);
		offset +=4;
		o.cbTotalEmfSize = dv.getUint32(offset,true);
		offset +=4;
		o.emfRecords = new DataView(dv.buffer,dv.byteOffset+offset,o.cbSize);
		return this.package(o,dv,offset);
	}
	AlternateSecondaryDrawingOrder.prototype.drawGDICacheEnd = function(dv){
		var o ={};
		var offset = 1;
		o.flags = dv.getUint8(offset);
		o.cacheType = dv.getUint16(offset,true);
		offset+=2;
		o.cacheIndex = dv.getUint16(offset,true);
		offset+=2;
		o.cbSize = dv.getUint16(offset,true);
		offset+=2;
		o.emfRecords = new DataView(dv.buffer,dv.byteOffset+offset,o.cbSize);
		return this.package(o,dv,offset);
	}
	function readNewOrExistingNotifyIcons(fp,dv){
		//https://msdn.microsoft.com/en-us/library/cc242475.aspx
		var o = {};
		var ds = new DataStream(dv.buffer,dv.byteOffset);
		
		if(fp & 0x00000008){//WINDOW_ORDER_FIELD_NOTIFY_VERSION
			o.version = ds.readUint32();
			if([0,3,4].indexOf(o.version) <0){
				throw new Error('Invalid Window Order Field Notify Verison');
			}
		}
		if(fp & 0x00000001){//WINDOW_ORDER_FIELD_NOTIFY_TIP
			o.tooltip = ds.readUCS2String(ds.readUint16()/2);
		}
		if(fp & 0x00000002){//WINDOW_ORDER_FIELD_NOTIFY_INFO_TIP
			//https://msdn.microsoft.com/en-us/library/cc242473.aspx
			o.infoTip = {
				timeout:ds.readUint32(),
				infoFlags:ds.readUint32(),
				infoTipText:ds.readUCS2String(ds.readUint16()/2),
				title:ds.readUCS2String(ds.readUint16()/2)
			}
		}
		if(fp & 0x00000004){//WINDOW_ORDER_FIELD_NOTIFY_STATE
			if([0].indexOf(o.version) < 0 ){
				throw new Error('State field present when version is 0');
			}
			o.state = ds.readUint32();
		}
		if(fp & 0x40000000){//icon present
			if(fp & 0x80000000){
				throw new Error('Icon and Cached Icon Present');
			}
			o.icon = readIconInfo(new DataView(ds.buffer,ds.byteOffset + ds.position));
		}
		if(fp & 0x80000000){//cached Icon present
			o.cachedIcon = {
				cacheEntry:ds.readUint16(),
				cacheId:ds.readUint8()
			}
		}
		
		if(fp & 0x10000000){//WINDOW_ORDER_STATE_NEW
			o.newNotify = true;
		}
		return o;
	}
	function readDeletedNotifyIcons(fp,dv){
		if(dv.byteLength){
			throw new Error('Deleted window has window Orders');
		}
		return {
			window:true,
			deleted:true
		};
	}
	function readNotifyFields(fp,dv){
		if(fp & 0x20000000){
			return readDeletedNotifyIcons(fp,dv);
		}else{
			return readNewOrExistingNotifyIcons(fp,dv);
		}
	}
	
	function readDesktopFields(fp,dv){
		if(!(fp & 0x00000001)){//WINDOW_ORDER_FIELD_DESKTOP_NONE
			return readDesktopFieldsMonitored(fp,dv);
		}
		return {
			monitored:false
		};
	}
	
	function readDesktopFieldsMonitored(fp,dv){
		//https://msdn.microsoft.com/en-us/library/cc242439.aspx
		var o = {
			monitored:true
		};
		var ds = new DataStream(dv.buffer,dv.byteOffset);
		if(fp & 0x00000002){//WINDOW_ORDER_FIELD_DESKTOP_HOOKED
			o.hooked = true;
		}
		if(fp & 0x00000008){//WINDOW_ORDER_FIELD_DESKTOP_ARC_BEGAN
			if(!o.hooked){
				throw new Error('Desktop not Hooked');
			}
			o.arcBegan = true;
		}
		if(fp & 0x00000004){//WINDOW_ORDER_FIELD_DESKTOP_ARC_COMPLETED
			o.arcCompleted = true;
		}
		if(fp & 0x00000020){//WINDOW_ORDER_FIELD_DESKTOP_ACTIVEWND
			o.activeWindowId = ds.readUint32();
		}
		if(fp & 0x00000010){//WINDOW_ORDER_FIELD_DESKTOP_ZORDER
			var numWindows = ds.readUint8();
			if(numWindows){
				o.zOrderWindowIds = [];
				while(numWindows--){
					o.zOrderWindowIds.push(ds.readUint32());
				}
			}
		}
		return o;
	}
	
	function readDeletedWindowFields(fp,dv){
		if(dv.byteLength){
			throw new Error('Deleted window has window Orders');
		}
		return {
			window:true,
			deleted:true
		};
	}
	function readStyle(b,e){
		//https://msdn.microsoft.com/en-us/library/ms632600.aspx
		var s =  {
			border:(b & 0x00800000),
			caption:(b & 0x00C00000),
			child:(b & 0x40000000),
			clipChildren:(b & 0x02000000),
			clipSiblings:(b & 0x04000000),
			disabled:(b & 0x08000000),
			dlgFrame:(b & 0x00400000),
			group:(b & 0x00020000),
			hScroll:(b & 0x00100000),
			iconic:(b & 0x20000000),
			maximize:(b & 0x01000000),
			maximizeBox:(b & 0x00010000),
			minimize:(b & 0x20000000),
			minimizeBox:(b & 0x00020000),
			overlapped:(b & 0x00000000),
			popup:(b & 0x80000000),
			sizeBox:(b & 0x00040000),
			sysMenu:(b & 0x00080000),
			tabStop:(b & 0x00010000),
			visible:(b & 0x10000000),
			vScroll:(b & 0x00200000),
			acceptFiles:(e & 0x00000010),
			appWindow:(e & 0x00040000),
			clientEdge:(e & 0x00000200),
			composited:(e & 0x02000000),
			contextHelp:(e & 0x00000400),
			controlParent:(e & 0x00010000),
			dlgModalFrame:(e & 0x00000001),
			layered:(e & 0x00080000),
			layoutRtl:(e & 0x00400000),
			left:(e & 0x00000000),
			leftScrollbar:(e & 0x00004000),
			ltrReading:(e & 0x00000000),
			mdiChild:(e & 0x00000040),
			noActivate:(e & 0x08000000),
			noInheritLayout:(e & 0x00100000),
			noParentNotify:(e & 0x00000004),
			noRedirectionBitmap:(e & 0x00200000),
			right:(e & 0x00001000),
			rightScrollbar:(e & 0x00000000),
			rtlReading:(e & 0x00002000),
			staticEdge:(e & 0x00020000),
			toolWindow:(e & 0x000000800),
			topmost:(e & 0x00000008),
			transparent:(e & 0x00000020),
			windowEdge:(e & 0x00000100)
		};
		Object.defineProperty(s,'popupWindow',{
			get:function(){
				return s.popup | s.border | s.sysMenu;
			}
		});
		Object.defineProperty(s,'overlappedWindow',{
			get:function(){
				return s.overlapped | s.caption | s.sysMenu | s.sizeBox | s.minimizeBox | s.maximizeBox;
			}
		});
		Object.defineProperty(s,'paletteWindow',{
			get:function(){
				return s.windowEdge | s.toolWindow | s.topmost;
			}
		});
		Object.defineProperty(s,'exOverlappedWindow',{
			get:function(){
				return s.windowEdge | s.clientEdge;
			}
		});
		return s;
	}
	
	function readNewOrExistingWindowFields(fp,dv){
		var o = {};
		var ds = new DataStream(dv.buffer,dv.byteOffset);
		if(fp & 0x10000000){//WINDOW_ORDER_STATE_NEW
			o.newWindow = true;
		}
		if(fp & 0x00000002){//WINDOW_ORDER_FIELD_OWNER
			o.ownerWindowId = ds.readUint32();
		}
		
		o.style = {};
		if(fp & 0x00000008){//WINDOW_ORDER_FIELD_STYLE
			o.style = readStyle(ds.readUint32(),ds.readUint32());
		}
		
		if(fp & 0x00000010){//WINDOW_ORDER_FIELD_SHOW
			o.showState = ds.readUint8();
			if([0x00,//do not show
				0x02,//show window minimized
				0x03,//show window maximized
				0x05//show window in its current size and position
				].indexOf(o.showState) < 0){
				throw new Error('Invalid Window Order State');
			}
		}
		if(fp & 0x00000004){//WINDOW_ORDER_FIELD_TITLE
			o.title = ds.readUCS2String(ds.readUint16()/2);
		}
		
		if(fp & 0x00004000){//WINDOW_ORDER_FIELD_CLIENTAREAOFFSET
			o.clientOffsetX = ds.readUint32();
			o.clientOffsetY = ds.readUint32();
		}
		
		if(fp & 0x00010000){//WINDOW_ORDER_FIELD_CLIENTAREASIZE
			o.clientAreaWidth = ds.readUint32();
			o.clientAreaHeight = ds.readUint32();
		}
		
		if(fp & 0x00020000){//WINDOW_ORDER_FIELD_RPCONTENT
			o.rpContent = ds.readUint8();
			if([0x00,0x01].indexOf(o.rpContent) < 0 ){
				throw new Error('Invalid RP Content Choice');
			} 
		}
		
		if(fp & 0x00040000){//WINDOW_ORDER_FIELD_ROOTPARENT
			o.rootParentHandle = ds.readUint32();
		}
		
		if(fp & 0x00000800){//WINDOW_ORDER_FIELD_WNDOFFSET
			o.windowOffsetX = ds.readUint32();
			o.windowOffsetY = ds.readUint32();
		}
		if(fp & 0x00008000){//WINDOW_ORDER_FIELD_CLIENTDELTA
			o.windowClientDeltaX = ds.readUint32();
			o.windowClientDeltaY = ds.readUint32();
		}
		if(fp & 0x00000400){//WINDOW_ORDER_FIELD_WNDSIZE
			o.windowWidth = ds.readUint32();
			o.windowHeight = ds.readUint32();
		}
		if(fp & 0x00000100){//WINDOW_ORDER_FIELD_WNDRECTS
			var numWindowRects = ds.readUint16();
			if(numWindowRects){
				o.windowRects = [];
				while(numWindowRects--){
					o.windowRects.push([
						ds.readUint16(),
						ds.readUint16(),
						ds.readUint16(),
						ds.readUint16()
					]);
				}
			}
		}
		
		if(fp & 0x00001000){//WINDOW_ORDER_FIELD_VISOFFSET
			o.visibleOffsetX = ds.readUint32();
			o.visibleOffsetY = ds.readUint32();
		}
		if(fp & 0x00000200){//WINDOW_ORDER_FIELD_VISIBILITY
			var numVisRects = ds.readUint16();
			if(numVisRects){
				o.visibilityRects = [];
				while(numVisRects--){
					o.visibilityRects.push([
						ds.readUint16(),
						ds.readUint16(),
						ds.readUint16(),
						ds.readUint16()
					]);
				}
			}
		}
		if(fp & 0x40000000){//WINDOW_ORDER_ICON
			o.icon = true;
		}
		if(fp & 0x00002000){//WINDOW_ORDER_FIELD_ICON_BIG
			o.bigIcon = true;
		}
		if(fp & 0x80000000){//WINDOW_ORDER_CACHEDICON
			o.cachedIcon = true;
		}
		return o;
	}
	function readWindowIconFields(fp,dv){
		var o ={};
		if(fp & 0x10000000){
			o.newWindow = true;
		}
		if(fp & 0x00002000){
			o.iconBig = true;
		}
		o.icon = readIconInfo(dv);
		return o;
		
	}
	function readCachedIconFields(fp,dv){
		var o ={};
		if(fp & 0x10000000){
			o.newWindow = true;
		}
		if(fp & 0x00002000){
			o.iconBig = true;
		}
		o.cachedIcon = {
			cacheEntry:dv.getUint16(0,true),
			cacheId:dv.getUint8(2)
		}
		return o;
	}
	
	function readWindowFields(fp,dv){
		//https://msdn.microsoft.com/en-us/library/cc242476.aspx
		if(fp & 0x20000000){//WINDOW_ORDER_STATE_DELETED
			return readDeletedWindowFields(fp,dv);
		}
		if(fp & 0x80000000){
			return readCachedIconFields(fp,dv);
		}
		if(fp & 0x40000000){
			return readWindowIconFields(fp,dv);
		}
		else{
			return readNewOrExistingWindowFields(fp,dv);
		}
	}
	
	function readIconInfo(dv){
		var o = {},offset;
		var ds = new DataStream(dv.buffer,dv.byteOffset);
		o.cacheEntry = ds.readUint16();
		o.cacheId = ds.readUint8();
		o.bpp = ds.readUint8();
		o.width = ds.readUint16();
		o.height = ds.readUint16();

		var cbColorTable;
		if([1,4,8].indexOf(o.bpp) >= 0){
			cbColorTable = ds.readUint16();
		}
		var cbBitsMask = ds.readUint16();
		var cbBitsColor = ds.readUint16();
		if(cbBitsMask){
			
			o.bitsMask = ds.readUint8Array(cbBitsMask);
		}
		if([1,4,8].indexOf(o.bpp) >= 0){
			o.colorTable = ds.readUint8Array(cbColorTable);
		}
		if(cbBitsColor){
			o.bitsColor = ds.readUint8Array(cbBitsColor);
		}
		return o;
	}
	AlternateSecondaryDrawingOrder.prototype.drawWindow = function(dv){
		var o = {}
		var length = dv.getUint16(1,true);
		var fp = dv.getUint32(3,true);
		var data,offset=1;
		if(fp & 0x01000000){//WINDOW_ORDER_TYPE_WINDOW
			data = new DataView(dv.buffer,dv.byteOffset + 11,length - 11);
			o = readWindowFields(fp,data);
			offset +=11;
			o.windowId = dv.getUint32(7,true);
			o.type = 'window';
		}else if(fp & 0x02000000){//WINDOW_ORDER_TYPE_NOTIFY
			data = new DataView(dv.buffer,dv.byteOffset + 15,length - 15);
			o = readNotifyFields(fp,data);
			o.windowId =  dv.getUint32(7,true);
			o.notifyIconId = dv.getUint32(11,true);
			offset+=15
			o.type = 'notify';
		}else if(fp & 0x04000000){//WINDOW_ORDER_TYPE_DESKTOP
			data = new DataView(dv.buffer,dv.byteOffset + 7,length -7);
			o = readDesktopFields(fp,data);
			offset+=7;
			o.type = 'desktop';
		}else{
			throw new Error('Unknown Window Order Type');
		}
		o.orderType = 0x0B;
		return this.package(o,dv,length);
	}
	AlternateSecondaryDrawingOrder.prototype.compdeskFirst = function(dv){
		var o ={};
		var offset = 1;
		o.operation = dv.getUint8(offset++);
		o.size = dv.getUint16(offset,true);
		offset+=2;
		o.eventType = dv.getUint8(offset++);
		return this.package(o,dv,offset);
	}
	AlternateSecondaryDrawingOrder.prototype.frameMarker = function(dv){
		var o ={};
		var offset = 1;
		o.action = dv.getUint32(offset,true);
		offset+=4;
		return this.package(o,dv,offset);
	}
	var as = new AlternateSecondaryDrawingOrder();
	function process(dv){
		as.controlFlags = dv.getUint8(0);
		switch( (as.controlFlags & 0x0FC) >> 2){
			case 0x00:
				return as.switchSurface(dv);
				break;
			case 0x01:
				return as.createOffscreenBitmap(dv);
				break;
			case 0x02:
				return as.streamBitmapFirst(dv);
				break;
			case 0x03:
				return as.streamBitmapNext(dv);
				break;
			case 0x04:
				return as.createNineGridBitmap(dv);
				break;
			case 0x05:
				return as.drawGDIFirst(dv);
				break;
			case 0x08:
				return as.drawGDICacheFirst(dv);
				break;
			case 0x06:
				return as.drawGDINext(dv);
				break;
			case 0x09:
				return as.drawGDICacheNext(dv);
				break;
			case 0x07:
				return as.drawGDIEnd(dv);
				break;
			case 0x0A:
				return as.drawGDICacheEnd(dv);
				break;
			case 0x0B:
				return as.drawWindow(dv);
				break;
			case 0x0C:
				return as.compdeskFirst(dv);
				break;
			case 0x0D:
				return as.frameMarker(dv);
				break;
			default:
				throw new Error('Unknown Alternate Secondary Order');
		}
	}
	
module.exports = {
    process:process
}