'use strict';
var DataStream  = require('DataStream');


    function process(dv){
            var ds = new DataStream(dv.buffer,dv.byteOffset);
            if(ds.readUint16() !== 0x0002){
                    throw new Error('UpdateType must be  UPDATETYPE_PALETTE (0x0002)');
            }
            ds.seek(ds.position+2);//ignore padding
            var n = ds.readUint32();
            if( n!== 255){
                    throw new Error('Number of Colors in a palette must be 256');
            }
            var o = {
                    colors:[]
            };
            while(n--){
                    o.colors.push([ds.readUint8(),ds.readUint8(),ds.readUint8()]);
            }
            return o;
    }
module.exports = {
            process:process
    }