'use strict';
	var pointerImageCache ={};

	function createPointer(o){
		var imdata = new Uint8ClampedArray(4*o.width*o.height);
		var h=0,w=0,j=0;
		var offsetAnd =0;
		var offsetOr = (o.width*3)%2;
		var xorPixel;

		for (h=0; h<o.height; h++) {
			offsetAnd = h*(Math.floor(o.width/8) + Math.floor(o.width/8)%2);
			for(w=0;w < o.width;w++){
				xorPixel = (o.xorMaskData.getUint8(j) << 24) +
					(o.xorMaskData.getUint8(j + 1) << 16) +
					(o.xorMaskData.getUint8(j + 2) << 8) +
					(((o.xorBpp === 32)?o.xorMaskData.getUint8(j + 3):255));
				j+=(o.xorBpp === 32)?4:3;

				if (o.andMaskData.byteLength) {
					if  ( (o.andMaskData.getUint8(Math.floor(w/8) + offsetAnd)  & (0x80 >>> (w%8)) ) ) {
						if (xorPixel === 0x000000FF) { /* black -> transparent */
							xorPixel = 0x00000000;
						} else if (xorPixel === -1) {
							//xorPixel = 0xFF0000FF;
						}
					}
				}

				imdata[4*((o.height - 1 - h)*o.width + w) ]    = (xorPixel & 0xFF000000) >>> 24;
				imdata[4*((o.height - 1 - h)*o.width + w) + 1] = (xorPixel & 0x00FF0000) >>> 16;
				imdata[4*((o.height - 1 - h)*o.width + w) + 2] = (xorPixel & 0x0000FF00) >>> 8;
				imdata[4*((o.height - 1 - h)*o.width + w) + 3] = (xorPixel & 0x000000FF );

			}
			j += offsetOr;
		}
		return  imdata;
	}

	function createCanvasPointer(o){
		var canvas = document.createElement('canvas');
		canvas.height = o.height;
		canvas.width = o.width;
		var ctx = canvas.getContext('2d');
		var imdata = ctx.createImageData(o.width,o.height);
		imdata.data.set(createPointer(o));
		ctx.putImageData(imdata,0,0);
		ctx.drawImage(canvas,0,0,o.width,o.height);

		return 'url(' + canvas.toDataURL() + ') ' + (o.hotSpot[0]) +' ' + (o.hotSpot[1]) +  ' ,auto'
	}

	function pointerPosition(dv){
		return {pos:[dv.getUint16(0,true),dv1.getUint16(2,true)]};
	}
	function colorPointer(dv,xorBpp){
		var o ={
			xorBpp:xorBpp
		};
		o.cacheIndex = dv.getUint16(0,true);
		o.hotSpot = [dv.getUint16(2,true),dv.getUint16(4,true)],
		o.width = dv.getUint16(6,true);
		o.height = dv.getUint16(8,true);
		o.xorMaskData = new DataView(dv.buffer,dv.byteOffset + 14,dv.getUint16(12,true));
		o.andMaskData = new DataView(dv.buffer,dv.byteOffset + 14 + dv.getUint16(12,true),dv.getUint16(10,true));
		var pointerData = createCanvasPointer(o);
		pointerImageCache[o.cacheIndex] = pointerData;
		document.body.style.cursor = pointerData;
	}
	function newPointer(dv){
		colorPointer(new DataView(dv.buffer,dv.byteOffset + 2),dv.getUint16(0,true));//colorPtrAttr
	}
	function cachedPointer(dv){
		document.body.style.cursor = pointerImageCache[dv.getUint16(0,true)];
	}
	function pointerHidden(o){
		document.body.style.cursor = 'invalid-cursor';//set cursor to '' because none fails on firefox
	}
	function pointerDefault(o){
		document.body.style.cursor = 'default';
	}
module.exports = {
        pointerHidden:pointerHidden,
        pointerDefault:pointerDefault,
        pointerPosition:pointerPosition,
        colorPointer:colorPointer,
        newPointer:newPointer,
        cachedPointer:cachedPointer
}
