"use strict";
module.exports = (function(){
    var _frames = {};
    var _current = null;
    function FrameMarker () {};

    FrameMarker.prototype.frameBegin = function (id) {
        if(_current !== null) {
            throw new Error("FrameBegin called while still in a Frame");
        }
        if(_frames[id]){
            throw new Error("FrameBegin called multiple times on a frame");
        }
        _current = id;
        _frames[_current] = {
            id:_current,
            frameEnd:function(id,data){
            },
            data:{}
        };

    }
    FrameMarker.prototype.frameEnd = function () {
        if(_current === null){
            throw new Error("FrameEnd called outside of frame")
        }
        if(!_frames[_current]){
            throw new Error("FrameEnd called on frame that does not exist");
        }
        _frames[_current].frameEnd(_frames[_current].id,_frames[_current].data,function(id){
            delete _frames[id];
        });
        _current = null;


    }
    FrameMarker.prototype.currentFrame = function () {
        return _frames[_current];
    }
    return new FrameMarker();
})();
