var RLGR            = require('xrdp/rfx/decompress/js/RLGREncoding');
var decoder = RLGR.decoder;

var RFX = require('xrdp/rfx/decompress/js/RFXTileCompression');
var JS = (typeof SIMD === "undefined" ? new RFX.decompressor : new RFX.decompressorSIMD);

var WASM = {};
try{
    WASM = require("xrdp/rfx/decompress/wasm/wasm");
    WASM.then(function(decompress){
        WASM = decompress;
    })
    .catch(function(e){

    });
}catch(e){
    console.log(e);
}

function getEngine(d){
    switch(d){
        case "WASM":
            return WASM.decompress?WASM:JS;
        case "JS":
        default:
            return JS;
    }
}

var yArr = new Int16Array(4096);
var cbArr = new Int16Array(4096);
var crArr = new Int16Array(4096);


function tile(t,entropy,quants,decompressor){
    var yData,cbData,crData,decode;
    yData = t.yData.buffer.slice(t.yData.byteOffset,t.yData.byteOffset + t.yData.byteLength),
    cbData = t.cbData.buffer.slice(t.cbData.byteOffset,t.cbData.byteOffset + t.cbData.byteLength),
    crData = t.crData.buffer.slice(t.crData.byteOffset,t.crData.byteOffset + t.crData.byteLength)


    var imdata = new Uint8ClampedArray(16384);

    // ARLGR decode
    decode = decoder(entropy);
    decode(4096,yData,yArr);
    decode(4096,cbData,cbArr);
    decode(4096,crData,crArr);

    decompressor.decompress(
        yArr,
        cbArr,
        crArr,
        quants[t.quantIdxY],
        quants[t.quantIdxCb],
        quants[t.quantIdxCr],
        imdata
    );
    return imdata.buffer;
    /*
    postMessage({
        buffer:imdata.buffer,
        rect:o.rect,
        regions:o.regions,


        extra:o.extra
    },[imdata.buffer]);
    */
}
self.onmessage = function (e) {
    var b = tile(e.data.t,e.data.entropy,e.data.quants,getEngine(e.data.engine));
    postMessage({
        buffer:b,
        x:e.data.t.xIdx*64,
        y:e.data.t.yIdx*64,
        tileId:e.data.tileId
    },[b]);
}

module.exports = tile;
