'use strict';
/*
 * A write only bitstream in the "backward" direction.
 */


var WriteStream = require('xrdp/rfx/decompress/js/WriteStream');

var BackwardWriteStream = function() {
	this.base = WriteStream;
	this.base();
};

BackwardWriteStream.prototype = new WriteStream;

BackwardWriteStream.prototype.write = function(bits, value) {
	var needed = this.index + ((Math.max(bits - this.pending,0) + 7) >> 3) + 1;

	if (this.arr.length < needed) this.bigger(needed);

	var done = 0;

	while (bits) {
		var i = Math.min(bits,this.pending);
		var mask = ((1 << i) - 1) << done;

		this.arr[this.index] |= ((value & mask) >>> done) << (8 - this.pending);

		bits -= i;
		done += i;

		if (this.pending == i) {
			this.index++;
			this.pending = 8;
		}
		else this.pending -= i;
	}
}

module.exports = BackwardWriteStream;
