'use strict';
/*
 * A write only bitstream in the "forward" direction.
 */
    var WriteStream     = require("xrdp/rfx/decompress/js/WriteStream");

var ForwardWriteStream = function() {
	this.base = WriteStream;
	this.base();
};

ForwardWriteStream.prototype = new WriteStream;

ForwardWriteStream.prototype.write = function(bits, value) {
	var needed = this.index + ((Math.max(bits - this.pending,0) + 7) >> 3) + 1;

	if (this.arr.length < needed) this.bigger(needed);

	while (bits) {
		var tmp = value & (0xffffffff >>> (32 - bits));
		var i = Math.min(bits,this.pending);

		bits -= i;

		this.arr[this.index] |= (tmp >>> bits) << (this.pending - i);

		if (this.pending == i) {
			this.index++;
			this.pending = 8;
		}
		else this.pending -= i;
	}
}

module.exports = ForwardWriteStream;
