'use strict';
/*
 * A read only bitstream base class. 
 */
var ReadStream = function(buf) {
	this.arr = new Uint8Array(buf || 0);
	this.remaining = this.arr.length;
	this.index = 0;
	this.pending = 8;
};

ReadStream.prototype.consume = function(bits) {
	while (bits && this.remaining) {
		var i = Math.min(bits,this.pending);

		bits -= i;

		if (this.pending == i) {
			this.remaining--;
			this.index++;
			this.pending = 8;
		}
		else this.pending -= i;
	}
}

module.exports = ReadStream;