'use strict';
/*
 * A write only bitstream base class.
 */

var WriteStream = function() {
	this.arr = new Uint8Array(256);
	this.index = 0;
	this.pending = 8;
};

WriteStream.prototype.bigger = function(minLength) {
	var tmp = new Uint8Array(Math.max(minLength,this.arr.length << 1));

	tmp.set(this.arr);
	this.arr = tmp;
}

WriteStream.prototype.reset = function() {
	while (this.index) this.arr[this.index--] = 0;
	this.pending = 8;
}

Object.defineProperty(WriteStream.prototype,'byteLength',
{ get: function() { return this.index + 1; } });

Object.defineProperty(WriteStream.prototype,'buffer',
{ get: function() { return this.arr.buffer.slice(0,this.index + 1); } });

module.exports = WriteStream;