"use strict";
var Offscreen       = require("xrdp/cache/offscreen-bitmap");
var Screen          = require("xrdp/canvas/screen");

var canvas,ctx,imdata;
function begin (myCanvas) {
    canvas = myCanvas;
    ctx = canvas.getContext('2d');
    imdata = ctx.createImageData(64,64);
}
function tile (regions,rect,t) {
    imdata.data.set(new Uint8ClampedArray(t.buffer));
    regions.forEach(function(r) {
        ctx.putImageData(imdata,
            rect[0] + t.x,
            rect[1] + t.y,
            r[0] - t.x,
            r[1] - t.y,
            r[2],
            r[3]
        );
    });
}
function end (frameId) {
    Screen.canvas.getContext('2d').drawImage(Offscreen.primary().canvas,0,0);
    document.dispatchEvent(new CustomEvent('snRailUpdateWindows'));
    if(frameId){
        document.dispatchEvent(new CustomEvent('frame-acknowledge',{detail:frameId}));
    }
}
module.exports = {
    begin:begin,
    tile:tile,
    end:end
};
