"use strict";

function readSecurityHeaderBasic(dv){
    var o = {};
    o.flags = dv.getUint16(0,true);
    o.flagsHi = dv.getUint16(2,true);
    o.data = new DataView(dv.buffer,dv.byteOffset+4,dv.byteLength-4);
    return o;
}
function readSecurityHeaderNonFIPS(dv){
    var o = {};
    o.flags = dv.getUint16(0,true);
    o.flagsHi = dv.getUint16(2,true);
    o.sig = new DataView(dv.buffer,dv.byteOffset+4,8);
    o.data = new DataView(dv.buffer,dv.byteOffset+12,dv.byteLength-12);
    return o;
}
function readSecurityHeaderFIPS(dv){
        throw new Error('FIPS not implemented');
        return dv;
}
function process(dv,encryptionLevel,encryptionMethod){
    var flags = dv.getUint16(0,true);
    if(encryptionLevel === 0 || encryptionLevel === 1 && !(flags & 0x0008)){
        return readSecurityHeaderBasic(dv);
    }else if( ([0x00000001,0x00000008,0x00000002].indexOf(encryptionMethod) >= 0) && (flags & 0x0008)){
        return readSecurityHeaderNonFIPS(dv);
    }else if( (encryptionMethod === 0x00000010) && (flags & 0x0008) ){
        return readSecurityHeaderFIPS(dv);
    }else{
        console.log(flags);
        return undefined;
    }
}

module.exports = {process:process};
