'use strict';
    var slowPath    = require('xrdp/slow-path/slow-path-pdu');

    function decodeUpdate(dv){
        var o = {};
        o.updateType = dv.getUint16(0,true);
        switch(o.updateType){
                case 0x0000:
                        break;
                case 0x0001:
                        o.numberRectangles = dv.getUint16(2,true);
                        break;
        }
    }

    function decodeSynchronize(dv){
        if(dv.getUint16(0,true) !== 1){
                console.log('Invalid Synchronize Message type');
                return undefined;
        }
        //ignore target user
        return 1;
    }

    function decodeControl(dv){
        switch(dv.getUint16(0,true)){
                case 0x0001://request-control
                break;
                case 0x0002://granted-control
                //ignore contents
                break;
                case 0x0003://control-detach
                break;
                case 0x0004://control-cooperate
                //ignore contents
                break;
                default:
                console.log('Invalid Control Action');
                return undefined;
        }
        return 1;
    }
    function decodeFontMap(dv){
        return 1;
    }
module.exports = {
        init:function(userChannelId,ioChannelId,shareId,compressionType){
                slowPath.init(userChannelId,ioChannelId,shareId,compressionType);
        },
        writeRefreshRect:function(areasToRefresh){
                var buf = new ArrayBuffer(4 + areasToRefresh.length * 8);
                var dv = new DataView(buf);
                dv.setUint8(0,areasToRefresh.length);
                var rect,pos = 4;

                while(areasToRefresh.length){
                        rect = areasToRefresh.shift();
                        dv.setUint16(pos    ,rect[0],true);//left
                        dv.setUint16(pos + 2,rect[1],true);//top
                        dv.setUint16(pos + 4,rect[2],true);//right
                        dv.setUint16(pos + 6,rect[3],true);//bottom
                        pos += 8;
                }
                return slowPath.dataPdu(0x21,0x02,0x00,new Uint8Array(buf));
        },
        decodeDataPdu:function(pduType2,data){
            var o = true;
            switch(pduType2){
                    case 0x14: //control
                            if(!decodeControl(data)){ return undefined;}
                            break;
                    case 0x1F: //syncronize
                            if(!decodeSynchronize(data)){ return undefined;}
                            break;
                    case 0x28: //fontmap
                            if(!decodeFontMap(data)){return undefined;}
                            break;
                    case 0x02://update (slow path graphics update
                    case 0x1B: //pointer
                    case 0x1C: //input
                            console.log(pduType2);
                            break;
                    default:
                            console.log('unknown pduType2',pduType2);
                            return undefined;
            }
            return o;
        }
    }
