function process(dv) {
    var type = dv.getUint16(0,true);
    var i = 4;
    var o = { type: type };

    switch (type) {
    case 0x01: // capset_general
        o.osMajorType =			dv.getUint16(i,true); i += 2;
        o.osMinorType =			dv.getUint16(i,true); i += 2;
        o.protocolVersion =		dv.getUint16(i,true); i += 2;
        /* padding */			i += 2;
        o.generalCompressionTypes =	dv.getUint16(i,true); i += 2;
        o.extraFlags =			dv.getUint16(i,true); i += 2;
        o.updateCapabilityFlag =	dv.getUint16(i,true); i += 2;
        o.remoteUnshareFlag =		dv.getUint16(i,true); i += 2;
        o.generalCompressionLevel =	dv.getUint16(i,true); i += 2;
        o.refreshRectSupport =		dv.getUint8(i); i++;
        o.suppressOutputSupport =	dv.getUint8(i); i++;
        break;
    case 0x02: // capset_bitmap
        o.preferredBitsPerPixel =	dv.getUint16(i,true); i += 2;
        o.receive1BitPerPixel =		dv.getUint16(i,true); i += 2;
        o.receive4BitsPerPixel =	dv.getUint16(i,true); i += 2;
        o.receive8BitsPerPixel =	dv.getUint16(i,true); i += 2;
        o.desktopWidth =		dv.getUint16(i,true); i += 2;
        o.desktopHeight =		dv.getUint16(i,true); i += 2;
        /* padding */			i += 2;
        o.desktopResizeFlag =		dv.getUint16(i,true); i += 2;
        o.bitmapCompressionFlag =	dv.getUint16(i,true); i += 2;
        o.hightColorFlags =		dv.getUint8(i); i++;
        o.drawingFlags =		dv.getUint8(i); i++;
        o.multipleRectangleSupport =	dv.getUint16(i,true); i += 2;
        break;
    case 0x03: // capset_order
        o.terminalDescriptor = new Uint8Array(16);

        for (var n = 0; n < 16; n++) {
            o.terminalDescriptor[n] = dv.getUint8(i); i++;
        }

        /* padding */			i += 4;
        /* desktopSaveXGranularity */	i += 2;
        /* desktopSAveYGranularity */	i += 2;
        /* padding */			i += 2;
        /* maximumOrderLevel */		i += 2;
        /* numberFonts */		i += 2;
        o.orderFlags = 			dv.getUint16(i,true); i += 2;
        o.orderSupport = new Uint8Array(36);

        for (var n = 0; n < 32; n++) {
            o.terminalDescriptor[n] = dv.getUint8(i); i++;
        }

        /* textFlags */			i += 2;
        o.orderSupportExFlags =		dv.getUint16(i,true); i += 2;
        /* padding */			i += 4;
        /* desktopSaveSize */		i += 2;
        /* padding */			i += 2;
        /* padding */			i += 2;
        /* textANSICodePage */		i += 2;
        /* padding */			i += 2;
        break;
    case 0x04: // capset_bitmap_cache_rev1
        /* padding */			i += 4;
        /* padding */			i += 4;
        /* padding */			i += 4;
        /* padding */			i += 4;
        /* padding */			i += 4;
        /* padding */			i += 4;
        o.cache0Entries =		dv.getUint16(i,true); i += 2;
        o.cache0MaximumCellSize =	dv.getUint16(i,true); i += 2;
        o.cache1Entries =		dv.getUint16(i,true); i += 2;
        o.cache1MaximumCellSize =	dv.getUint16(i,true); i += 2;
        o.cache2Entries =		dv.getUint16(i,true); i += 2;
        o.cache2MaximumCellSize =	dv.getUint16(i,true); i += 2;
        break;
    case 0x05: // capset_controlType
        o.controlFlags =		dv.getUint16(i,true); i += 2;
        o.remoteDetachFlag =		dv.getUint16(i,true); i += 2;
        o.controlInterest =		dv.getUint16(i,true); i += 2;
        o.detachInterest =		dv.getUint16(i,true); i += 2;
        break;
    case 0x07: // capset_activation
        o.helpKeyFlag =			dv.getUint16(i,true); i += 2;
        o.helpKeyIndexFlag =		dv.getUint16(i,true); i += 2;
        o.helpExtendedKeyFlag =		dv.getUint16(i,true); i += 2;
        o.windowManagerKeyFlag =	dv.getUint16(i,true); i += 2;
        break;
    case 0x08: // capset_pointer
        /* colorPointerFlag */		i += 2;
        o.colorPointerCacheSize =	dv.getUint16(i,true); i += 2;
        o.pointerCacheSize =		dv.getUint16(i,true); i += 2;
        break;
    case 0x09: // capset_share
        o.nodeId =			dv.getUint16(i,true); i += 2;
        /* padding */			i += 2;
        break;
    case 0x0A: // capset_colorTable_cache
        /* colorTableCacheSize */	i += 2;
        /* padding */			i += 2;
        break;
    case 0x0C: // capset_sound
        o.soundFlags =			dv.getUint16(i,true); i += 2;
        /* padding */			i += 2;
        break;
    case 0x0D: // capset_input
        o.inputFlags =			dv.getUint16(i,true); i += 2;
        /* padding */			i += 2;
        o.keyboardLayout =		dv.getUint32(i,true); i += 4;
        o.keyboardType =		dv.getUint32(i,true); i += 4;
        o.keyboardSubtype =		dv.getUint32(i,true); i += 4;
        o.keyboarFunctionKey =		dv.getUint32(i,true); i += 4;
        o.imeFileName = new Uint16Array(31);

        for (var n = 0; n < 31; n++) {
            o.imeFileName[n] = dv.getUint16(i,true); i += 2;
        }

        break;
    case 0x0E: // capset_font
        o.fontSupportFlags =		dv.getUint16(i,true); i += 2;
        /* padding */			i += 2;
        break;
    case 0x0F: // capset_brush
        o.brushSupportLevel =		dv.getUint32(i,true); i += 4;
        break;
    case 0x10: // glyph cache
        for (var n = 0; n < 10; n++) {
            o.glyphCache[n] = {
                cacheEntries: dv.getUint16(i,true),
                cacheMaximumCellSize: dv.getUint16(i + 2,true)
            }; i += 4;
        }

        o.flagCache =			dv.getUint32(i,true); i += 4;
        o.glyphSupportLevel =		dv.getUint16(i,true); i += 2;
        /* padding */			i += 2;
        break;
    case 0x11: // capset_offscreenCache
        o.offscreenSupportLevel =	dv.getUint32(i,true); i += 4;
        o.offscreenCacheSize =		dv.getUint16(i,true); i += 2;
        o.offscreenCacheEntries =	dv.getUint16(i,true); i += 2;
        break;
    case 0x12: // capset_bitmap_cache_host_support
        o.cacheVersion =		dv.getUint8(i); i++;
        /* padding */			i++;
        /* padding */			i += 2;
        break;
    case 0x13: // capset_bitmap_cache_rev2
        o.cacheFlags =			dv.getUint16(i,true); i += 2;
        /* padding */			i++;
        o.numCellCaches =		dv.getUint8(i); i++;
        o.bitmapCache0CellInfo = {
            numEntries: dv.getUint32(i,false) >>> 1,
            k: dv.getUint32(i,false) & 0x1
        }; i += 4;
        o.bitmapCache1CellInfo = {
            numEntries: dv.getUint32(i,false) >>> 1,
            k: dv.getUint32(i,false) & 0x1
        }; i += 4;
        o.bitmapCache2CellInfo = {
            numEntries: dv.getUint32(i,false) >>> 1,
            k: dv.getUint32(i,false) & 0x1
        }; i += 4;
        o.bitmapCache3CellInfo = {
            numEntries: dv.getUint32(i,false) >>> 1,
            k: dv.getUint32(i,false) & 0x1
        }; i += 4;
        o.bitmapCache4CellInfo = {
            numEntries: dv.getUint32(i,false) >>> 1,
            k: dv.getUint32(i,false) & 0x1
        }; i += 4;
        /* padding */			i += 12;
        break;
    case 0x14: // capset_virtualChannel
        o.flags =			dv.getUint32(i,true); i += 4;
        o.vCChunkSize =			dv.getUint32(i,true); i += 4;
        break;
    case 0x15: // capset_drawninegridcache
        o.drawNineGridSupportLevel =	dv.getUint32(i,true); i += 4;
        o.drawNineGridCacheSize =	dv.getUint16(i,true); i += 2;
        o.drawNineGridCacheEntries =	dv.getUint16(i,true); i += 2;
        break;
    case 0x16: // capset_drawGDIPlus
        o.drawGDIPlusSUpportLevel =	dv.getUint32(i,true); i += 4;
        o.gdipVersion =			dv.getUint32(i,true); i += 4;
        o.drawGdiplusCacheLevel =	dv.getUint32(i,true); i += 4;
        o.gdipCacheEntries = {
            gdipGraphicsCacheEntries: dv.getUint16(i,true),
            gdipBrushCachEntries: dv.getUint16(i + 2,true),
            gdipPenCacheEntries: dv.getUint16(i + 4,true),
            gdipImageCacheEntries: dv.getUint16(i + 6,true),
            gdipImageAttributesCacheEntries: dv.getUint16(i + 8,true)
        }; i += 10;
        o.gdipCacheChunkSize = {
            gdipGraphicsCacheChunkSize: dv.getUint16(i,true),
            gdipObjectBrushCacheChunkSize: dv.getUint16(i + 2,true),
            gdipObjectPenCacheChunkSize: dv.getUint16(i + 4,true),
            gdipObjectImageAttributesCacheChunkSize: dv.getUint16(i + 6,true)
        }; i += 8;
        o.gdipImageCacheProperties = {
            gdipObjectImageCacheChunkSize: dv.getUint16(i,true),
            gdipObjectImageCacheTotalSize: dv.getUint16(i + 2,true),
            gdipObjectImageCacheMaxSize: dv.getUint16(i + 4,true)
        }; i += 6;
        break;
    case 0x17: // capset_RAIL
        o.railLevelSupported = dv.getUint32(i,true) & 0x80000000;
        o.railLevelDockedLangBarSupported = dv.getUint32(i,true) & 0x40000000;
        o.railLevelLanguageImeSyncSupported = dv.getUint32(i,true) & 0x10000000;
        i += 4;
        break;
    case 0x18: // capset_window
        o.wndSupportLevel =		dv.getUint32(i,true); i += 4;
        o.numIconCaches =		dv.getUint8(i); i++;
        o.numIconCacheEntries =		dv.getUint16(i,true); i += 2;
        break;
    case 0x19: // capset_compdesk
        o.compDeskSupportLevel =	dv.getUint16(i,true); i += 2;
        break;
    case 0x1A: // capset_multifragment_update
        o.maxRequestSize =		dv.getUint32(i,true); i += 4;
        break;
    case 0x1B:
        o.largePointerSupportFlags =	dv.getUint16(i,true); i += 2;
        break;
    case 0x1C:
        o.cmdFlags = 			dv.getUint32(i,true); i += 4;
        /* reserved */			i += 4;
        break;
    case 0x1D: // capset_bitmap_codecs
        var numCodecs = dv.getUint8(i); i++;

        o.bitmapCodecs = [];
        for (var n = 0; n < numCodecs; n++) {
            o.bitmapCodecs[n] = {};
            o.bitmapCodecs[n].codecGUID = new Uint8Array(16);

            for (var m = 0; m < 16; m++) {
                o.bitmapCodecs[n].codecGUID[m] = dv.getUint8(i); i++;
            }

            o.bitmapCodecs[n].codecId = dv.getUint8(i); i++;

            var numProps = dv.getUint16(i,true); i += 2;

            o.bitmapCodecs[n].codecProperties = new Uint8Array(numProps);

            for (var m = 0; m < numProps; m++) {
                o.bitmapCodecs[n].codecProperties[m] = dv.getUint8(i); i++;
            }
        }

        break;
    case 0x1E: // capset_frame_acknowledge
        o.maxUnacknowledgedFrameCount =	dv.getUint32(i,true); i += 4;
        break;
    default:
        console.log("Unknown Capability Set ",type);
        return undefined;
    }

    return o;
}

module.exports = {process:process};
