'use strict'

import angular from 'angular';

export default angular.module('fastx.MenuButton',[])
.factory('MenuButton',['$rootScope',function($rootScope){
	var f ={};

	f.sendKeyDown = function(e){
		e.location = e.location ||  KeyboardEvent.DOM_KEY_LOCATION_STANDARD;
		$rootScope.cb.sendKeyDown(e);
	}
	f.sendKeyUp = function(e){
		e.location = e.location ||  KeyboardEvent.DOM_KEY_LOCATION_STANDARD;
		$rootScope.cb.sendKeyUp(e);
	}
	f.keyClick = function(e){
			f.sendKeyDown(e);
			f.sendKeyUp(e);
	}
	return f;
}])
.factory('MenuButtonToggle',['MenuButton',function(MenuButton){
	var f = {};
	f.active = function(e,buttons){
		if(e){
			return {active:(e.code in buttons)};
		}
		return {active:(buttons.length > 0)};
	}
	f.set = function(e,buttons){
		if(!(e.code in buttons)){
			MenuButton.sendKeyDown(e);
			buttons[e.code] = e;
		}else{
			MenuButton.sendKeyUp(e);
			delete buttons[e.code];
		}
	}
	return f;
}])
.directive('fxTogglebutton',[function(){
	function link(scope,element,attr){
		element.on('click',function(e){
			element.toggleClass('active');
		});
	}

	return {
		link:link
	}
}])
.directive('fxPanelButton',['$compile','$http',function($compile,$http){
	function  link(scope,element,attr){
		var html = element.html();
		$http.get(attr['template']).then(function(data){
			element[0].innerHTML = '<div class="bottom-menu-panel" style="position:fixed;z-index:1005;bottom:15px" ng-show="active">' + data.data + '</div>' + html;
			element.on('click',function(e){
				e.stopPropagation();
				scope.active = ! scope.active;
			});
			var fn = $compile(element[0].innerHTML);
			var content = fn(scope);
			angular.element('html').on('click',function(){
				scope.active = false;
			});
			element.html(content);
		},function(error){})

	}
	return {
		scope:{
			active:'=?bind'
		},
		link:link
	}
}])
.factory('MouseButton',['$rootScope',function($rootScope){
	var f= {};

	f.set = function(btn){
		var i = $rootScope.mouse.indexOf(btn);
		if(i < 0){
			$rootScope.mouse.push(btn);
		}else{
			$rootScope.mouse.splice(i,1);
		}
	}
	f.clear = function(){
		$rootScope.mouse = [];
	}

	f.active = function(btn){
		return {active:($rootScope.mouse.indexOf(btn) >= 0)};
	}

	return f;
}])
