'use strict'

import angular from 'angular';

import "angular-route";

import '../cfg/cfg';
import '../clipboard/clipboard';
import '../keyboard/keyboard';
import './menu-button';
import '../share/share';


export default angular.module('fastx.Menu',[
	'ngRoute',
	'fastx.Keyboard',
	'fastx.Cfg',
	'fastx.Clipboard',
	'fastx.MenuButton',
	'fastx.xrdp.Share'
])
.run(['$rootScope',function($rootScope){
	$rootScope.mouse = [1];
	$rootScope.modifiers = {};
	$rootScope.numlock;
}])
.directive('fxPopupMenu',['$window','$timeout',function($window,$timeout){
	var show,timeout;


	function hideTimeout(view,el,pinned){
		$timeout.cancel(timeout);
		timeout = $timeout(function(){
			if(pinned){
				hideTimeout(view,el,pinned);
				return;
			}
			if(view.length){return;}
			el.addClass('hidden');
		},3000);
	}

	function link($scope,el,attr){
		$scope.view = '';
		$scope.pinned = $window.localStorage['pinned'] || window.navigator.platform === 'iPad' || ('ontouchstart' in $window);

		$(document).bind('click',function(e){
			return;
			if(el.find(e.target).length){
				return;
			}
			$scope.view ='';
			hideTimeout($scope.view,el,$scope.pinned);
		});
		el.on('mouseenter',function(){
			el.removeClass('hidden');
		});
		el.on('mouseleave',function(){
			hideTimeout($scope.view,el,$scope.pinned);
		});
		hideTimeout($scope.view,el,$scope.pinned);
	}
	return {
		link:link
	}
}])
.controller('MenuCtrl',['$scope','$rootScope','$window','$timeout',function($scope,$rootScope,$window,$timeout){
	$scope.touch = ('ontouchstart' in $window);

	$scope.menu ='';

	$scope.setView = function(v){
		if($scope.view === v){
			v = '';
		}else{
			$scope.showMenu();
		}
		$scope.view = v;
	}
	$scope.pin = function(p){
		$scope.pinned = p;
	}
	$scope.popupDelay=1000;


	$scope.showMenu = function(){
		$scope.hideMenu = false;
	};
}])
.controller('ResizeCtrl',['$scope','$rootScope','$window',function($scope,$rootScope,$window){
	$scope.resize = function(){
		document.dispatchEvent(new CustomEvent('snSendResizeRequest'));
	}
}])
