'use strict';

import angular from "angular";


export default angular.module('fastx.RailTaskbar',[])
.factory('RailTaskbar',[function(){
	var taskbar,icons = {};

	function createIcon(wnd){
		var a = document.createElement('a');
		a.className = 'rail-taskbar-icon';
		a.innerHTML = wnd.title;
		//a.title = wnd.id;
		a.addEventListener('click',function(e){
			if(wnd.hidden){
				wnd.show();
				wnd.activate();
			}else if(!wnd.active){
				wnd.activate();
				update(wnd);
			}else{
				wnd.minimize();
			}
			document.dispatchEvent(new CustomEvent('snRailUpdateWindows'));
		});
		return a;
	}
	function init(){
		taskbar = document.createElement('div');
		taskbar.className = 'rail-taskbar';
		return taskbar;
	}
	function addIcon(wnd){
		if(wnd.parent){return;}
		if(wnd.style.popup){return;}
		icons[wnd.id] = createIcon(wnd);
		taskbar.appendChild(icons[wnd.id]);
	}
	function deleteIcon(id){
		angular.element(icons[id]).remove();
		delete icons[id];
	}
	function update(wnd){
		var el = angular.element(icons[wnd.id]);
		if(el && el[0]){
			el[0].innerHTML = wnd.title;
			el.toggleClass('active',wnd.active);
		}
	}
	return {
		init:init,
		update:update,
		addIcon:addIcon,
		deleteIcon:deleteIcon

	}
}]);
