'use strict'

import angular from "angular";
import "../../lib/angular-foundation.min";

import "../../common/share/share";

export default angular.module('fastx.xrdp.Share',['mm.foundation','fastx.Share'])
.run()
.factory('ShareMenuStore',[function(){
	var users,
		chat,
		key,
		shareMenu;
	var store = {};
	Object.defineProperty(store,'users',{
		get:function(){return users;},
		set:function(u){users = u;}
	});
	Object.defineProperty(store,'chat',{
		get:function(){return chat;},
		set:function(c){chat = c;}
	});
	Object.defineProperty(store,'key',{
		get:function(){return key;},
		set:function(k){key = k;}
	});
	Object.defineProperty(store,'shareMenu',{
		get:function(){return shareMenu;},
		set:function(k){shareMenu = k;}
	});
	return store;
}])
.controller('ShareMenuBottomButton',['$scope','ShareMenuStore',
			function($scope,ShareMenuStore){
	$scope.toggleShareMenu = function(){
		ShareMenuStore.shareMenu = !ShareMenuStore.shareMenu;
	}
	$scope.view = function(){
		return ShareMenuStore.shareMenu;
	}
}])
.controller('ShareMenuCtrl',['$scope','$rootScope','ShareMenuStore',
			function($scope,$rootScope,ShareMenuStore){
		$scope.view = function(n){
			return ShareMenuStore[n];
		}
		$scope.hide = function(n){
			ShareMenuStore[n] = false;
		}
}])
.controller('SharePanelCtrl',['$scope','$rootScope','ShareMenuStore',
			function($scope,$rootScope,ShareMenuStore){
	$scope.endSharing = function(){

	}
	$scope.toggleDialog = function(n){
		ShareMenuStore[n] = ! ShareMenuStore[n];
	}

}])
.controller('ShareUsersCtrl',['$scope','$rootScope','ShareMenuStore',function($scope,$rootScope,ShareMenuStore){

	$scope.giveControl = function(e,id){
		e.preventDefault();
		e.stopPropagation();
		$rootScope.cb.sharing.grantControl(id);
	}
	$scope.kick = function(e,id){
		e.preventDefault();
		e.stopPropagation();
		$rootScope.cb.sharing.kickClient(id);
	}
}])
.controller('ShareChatCtrl',['$scope','ShareMenuStore',function($scope,ShareMenuStore){
	$scope.chatbox = function(){
		$rootScope.cb.disableInput(true);
	}
}])
.factory('createUrl',[function(){
	return function(o){
		if(o){
			var uri = btoa(JSON.stringify(o));
			return [
				window.location.protocol,
				'//',
				window.location.hostname,
				':',
				window.location.port?(window.location.port):((window.location.protocol === 'http:')?80:443),
				'/share#',
				uri
			].join('');
		}
	}
}])
.controller('ShareKeyCtrl',['$scope','Share','$rootScope','createUrl',
function($scope,Share,$rootScope,createUrl){

	$rootScope.init.then (function (){
		($scope.getKeys = function(id){
			Share.list({id:id},function(d){
				$scope.sharingEnabled = Boolean(d.keys.length);
				$scope.shareUrl = createUrl(
					Object.assign({id:id},
						d.keys.find(function(c){return c.perms.indexOf('viewer') >=0;}) ||{})
					);
				$scope.grantUrl = createUrl(
					Object.assign({id:id},
						d.keys.find(function(c){return c.perms.indexOf('granter') >=0;})|| {} )
					);
			});
		})($rootScope.fastx.id);
	});


	$scope.toggleSharing = function(n,id){
		if(n){
			Share.update({id:id,perms:['viewer']},function(d){
				$scope.shareUrl = createUrl(
					Object.assign({id:id},
						d.keys.find(function(c){return c.perms.indexOf('viewer') >=0;}) ||{})
					);
			},function(e){console.log(e)});
			Share.update({id:id,perms:['granter']},function(d){
				$scope.grantUrl = createUrl(
					Object.assign({id:id},
						d.keys.find(function(c){return c.perms.indexOf('granter') >=0;})|| {} )
					);
			},function(e){console.log(e)});
		}else{
			Share.reset({id:id});
			$scope.shareUrl = null;
			$scope.grantUrl = null;
			$scope.sharingEnabled = false;
		}
	}

}])
.controller('ShareCtrl',['$scope','XrdpShare','$modal','$location',function($scope,Share,$modal,$location){
	//var share = Share.parseKey(Share.getKeyFromUrl());
}]);
