'use strict';

import angular from 'angular';

import Hammer from "./hammer.min";

export default angular.module('fastx.Touch',[])
.factory('TouchEvents',['$rootScope',function($rootScope){
	var mousedown,cb;
	$rootScope.mouse = [1];
	$rootScope.pos = [0,0];

	function setOnScreenMouse(e){

	}
	function press(e){
		console.log(e);
	}
	function setMousePos(e){
		$rootScope.pos = $rootScope.cb.getMousePos(e);
		$rootScope.cb.sendMouseMove($rootScope.pos);
	}
	function touchMouseDown(e){
		e.preventDefault();
		e.srcEvent.stopPropagation();
		console.log(e);
		if(!mousedown){
			mousedown = true;
			setMousePos(e.pointers[0]);
			for(var i =0; i < $rootScope.mouse.length; i++){
				$rootScope.cb.sendMouseDown($rootScope.mouse[i],$rootScope.pos);
			}
			setOnScreenMouse(e.pointers[0]);
		}
	}
	function touchMouseUp(e){
		e.preventDefault();
		e.srcEvent.stopPropagation();
		mousedown = false;
		setMousePos(e.pointers[0]);
		for(var i =0; i < $rootScope.mouse.length; i++){
			cb.sendMouseUp($rootScope.mouse[i],$rootScope.pos);
		}
		setOnScreenMouse(e.pointers[0]);
	}
	function touchMouseMove(e){
		e.preventDefault();
		e.srcEvent.stopPropagation();
		setMousePos(e.pointers[0]);
		setOnScreenMouse(e.pointers[0]);
	}

	function tapEvent(e){
		e.srcEvent.stopPropagation();
		e.preventDefault();
		setMousePos(e.pointers[0]);
		for(var i =0; i < $rootScope.mouse.length; i++){
			cb.sendMouseDown($rootScope.mouse[i],$rootScope.pos);
			cb.sendMouseUp($rootScope.mouse[i],$rootScope.pos);
		}
		setOnScreenMouse(e.pointers[0]);
	}

	return function(canvas,callback){
		cb = callback;
		Hammer(canvas).on('tap',tapEvent);
		Hammer(canvas).on('panstart',touchMouseDown);
		Hammer(canvas).on('panmove',touchMouseMove)
		Hammer(canvas).on('panend',touchMouseUp)
		Hammer(canvas).on('pancancel',touchMouseUp)
	}
}])
