//#!/usr/bin/env node

require('../globals');

const path = require('path');
const http 	= require('http');
const https	= require('https');
const exec = require('child_process').exec;

var app 	 = _require('./app');
var Monitor  = _require('./common/lib/monitor'); //initialize early
var www 	 = _require('./common/lib/config/www');
var settings = _require('./common/lib/config/settings');
var Migrate  = _require('./common/lib/migrate');

Migrate();

app.set('port', www.data.port || 3000);
app.set('httpsport',  www.data.httpsport || 3443 );
app.set('sshport', settings.data.sshport || 22);


/***************** START THE SERVERS ***********************/
app.locals.sockets = {};
app.locals.servers = {};

console.log('Process: ',process.argv.join(" "));
console.log('Process pid:',process.pid);
exec('whoami',function(e,stdout,stderr){
	if(e){
		console.log(e);
		return;
	}else if(stderr){
		console.log(stderr);
		return;
	}else{
		console.log('Process started as user: ', stdout);
	}
});
var WebSocketServer = require('ws').Server;
app.server = http.createServer(app,function(c){});
app.server.on('error',function(e){
	if(e.code === 'EADDRINUSE'){
		console.log('Cannot bind to port ' +  app.get('port') + '.  Do you already have a FastX server running?');
		console.log('Exiting...');
		process.exit(1);
	}
});
app.server.listen(app.get('port'), function() {
	console.log('FastX Server listening on port ' + app.server.address().port);
	_require('./gw/lib/ws/server').initWs(app.server,app.locals,settings);

});

if(www.hasHttpsOptions(www.data)){
	app.HTTPSserver = https.createServer(www.parseHttpsOptions(www.data), app)
	.listen(app.get('httpsport'), function() {
		console.log('FastX HTTPS Server listening on port ' + app.HTTPSserver.address().port);
		_require('./gw/lib/ws/server').initWs(app.HTTPSserver,app.locals,settings);
	});
	if(!app.HTTPSserver){
		console.log("WARNING: No HTTPS server running.  All Data (including passwords) is unencrypted");
	}
}else{
	console.log("WARNING: No HTTPS server running.  All Data (including passwords) is unencrypted");
}
