var passport = require('passport');
var SamlStrategy = require('passport-saml').Strategy;

var Cache = require('./config-cache');



var authMethods = new Cache('auth-methods.json',{defaults:{
	defaultPage:'ssh',
	okta:{
		entryPoint:'',
		issuer:'',
		cert:''
	},
	ssh:{
		basic:false,
		publicKey:true,
		hidePasswordField:false
	},
	ldap:{
		connect:{
			url:'',
			tlsOptions:'',
		},
		bind:{
			dn:'',
			password:''
		},
		search:{
			base:''
		}
	}
},
mode:'0600'
});

authMethods.refresh = function(){
	if(authMethods.data.okta){
		var okta = authMethods.data.okta;
		passport.use(new SamlStrategy({
				path:'/auth/okta',
				entryPoint:okta.entryPoint,
				issuer:okta.issuer,
				cert:okta.cert,
				passReqToCallback:true
			},
			function(req,profile, done) {
				return done(null,profile);
			}));
	}
}
module.exports = authMethods;