var path = require('path');
var uuid = require('node-uuid');

var Cache = require('./config-cache');

var bookmark = new Cache('suggestions.json',{
		defaults:[],
		mode:'0644'
	});

function find(id,b){
	var i;
	for(i=0;i<b.length;i++){
		if(b[i].id === id){
			return i;
		}
	}
	return -1;
}
bookmark.find  = function (id) {
	if (!id) { return; }
	var i = find(id,this.data);
	if (i >=  0) {
		return this.data[i];
	}
}
bookmark.edit = function(b){
	if(!b.command || !b.command.length){
		throw new Error('Command is required');
	}
	var book = this.data;
	if(!b.id){
		b.id = uuid.v4();
		book.push(b);
	}else{
		var i = find(b.id,book);
		if(i < 0){
			book.push(b);
		}else{
			book[i] = b;
		}
	}
	this.data = book;
}
bookmark.remove = function(id){
	var book = this.data;
	var i = find(id,book);
	if(i >= 0){
		book.splice(i,1);
		this.data = book;
	}
}
module.exports = bookmark;
