var fs = require('fs');
var extend = require('extend');
var path = require('path');


function ConfigDirCache(dirname,o){
	this.out = [];
	this.o = o;
	this.mtime = -1,
	this.dirname = path.resolve(process.env.FX_CONFIG_PATH 
	|| path.resolve(global.FXROOTDIR,'var','config',dirname));
	this.defaults = o.defaults || ((this.o.raw)?'':{});
	
	var that = this;
	Object.defineProperty(this,'data',{
		get:function(){
			try{
				var stats; 
				try{
					stats = fs.statSync(that.dirname);
				}catch(e){
					if(e.code === 'ENOENT'){
						fs.mkdirSync(that.dirname, parseInt('0755',8));
						stats = fs.statSync(that.dirname);
					}
				}
				if(that.mtime < stats.mtime.getTime()){
					that.out = [];
					var files = fs.readdirSync(that.dirname,{encoding:'utf8'});
					var f;
					while(f = files.shift()){
						try{
							var d = JSON.parse(fs.readFileSync(path.resolve(that.dirname,f)));
						}catch(e){
							console.log(e,f);
							continue;
						}
						d.name = path.basename(f,'.json');
						d.id = d.name;
						that.out.push(d);
					}
					that.mtime = stats.mtime.getTime();
				}
				that.exists = true;
				return that.out;
			}catch(e){
				if(e.code !== 'ENOENT'){
					console.log(that.dirname,e.message);
				}else{
					
				}
				that.mtime = -1;
				that.exists = false;
				return [];
			}
		}
	});
} 
ConfigDirCache.prototype.reread = function(){
	this.mtime = -1;
	return this.data;
}
ConfigDirCache.prototype.remove = function(id){
	try{
		fs.unlinkSync(path.resolve(this.dirname,id));
		this.reread();
	}catch(e){
		if(e.code !== 'ENOENT'){
			throw e;
		}
	}
}
ConfigDirCache.prototype.edit = function(id,data,options){
	try{
		fs.writeFileSync(path.resolve(this.dirname,id),JSON.stringify(data),options || {});
		this.reread();
	}catch(e){
		console.log(e);
		if(e.code !== 'ENOENT'){
			throw e;
		}
	}
}
module.exports = ConfigDirCache;


