var fs = require('fs');
var extend = require('extend');
var path = require('path');


function Cache(file,o){
	var data = {};
	this.o = o;
	this.mtime = -1,
	this.filename = path.resolve(process.env.FX_CONFIG_PATH || path.resolve(global.FXROOTDIR,'var','config'),file);
	this.defaults = o.defaults || ((this.o.raw)?'':{});

	var that = this;
	Object.defineProperty(this,'data',{
		get:function(){
			try{
				var stats = fs.statSync(that.filename);
				if(that.mtime < stats.mtime.getTime()){
					if(!that.o.raw){
						var d = JSON.parse(fs.readFileSync(that.filename));
						if(!Array.isArray(d)){
							data = extend({},that.o.defaults,d);
						}else{
							data = d;
						}
					}else{
						data = fs.readFileSync(that.filename,{encoding:'utf8'});
					}
					that.mtime = stats.mtime.getTime();
				}
				that.exists = true;
				return data;
			}catch(e){
				if(e.code !== 'ENOENT'){
					console.log(that.filename,e.message);
				}
				that.mtime = -1;
				that.exists = false;
				return that.defaults;
			}
		},
		set:function(n){
			try{
				if(!that.o.raw){
					fs.writeFileSync(that.filename,JSON.stringify(n,null,4),{
						mode:parseInt(that.o.mode || '0600',8)
					});
				}else{
					fs.writeFileSync(that.filename,(n),{
						mode:parseInt(that.o.mode || '0600',8)
					});
				}
				data = n;
				that.mtime = -1;
			}catch(e){
				throw e;
			}
		}
	});
	if(!Array.isArray(that.data)){
		Object.defineProperty(this,'length',{
			get:function(){
				if(that.data.length){
					return that.data.length;
				}else{
					return Object.keys(that.data).length;
				}
			}
		});
	}
}
Cache.prototype.reread = function(){
	this.mtime = -1;
	return this.data;
}
Cache.prototype.unlink = function(){
	try{
		fs.unlinkSync(this.filename);
	}catch(e){
		if(e.code !== 'ENOENT'){
			throw e;
		}
	}
}
module.exports = Cache;
