var nodemailer = require('nodemailer');
var validator = require('validator');

var Cache = require('./config-cache');


var email = new Cache('email.json',{defaults:{},
mode:'0600'
});


email.send = function(emails,mailOptions,success,error){
	error = error || function(){};
	success = success || function(){};
	emails = emails || [];
	mailOptions = mailOptions || {};
	
	emails = emails.filter(function(c,i,a){
		return validator.isEmail(c);
	});
	if( !emails.length){
		error({error:{code:500,message:'Emails Required'}});
		return;
	}
	mailOptions.from = mailOptions.from || email.data.auth.user;
	mailOptions.to = emails.join(',');
	
	var transporter = nodemailer.createTransport(email.data);
	transporter.sendMail(mailOptions, function(e, i){
		if(e){
			error({error:e});
		}else{
			success(i)
		}
	});
}


// send mail with defined transport object

module.exports = email;