var path = require('path');
var fs = require('fs');

var Cache = require('./config-cache');

/* upgrade profiles for 2.3 patch */
try{
	var file= path.resolve(process.env.FX_CONFIG_PATH || path.resolve(global.FXROOTDIR,'config/'),'fastx-defaults.json');
	var d = JSON.parse(fs.readFileSync(file));
	if(!Array.isArray(d)){
		d.name = d.name || "Default Settings";
		d.id = d.id || d.name;
		d.description = d.description || "";
		fs.writeFileSync(file,JSON.stringify([d]));
	}
}catch(e){
	if(e.code !== 'ENOENT'){
		console.log(file,e.message);
	}
}
var session = new Cache('fastx-defaults.json',{
	defaults:[{
		"name":'Default Settings',
		"description":"",
		"id":'Default Settings',
		"MouseQuantum":1,
		"FPSLimit":30,
		"Compression":0,
		"FrameAcknowledgeWindow":5,
	}],
	mode:'0644'
});
module.exports = session;