var uuid = require('node-uuid');
var URL = require('url');

var Cache = require('./config-cache');
var localPool = require('../local-pool');


var network = new Cache('network.json',{
	defaults:{
		keys:{},
		rejectUnauthorized:false,
		loadBalance:'',
		enableDirectMode:false
	}
});

Object.defineProperty(network,'urlObjects',{
	get:function(){
		var urls = [];
		var i,j;
		for(i in network.data.keys){
			if(network.data.keys[i].urls && !network.data.keys[i].disableCluster){
				for(j=0;j<network.data.keys[i].urls.length;j++){
					if(network.data.keys[i].urls[j].url){
						urls.push({
							key:i,
							url:URL.parse(network.data.keys[i].urls[j].url)
						});
					}
				}
			}
		}
		return urls;
	}
});
Object.defineProperty(network,'receivers',{
	get:function(){
		var r = [];
		//if a cluster mode (default), or gateway -- can receive
		for(var i in network.data.keys){
			if(!network.data.keys[i].mode || network.data.keys[i].mode === 'gateway'){
				r.push(i)
			}
		}
		return r;
	}
});
Object.defineProperty(network,'loginEnabled',{
	get:function(){
		var n =0;
		for(i in network.data.keys){
			if(network.data.keys[i].disableCluster && network.data.keys[i].allowIncomingConnections){n++;}
		}
		if(n && (n === Object.keys(network.data.keys).length)){
			return false;
		}
		return true;
	}
});
network.isLoadBalanced = function(){
	return network.data.loadBalance;
}
module.exports = network;