var path = require('path');
var fs = require('fs');
var os = require('os');

var Cache = require('./config-cache');

var theme = {};
var defaults = {
			"debrand":false,
			"button-background":'#4682b4',
			"button-color":'#FFFFFF',
			"active-background":'#D2ECF6',
			"active-color":'#008CBA',
			"backgroundImage":"'body.png'",
			"backgroundImageRepeat":"repeat",
			"logo":"'logo.png'",
		};

var c = new Cache('theme.json',{defaults:defaults});

Object.defineProperty(theme,'data',{
	get:function(){
		return c.data;
	},
	set:function(n){
		var tempDir = path.join(os.tmpDir(), 'fastx-css-cache-' + process.pid);
		try{
			fs.unlinkSync(path.resolve(tempDir,'css','fastx.css'));
		}catch(e){
			if(e.code !== 'ENOENT'){
				console.log('failed to unlink fastx.css',e.message);
			}
		}
		try{
			fs.unlinkSync(path.resolve(tempDir,'css','common.css'));
		}catch(e){
			if(e.code !== 'ENOENT'){
				console.log('failed to unlink common.css',e.message);
			}
		}
		try{
			fs.unlinkSync(path.resolve(tempDir,'css','xrdp.css'));
		}catch(e){
			if(e.code !== 'ENOENT'){
				console.log('failed to unlink xrdp.css',e.message);
			}
		}
		c.data = n;
	}
})
theme.length = c.length;

module.exports = theme;
