module.exports = {
	communicationError:{
		error:{
			code:500,
			message:"Communication error between gateway and FastX server"
		}
	},
	directMessageFailed:{
		error:{
			code:500,
			message:"Direct Message between gateway and FastX server"
		}
	},
	localRequestFailed:{
		error:{
			code:500,
			message:"Communication error between Local Machine and Gateway"
		}
	},
	bridgeFailed:{
		error:{
			code:500,
			message:"Could not create bridge between Local Machine and Gateway"
		}
	},
	usernameRequired:{
		error:{
			code:-32016, 
			message:'Username required'
		}
	},
	usernameIncorrect:{
		error:{
			code:-32016,
			message:'Username or password incorrect'
		}
	},
	authenticationRequired:{
		error:{
			code:403,
			message:'Authentication required'
		}
	},
	permissionDenied:{
		error:{
			code:500,
			message:'Permission Denied'
		}
	},
	sessionAdminPermissionDenied:{
		error:{
			code:500,
			message:'Permission Denied: You are not an admin on the server this session is running on.'
		}
	},
	invalidParameters:{
		error:{
			code:-32602,
			message:'Invalid parameters'
		}
	},
	commandNotFound:{
		error:{
			code:-32015,
			message:'Command not found'
		}
	},
	serverNotFound:{
		error:{
			code:401,
			message:"Cannot find a server to connect to. Please check your installation"
		}
	},
	sessionNotFound:{
		error:{
			code:401,
			message:"Session Not Found"
		}
	},
	userNotFound:{
		error:{
			code:401,
			message:"User Not Found"
		}
	},
	timeout:{
		error:{
			code:500,
			message:'Timeout while waiting for response'
		}
	},
	screenshotDisabled:{
		error:{
			code:500,
			message:'Administrator has disabled screenshots'
		}
	},
	noScheduleScript:{
		error:{
			code:500,
			message:'Schedule Script not found'
		}
	},
	cannotQueueServer:{
		error:{
			code:500,
			message:'Cannot Queue message'
		}
	},
	disableSessionStart:{
		error:{
			code:500,
			message:'Starting Sessions has been disabled on this system'
		}
	},
	maxSessions:{
		error:{
			code:500,
			message:'Can not start a new session. Maximum number of Sessions reached'
		}
	},
	loginDisabled:{
		error:{
			code:500,
			message:'Logins are disabled on this system'
		}
	},
	cannotParseFile:{
		error:{
			code:500,
			message:'There was an error parsing your json file'
		}
	},
	cannotWriteFile:{
		error:{
			code:500,
			message:'There was an error writing your json file'
		}
	},
	sudoDisabled:{
		error:{
			code:500,
			message:'Sudo user is not enabled on this system'
		}
	}
}