var ldap = require('ldapjs');

var LDAP = require('../config/auth-methods').data.ldap;


function LdapClient(errCB){
	try{
		this.client = ldap.createClient(LDAP.connect);
		this.bind();
		this.client.on('error',function(e){
			errCB = errCB || function(){};
			errCB(e);
		});
	}catch(e){
	}
}
LdapClient.prototype.bind = function(){
	this.client.bind(LDAP.bind.dn,LDAP.bind.password,function(err){
		
	});
}
LdapClient.prototype.search = function(filter,cb){
	cb = cb || function(){};
	if(!this.client){
		cb({});
		return;
	}
	var o;
	try{
		this.client.search(LDAP.search.path || LDAP.bind.dn,{
			scope:'sub',
			filter:filter,
			sizeLimit:1,
		},function(err,res){
			console.log('error');
			if(err){
				console.log(err.stack);
				cb();
				return;
			}
			res.on('searchEntry', function(entry) {
				o = entry.object;
			});
			res.on('error', function(err) {
				console.error('ldap search error',err.message);
				cb();
			});
			res.on('end', function(result) {
				cb(o);
			});
		});
	}catch(e){
		console.log(e);
		cb({});
	}
}
module.exports = LdapClient;
	