var network 	= require('../config/network');
var Session 	= require('../config/session');
var Settings 	= require('../config/settings');
var Defaults 	= require('../config/fastx-defaults');
var Motd 		= require('../config/motd');

function convertNetwork(network){
	var d = network.data;
	if(typeof d.loadBalance === 'string'){
		d.loadBalance = {
			metric:d.loadBalance,
			desc:false
		}
	}
	for(var i in d.keys){
		if(d.keys[i].hasOwnProperty("allowIncommingConnections")){
			d.keys[i].allowIncomingConnections = d.keys[i].allowIncommingConnections;
			delete d.keys[i].allowIncommingConnections;
		}
	}
	network.data  = d;
}
function convertSettings(){
	if(Session.data.maxSessions){
		var s = Settings.data;
		s.maxSessions = Session.data.maxSessions;
		Settings.data = s;
	}
}
function convertSession(){
	if(!Session.data.session){
		Session.data = {
			session:Session.data,
			schedule:{
				filename:Session.data.scheduleScript
			}
		}
	}
}
function convertMotd(){
	if(Motd.data.beforeLogin){
		Motd.data = {
			motd:Motd.data.beforeLogin
		}
	}
}


function migrate(){
	convertNetwork(network);
	convertSettings();
	convertSession();
	convertMotd();
}
module.exports = migrate;





