var localPool = require('../local-pool');
var sessions = {};
var responses = {};
var timers = {};

function create(id){
	if(!sessions[id]){
		sessions[id] = [];
	}
}

function queueMessage(id,o){
	create(id);
	sessions[id].push(o);
	send(id);
}
function getMessages(id){
	create(id);
	var msg = sessions[id];
	sessions[id] = [];
	return msg;
}
function cleanup(id){
	delete sessions[id];
}
function storeTimers(id){
	if(!timers[id]){
		timers[id] = [];
	}
	timers[id].push(setTimeout(function(){send(id);},10000));
}
function clearTimers(id){
	var t;
	if(!timers[id]){return;}
	while(t = timers[id].shift()){
		clearTimeout(t);
	}
}
function store(id,res){
	if(responses[id]){
		send(id);
		clearTimers(id);
	}
	responses[id] = res;
	storeTimers(id);
}
function send(id){
	if(responses[id]){
		var m = getMessages(id);
		responses[id].json(m);	
	}
	delete responses[id];
}
module.exports = {
	queueMessage:queueMessage,
	store:store,
	cleanup:cleanup
};
