var Network 	= _require('common/lib/config/network');
var LocalPool 	= _require('common/lib/local-pool');

function LoadBalancer(pool){
	this.pool = pool;
}
LoadBalancer.prototype.selectServer = function(method,desc){
	switch(method){
		case 'random':
			return random(this.pool);
			break;
		case 'sessions':
			return sessions(this.pool);
			break;
		case 'local':
			break;
		default:
			return custom(this.pool,method,desc);
			break;
			//return nothing -- queue local
	}
}
function random(pool){
	var items = Object.keys(pool);
	if(!Network.loginEnabled){
		var i = items.indexOf(LocalPool.serverId);
		if(i >=0){
			items.splice(i,1);
		}
	}
	return items[Math.floor(Math.random()*items.length)];
}
function sessions(pool){
	var i;
	var arr = Object.keys(pool);
	if(!Network.loginEnabled){
		i= arr.findIndex(function(c,t,a){
			return c === LocalPool.serverId;
		});
		if(i>=0){
			arr.splice(i,1);
		}
	}
	arr.sort(function(a,b){
		return pool[a].data.sessions.length - pool[b].data.sessions.length;
	});
	return arr[0];
}
function custom(pool,metric,desc){
	var i;
	var arr = Object.keys(pool);
	if(!Network.loginEnabled){
		i= arr.findIndex(function(c,t,a){
			return c === LocalPool.serverId;
		});
		if(i>=0){
			arr.splice(i,1);
		}
	}
	arr = arr.filter(function(c){
		if(!pool[c].data.server.hasOwnProperty('metrics')){return;}
		return (pool[c].data.server.metrics.hasOwnProperty(metric) && (typeof pool[c].data.server.metrics[metric]) === 'number');
	});
	if(!arr.length){
		return;
	}
	arr.sort(function(a,b){
		return pool[a].data.server.metrics[metric] - pool[b].data.server.metrics[metric];
	});
	return desc?arr[0]:arr[arr.length-1];
}
module.exports.LoadBalancer = LoadBalancer;
