const equal = require('equals');
function Pool(pool){
	this.pool = pool || {};
	this.expireTimes = {};
}
Pool.prototype.create = function(o){
	if(!this.pool[o.id]){
		this.pool[o.id] = {
			serverPool:o.serverPool,
			serverId:o.serverId,
			data:o.data,
		};
		return true;
	}
}
Pool.prototype.update = function(o){
	if(!o.id){return;}
	var updated;
	
	updated = this.create(o);
	if(o.serverPool){
		this.pool[o.id].serverPool = o.serverPool;
	}
	if(o.serverId){
		this.pool[o.id].serverId = o.serverId;
	}
	if(o.data){
		if(equal(this.pool[o.id].data,o.data) && !updated){
			return false;
		}else{
			this.pool[o.id].data = o.data;
			return true;
		}
	}
	return updated;
}


Pool.prototype.getServerIdById = function(id){
	if(this.pool[id]){
		return this.pool[id].serverId;
	}
}
Pool.prototype.get = function(id){
	return this.pool[id];
}

Pool.prototype.isEqual = function(id,obj){
	return equal(this.pool[id],obj);
}
Pool.prototype.getListByServerId = function(serverId){
	var keys = Object.keys(this.pool);
	var l =[];
	for(var i=0; i< keys.length; i++){
		if(this.pool[keys[i]].serverId === serverId){
			l.push(this.pool[keys[i]]);
		}
	}
	return l;
}
Pool.prototype.getIdsByServerId = function(serverId){
	var keys = Object.keys(this.pool);
	var l =[];
	for(var i=0; i< keys.length; i++){
		if(this.pool[keys[i]].serverId === serverId){
			l.push(keys[i]);
		}
	}
	return l;
}
Pool.prototype.delete = function(id){
	delete this.pool[id];
}
Pool.prototype.deleteByServerId = function(serverId){
	var keys = Object.keys(this.pool);
	for(var i=0; i< keys.length; i++){
		if(this.pool[keys[i]].serverId === serverId){
			delete this.pool[keys[i]];
		}
	}
}
Pool.prototype.expires = function(id,timeout,cb){
	if(!this.pool[id]){return;}
	cb = cb || function(){};
	clearTimeout(this.expireTimes[id]);
	var pool = this.pool;
	var times = this.expireTimes;
	this.expireTimes[id] = setTimeout(function(){
		cb(id);
		delete pool[id];
		delete times[id];
		},timeout);
}
module.exports.Pool = Pool;