var ServerPool = require('./pool').Pool;
var LoadBalancer = require('./load-balance/load-balance').LoadBalancer;
var localPool = require('../../local-pool');

var messageStore = {};

function createMessageStore(serverId){
	if(!messageStore[serverId]){
		messageStore[serverId] = {
			data:[]
		};
	}
}
ServerPool.prototype.queueMessage = function(serverId,o){
	createMessageStore(serverId);
	messageStore[serverId].data.push(o);
	localPool.ee.emit('snServerMessageQueued',serverId);
}
ServerPool.prototype.delegateMessages = function(serverId){
	if(serverId){
		createMessageStore(serverId);
		var d = messageStore[serverId].data;
		messageStore[serverId].data = [];
	}
	return d || [];
}
ServerPool.prototype.hasMessages = function(serverId){
	createMessageStore(serverId);
	return (messageStore[serverId].data.length > 0);
}


ServerPool.prototype.getServerId = function(id){
	return this.getServerIdById(id);
}
ServerPool.prototype.getServer = function(id){
	return this.pool[id];
}
ServerPool.prototype.getLeastLoadedServer = function(method,desc){
	var lb = new LoadBalancer(this.pool);
	return lb.selectServer(method,desc);
}
ServerPool.prototype.setCommunicationMethod = function(id,type){
	if(this.pool[id]){
		this.pool[id].communicationMethod = type;
	}
}
ServerPool.prototype.getServers = function(){
	return this.pool;
}

module.exports.ServerPool = ServerPool;
