var SessionPool = require('./pool').Pool;

SessionPool.prototype.updateSessions = function(o){
	var s,ids=[],changed;

	for(var i =0; i<o.sessions.length;i++){
		s = {
			id:o.sessions[i].id,
			serverPool:o.serverPool,
			serverId:o.serverId,
			data:o.sessions[i]
		};
		changed = changed || this.update(s);
		if(s.id){
			ids.push(s.id);
			this.expires(s.id,45000);
		}
	}
	for(var i in this.pool){//merge
		if(this.pool[i].serverId === o.serverId && ids.indexOf(i) < 0){
			delete this.pool[i];
			changed = true;
		}
	}
	return changed;
}
SessionPool.prototype.getSessions = function(query){
	var that = this;
	return (Object.keys(that.pool).filter(function (c) {
		return Object.keys(query || {}).every(function(i){
			return (that.pool[c].data.hasOwnProperty(i) && that.pool[c].data[i] === query[i]) ||
				(that.pool[c].data.hasOwnProperty("params") && that.pool[c].data.params[i] === query[i]);
		});
	})).map(function(c){
		return Object.assign({
			serverId:that.pool[c].serverId
		},that.pool[c].data);
	});
}

SessionPool.prototype.getSession = function(id){
	return this.pool[id];
}
SessionPool.prototype.userOwnsSession = function(username,id){
	if(!this.pool[id]){return false;}
	return (this.pool[id].data.login === username);
}
SessionPool.prototype.getSessionsByUserId= function(userId,serverId){
	var s,sessions = [];
	for(s in this.pool){
		if(this.pool[s].data.userId === userId){
			if(!serverId){
				sessions.push(this.pool[s].data);
			}else if(serverId === this.pool[s].serverId){
				sessions.push(this.pool[s].data);
			}
		}
	}
	return sessions;
}
module.exports.SessionPool = SessionPool;
