var extend 		= require('extend');
var uuid 		= require('node-uuid');
var ERROR 		= require('../error-responses');
var localPool 	= require('../local-pool');


function Response(){
	this.responses = {};
}
Response.prototype.storeRemote = function(msgId,serverId){
	return remote[msgId] = {serverId:serverId};
}
Response.prototype.store = function(o,serverId){
	if(!o.res){return;}
	var that = this;
	o.msgId = uuid.v4();
	that.responses[o.msgId] = {
		res:o.res,
		resData:o.resData,
		cb:o.cb,
		expires:setTimeout(function(){
			if(that.responses[o.msgId]){
				if(!that.responses[o.msgId].res.headersSent){
					that.responses[o.msgId].res.json(ERROR.timeout);
				}
				delete that.responses[o.msgId];
			}
		},30000)
	};
	delete o.res;
	delete o.resData;
	delete o.cb;
	return o.msgId;
}
Response.prototype.send = function(id,data){
	if(this.responses[id]){
		if(this.responses[id].resData && data.result){
			this.responses[id].resData;
			extend(data.result,this.responses[id].resData);
		}
		if(this.responses[id].cb){
			this.responses[id].cb(data);
		}
		if(!this.responses[id].res.headersSent){
			this.responses[id].res.json(data);
		}
		this.deleteMessage(id);
	}
}

Response.prototype.deleteMessage = function(id){
	if(this.responses[id]){
		clearTimeout(this.responses[id].expires);
		delete this.responses[id];
	}
}
module.exports.Response = Response;
