const exec = require('child_process').exec;
const fs = require('fs');
const Q = require('q');


const ERROR = _require('common/lib/error-responses');

function systemLog(timeout){
	var q = Q.defer();
	var read;
	timeout = timeout || 20000;
	
	setTimeout(function(){
		if(!read){
			q.reject(ERROR.timeout);
		}
		read = true;
	},timeout);
	fs.readlink(['/proc/',process.pid,'/fd/1'].join(''),function(err,linkStr){
		if(err){
			if(!read){
				q.reject({error:e});
				read = true;
			}
		}else{
			if(linkStr.match(/socket:/)){
				exec('journalctl -u fastx.service',{timeout:20000},function(err,stdout,stderr){
					if(!read){
						if(err){
							q.reject({error:err});
						}else if(stderr){
							q.reject({error:{message:stderr}});
						}else{
							q.resolve({result:{file:'journalctl -u fastx.service',text:stdout}});
						}
						read = true;
					}
				});
			}else if(linkStr === '/dev/tty'){
				if(!read){
					q.reject({error:{
						message:'Cannot get log file. Your current logs are written to stdout'
					}});
					read = true;
				}
			}else{
				fs.readFile(linkStr,{encoding:'utf8'},function(e,text){
					if(!read){
						if(e){
							q.reject({error:e});
							return;
						}else{
							q.resolve({result:{
								file:linkStr,
								text:text
							}});
						}
						read = true;
					}
				});
			}
			
		}
	});
	return q.promise;
}

module.exports = systemLog;

