var uuid = require('node-uuid');
var path = require('path');

var ERROR 		= _require('common/lib/error-responses');
var Monitor 	= _require('common/lib/monitor');
var Profile 	= _require('common/lib/config/profile');
var Session 	= _require('common/lib/config/session');
var Suggestion 	= _require('common/lib/config/bookmark');
var History 	= _require('common/lib/config/user-history');
var Bookmark 	= _require('common/lib/config/user-bookmark');
var Settings  	= _require('common/lib/config/settings');
var createParamString = _require('common/lib/create-param-string');

const  apiPath = path.resolve(global.FXROOTDIR,'api/');

function bookmarkFindOne(id,b){
	return b.findIndex(function(c,i,a){
		return id === c.id;
	});
}


function UserExec(user,home){
	this.home = home;
	this.user = user;
	this.bookmarks = new Bookmark(this.home);
	this.history = new History(this.home);
}

UserExec.prototype.bookmarkList = function(r){
	Monitor.sendResponse(r.msgId,{result:{
		bookmarks:this.bookmarks.data,
		history:this.history.data,
		suggestions:Suggestion.data
	}});
}
UserExec.prototype.bookmarkEdit = function(r){
	var b = this.bookmarks.data;
	if(!r.data.command){
		Monitor.sendResponse(r.msgId,ERROR.invalidParameters);
		return;
	}
	var i = bookmarkFindOne(r.data.id,b);
	if(i >=0){
		b[i] = r.data;
	}else{
		r.data.id = uuid.v4();
		b.push(r.data);
	}
	this.bookmarks.data = b;
	this.bookmarkList(r);
}
UserExec.prototype.bookmarkDelete = function(r){
	var b = this.bookmarks.data;
	var i;
	do{
		i = bookmarkFindOne(r.data.id,b);
		if(i >= 0){
			b.splice(i,1);
		}
	}while(i >=0);
	this.bookmarks.data = b;
	b = this.history.data;
	do{
		i = bookmarkFindOne(r.data.id,b);
		if(i >= 0){
			b.splice(i,1);
		}
	}while(i>=0);
	this.history.data = b;
	this.bookmarkList(r);
}
module.exports = UserExec;