var mkdirp = require('mkdirp');
var uuid = require('node-uuid');
var path = require('path');

var UserExec 	= require('./auth/user-exec');

var ERROR 		= _require('common/lib/error-responses');
var localPool 	= _require('common/lib/local-pool');
var Monitor 	= _require('common/lib/monitor');




function sanitize(str){
	if(typeof str === 'string'){
		return "'" + str.replace(/\'/g,"\'\\\'\'") + "'";
	}else{
		return str;
	}
}
function createUser(profile){
	var home = path.resolve(global.FXROOTDIR,'var/virtual-store/users/',profile.login);
	try{
		mkdirp.sync(home,{
			mode:'0755'
		});
		var token = uuid.v4();
		Monitor.createUser({
			id:token,
			serverId:localPool.serverId,
			serverPool:localPool.serverKey,
			data:{
				token:token,
				login:profile.login,
				userId:profile.login,
				authType:profile.provider,
				firstName:profile.firstName,
				lastName:profile.lastName,
				email:profile.email,
				virtualUser:true
			}
		});
		var u = Monitor.getUser(token);
		Monitor.authenticated(token);
		Monitor.loggedIn(token);
		Monitor.broadcastUsers();
		return u;
	}catch(e){
		console.log(e.stack);
	}
}
function VirtualUser(profile){
	this.user = createUser(profile);
	return this.user;
}
module.exports = VirtualUser