var WebSocketServer = require('ws').Server;
var Url = require('url');

var Monitor 	= _require('common/lib/monitor');
var Network 	= _require('common/lib/config/network');
var Admin 		= _require('common/lib/config/admin');
var localPool 	= _require('common/lib/local-pool');
var ERROR 		= _require('common/lib/error-responses');

var users = {};

localPool.ee.on('snSessionUpdated',function(s){
	s.data.serverId = s.serverId;
	for(var i in users){
		try{
			for(var j=0; j< users[i].ws.length;j++){
				users[i].ws[j].send(JSON.stringify({result:{id:s.id,data:s.data}}));
			}
		}catch(e){
			console.log(e);
		}
	}
});
localPool.ee.on('snSessionDeleted',function(s){
	for(var i in users){
		try{
			for(var j=0; j< users[i].ws.length;j++){
				users[i].ws[j].send(JSON.stringify({result:{id:s.id}}));
			}
		}catch(e){
			console.log(e);
		}
	}
});
localPool.ee.on('snDeleteUser',function(data){
	delete users[data.token];
});

exports.list = function(o){
	var wsserver = new WebSocketServer(o);
	wsserver.on('connection',function(ws){
		var q= (Url.parse(ws.upgradeReq.url,true)).query;
		if(!q){
			ws.close(1000,"Cannot parse data. Closing");
			return;
		}
		try{
			var u = Monitor.getUserByToken(q.token);
			if(!u){
				ws.send(JSON.stringify(ERROR.userNotFound));
				ws.close(1000);
				return;
			}
			if(!Monitor.isAdmin(q.token)){
				ws.send(JSON.stringify(ERROR.permissionDenied));
				ws.close(1000);
				return;
			}
			if(!users[q.token]){
				users[q.token] = {
					ws:[]
				}
			}
			var l = users[q.token].ws.length;
			users[q.token].ws.push(ws);
			var sessions = Monitor.getSessions();
			while(s = sessions.shift()){
				try{
					ws.send(JSON.stringify({result:{id:s.id,data:s}}));
				}catch(e){

					console.log("admin-session",e);
				}
			}

			ws.on('message',function(msg){


			});
			ws.on('close',function(msg){
				if(users[q.token]){
					users[q.token].ws.splice(l,1);
				}
			});
			ws.on('error',function(e){
				console.log("admin session error",e);
			});

		}catch(e){
			ws.close(1000,e.message);
			return;
		}


	});
	return wsserver;
}
