var WebSocketServer = require('ws').Server;
var Url = require('url');

var Monitor 	= _require('common/lib/monitor');
var Network		= _require('common/lib/config/network');
var localPool 	= _require('common/lib/local-pool');
var ERROR 		= _require('common/lib/error-responses');

var users = {};

localPool.ee.on('snSessionUpdated',function(s){
	if(users[s.data.login]){
		s.data.serverId = s.serverId;
		for(var i  in users[s.data.login].ws){
			try{
				users[s.data.login].ws[i].send(JSON.stringify({result:{id:s.id,data:s.data}}));
			}catch(e){
				console.log(e.stack);
			}
		}
	}

});
localPool.ee.on('snSessionDeleted',function(s){
	if(users[s.data.login]){
		for(var i in users[s.data.login].ws){
			try{
				users[s.data.login].ws[i].send(JSON.stringify({result:{id:s.data.id}}));
			}catch(e){
				console.log(e.stack);
			}
		}
	}
});
localPool.ee.on('snDeleteUser',function(data){
	delete users[data.login];
});
exports.list = function(o){
	var wsserver = new WebSocketServer(o);
	wsserver.on('connection',function(ws){
		var q= (Url.parse(ws.upgradeReq.url,true)).query;
		if(!q){
			ws.close(1000,"Cannot parse data. Closing");
			return;
		}
		try{
			if(!q.token){
				console.log('token not sent ws/list');
				ws.send(JSON.stringify(ERROR.userNotFound));
				ws.close(1000);
				return;
			}
			var u = Monitor.getUserByToken(q.token);
			if(!u){
				console.log('Could not find user in ws/list');
				ws.send(JSON.stringify(ERROR.userNotFound));
				ws.close(1000);
				return;
			}
			if(!users[u.data.login]){
				users[u.data.login] = {
					ws:{}
				};
			}
			users[u.data.login].ws[q.token] = ws;
			var sessions,s;
			if(Network.isLoadBalanced()){
				sessions = Monitor.getSessions({login:u.data.login});
			}else{
				sessions = (Monitor.getLocalSessions()).filter(function(s){return s.login === u.data.login;});
			}
			while(s = sessions.shift()){
				try{
					ws.send(JSON.stringify({result:{id:s.id,data:s}}));
				}catch(e){
					console.log(e.stack);
				}
			}

			ws.on('message',function(msg){
			});
			ws.on('close',function(msg){
				try{
					if(users[u.data.login] && users[u.data.login].ws[q.token]){
						delete users[u.data.login].ws[q.token];
					}
				}catch(e){
					console.log(e.stack);
				}
			});
			ws.on('error',function(e){
				console.log(e);
			});


		}catch(e){
			console.log(e.stack);
			ws.close(1000,e.message);
			return;
		}
	});
	return wsserver;
}
