
const URL = require("url");



function initWs (server,locals,settings) {
    const adminServer = _require('./gw/lib/ws/admin-server').list({noServer:true});
    const adminSession = _require('./gw/lib/ws/admin-session').list({noServer:true});
    const bridge = _require('./gw/lib/ws/ws-gw').bridge({noServer:true},locals.sockets,settings.keepAliveInterval);
    const list = _require('./gw/lib/ws/list').list({noServer:true});
    const connect = _require('./gw/lib/ws/ws-connect').connect({noServer:true},locals.sockets,settings.keepAliveInterval);
    const cluster = _require('./gw/lib/ws/cluster').Server({noServer:true},locals);
    const windows = _require('./gw/lib/ws/ws-windows').windows({noServer:true});
    const xrdp = _require('./gw/lib/ws/ws-direct').connect({noServer:true});

    server.on("upgrade", (request, socket, head) => {
        var pathname = URL.parse(request.url).pathname;
        switch (pathname) {
            case "/api/admin/server":
                adminServer.handleUpgrade(request, socket, head, (ws) => {
                    adminServer.emit('connection', ws);
                });
                break;
            case "/api/admin/session":
                adminSession.handleUpgrade(request, socket, head, (ws) => {
                    adminSession.emit('connection', ws);
                });
                break;
            case "/api/list":
                list.handleUpgrade(request, socket, head, (ws) => {
                    list.emit('connection', ws);
                });
                break;
            case "/bridge":
                bridge.handleUpgrade(request, socket, head, (ws) => {
                    bridge.emit('connection', ws);
                });
                break;
            case "/connect":
                connect.handleUpgrade(request, socket, head, (ws) => {
                    connect.emit('connection', ws);
                });
                break;
            case "/server":
                cluster.handleUpgrade(request, socket, head, (ws) => {
                    cluster.emit("connection", ws);
                });
                break;
            case "/windows":
                windows.handleUpgrade(request, socket, head, (ws) => {
                    windows.emit('connection', ws);
                });
                break;
            case "/xrdp":
                xrdp.handleUpgrade(request, socket, head, (ws) => {
                    xrdp.emit('connection', ws);
                });
                break;
            default:
                socket.destroy();
        }
    });
}
module.exports = {
    initWs:initWs
};
