var WebSocketServer = require('ws').Server;
var URL 			= require('url');
var extend			= require('extend');
var uuid 			= require('node-uuid');

var fxws = require('./ws');

var Monitor = _require('common/lib/monitor');

function decode(query){
	var q = new Buffer(query,'base64');
	return JSON.parse( q.toString());
}
function findSession(o,ws,sockets){
	var s = Monitor.getSession(o.id);
	var bridgeId = uuid.v4().replace(/-/g,'');

	if(!s || Monitor.isLocalServerId(s.serverId)){
			fxws.direct(ws,o.port);
	}else if(Monitor.queueSession(o.id,{
		action:'bridge',
		noResponse:true,
		data:{
			port:o.port,
			bridgeId:bridgeId
		}
	})){
		ws.pause();//wait
		var timeout = setTimeout(function(){
			fxws.ee.removeListener('snBridge',listener);
			ws.close(1000,"Timeout while creating bridge");
		},60000);

		var listener = function(e){
			if(e.id === bridgeId){
				clearTimeout(timeout);
				ws.resume();
				sockets[e.id].browser = ws;
				fxws.bridge.browser(sockets[e.id]);
				fxws.ee.removeListener('snBridge',listener);
			}
		}
		fxws.ee.on('snBridge',listener);

	}else{
		ws.close(1000,"Failed to create connection. Closing");
	}
}


exports.connect = function(o,sockets,keepAlive){
	var wsserver = new WebSocketServer(o);
	wsserver.on('connection',function(ws){
		var q= ws.upgradeReq.url.split('?');
		if(!q[1]){
			ws.close(1000,"Cannot parse data. Closing");
			return;
		}
		try{
			findSession(decode(q[1]),ws,sockets);
		}catch(e){
			ws.close(1000,e.message);
			return;
		}
		if(keepAlive){
			setInterval(function(){
				ws.ping();
			},keepAlive * 1000);
		}
	});
	return wsserver;
}
