var URL = require('url');
var WebSocketServer = require('ws').Server;

var bridge = require('./ws').bridge;
var ee = require('./ws').ee;

/*
 * WebSocket connection established by the Xrdp Server
 */
exports.bridge = function(o,sockets,keepAlive){
	var wsserver = new WebSocketServer(o);
	wsserver.on('connection',function(ws){
		var q = URL.parse(ws.upgradeReq.url,true).query;
		if(!q['bridge']){
			ws.close();
			return;
		}
		sockets[q['bridge']] = {rdp:ws};
		bridge.server(sockets[q['bridge']]);
		ee.emit('snBridge',{
			id:q['bridge']
		});
		if(keepAlive){
			setInterval(function(){
				ws.ping();
			},keepAlive * 1000);
		}
	});
	return wsserver;
}

/*
 * WebSocket Connection established by the browser client
 * Bridge from the Browser to the Proxy
 */
exports.browserConnection = function(o,sockets){
	var wsserver = new WebSocketServer(o);
	wsserver.on('connection',function(ws){
		var q = URL.parse(ws.upgradeReq.url,true).query;
		if(!sockets[q['bridge']]){ //find the socket
			ws.close();
			return;
		}
		sockets[q['bridge']].browser = ws;
		bridge.browser(sockets[q['bridge']]);
	});
	return wsserver;
}
