var Monitor = _require('common/lib/monitor');
var URL = require('url');

function secure(req,res,next){
	if(['127.0.0.1','::ffff:127.0.0.1','::1'].indexOf(req.ip) >= 0){
		next();
		return;
	}else if(!req.secure && req.app.HTTPSserver){
		var port = req.app.HTTPSserver.address().port;
		var url =  URL.parse('http://' + req.headers.host);
		var host;
		host = (url.host.match(/\[.*\]/))?('[' + url.hostname +']'):url.hostname;
		res.redirect(['https://',host,((port !==443)?':'+port:''),req.originalUrl].join(''));
		return;
	}else{
		next();
	}
}
function auth(req,res,next){
	var u;
	if(req.cookies.token){
		u = Monitor.getUserByToken(req.cookies.token);
		if(u && u.data.loggedIn){
			req.token = req.cookies.token;
		}
	}
	if(req.params.token){
		u = Monitor.getUserByToken(req.params.token);
		if(u && u.data.loggedIn){
			req.token = req.params.token;
		}
	}
	if(!req.token || !u || !u.data.loggedIn){
		res.clearCookie('username');
		res.clearCookie('host');
		res.clearCookie('token');
		res.clearCookie('token');
		res.redirect(['/auth',URL.parse(req.originalUrl).search].join(''));
		return;
	}else{
		req.user = u;
		req.isAdmin = Monitor.isAdmin(u.data.token);
		res.cookie('username',u.data.login,cookieExpireTime());
		res.cookie('host',u.data.hostname,cookieExpireTime());
		res.cookie('token',req.cookies.token,cookieExpireTime());
		Monitor.queueUser(req.token,{
			token:req.token,
			action:'keepalive'}
		);
		next();
		return;
	}
}
function cookieExpireTime(){return {expires:new Date(Date.now() + 3600000)};}
module.exports = {
	auth:auth,
	secure:secure,
	cookieExpireTime:cookieExpireTime
}
