var extend = require('extend');
var path = require('path');

var Connections = require('../ssh/connections').Connections

var ERROR 		= _require('common/lib/error-responses');
var Monitor 	= _require('common/lib/monitor');

function Action(){
	this.local = false;
	var that = this;
	Object.defineProperty(this,'Connections',{
		get:function(){
			return Connections;
		}
	});
	Object.defineProperty(this,'ERROR',{
		get:function(){
			return ERROR;
		}
	});
}

Action.prototype.localExec = function(m,cb,raw){
	if(m.id){m.data = extend({id:m.id},m.data);}
	if(!Monitor.userExec(m.token,{
		msgId:m.msgId,
		action:m.action,
		data:m.data
	},cb)){
		Monitor.sendResponse(m.msgId,ERROR.authenticationRequired,m.serverId);
	}
	return true;
}
Action.prototype.sudoExec = function(login,m,cb){
	if(m.id){m.data = extend({id:m.id},m.data);}
	var command;
	if(m.action !== 'schedule'){
		command = path.resolve(global.FXROOTDIR,'api',m.action);
	}else{
		if(m.data.profile){
			command = (new ProfileCache(m.data.profile)).data.schedule.script || Session.data.schedule.script;
		}else{
			command = Session.data.schedule.script;
		}
	}
	Monitor.sudoExec(m.sudo,{
		msgId:m.msgId,
		command:command,
		data:m.data
	},cb);
	return true;
}
Action.prototype.keepalive = function(m,cb){
	var u = Monitor.getUserByToken(m.token);
	if(u && u.link){
		u.link.keepalive(600000);
	}else{
		Monitor.sendResponse(m.msgId,ERROR.authenticationRequired,m.serverId);
	}
}
Action.prototype.runCommand = function(m,cb,raw){
	if(!Connections.runCommand(m.token,{
		action:m.action,
		data:m.data,
		cb:cb,
		raw:raw
	})){
		Monitor.sendResponse(m.msgId,ERROR.authenticationRequired,m.serverId);
	}
	return true;
}
module.exports.Action = Action;
