var Api = require('./api').Api;

var ERROR 		= _require('common/lib/error-responses');
var localPool	= _require('common/lib/local-pool');
var Monitor 	= _require('common/lib/monitor');
var Network 	= _require('common/lib/config/network');
var Settings 	= _require('common/lib/config/settings');

function LocalApi(o){
	this.api = new Api(o);
	var that = this;

	this.api.status = function(m,cb){
		cb(null);
	}
}

LocalApi.prototype.process = function(m,cb,serverId){
	var that = this;
	var cb = cb || function(msg){
		Monitor.sendResponse(m.msgId,msg,m.serverId);
	}

	if(that.api[m.action]){//exec session
		that.api[m.action](m,cb,serverId);
	}else if(m.action === 'user-data'){
		localPool.ee.emit('snUserData:' + m.token,m);
	}else{//exec local
		that.api.localExec(m,cb);
	}
}

var api  = new LocalApi({});
localPool.ee.on('snLocalMessage',function(e){
	api.process(e.m,e.cb,e.serverId);
});
localPool.ee.on('snServerMessage',function(e){
	if(e.result){
		var m,cb;
		if(e.result.messages){
			while(m = e.result.messages.shift()){
				m.serverId = e.result.serverId;
				api.process(m,null,e.result.serverId);
			}
		}
	}
});
module.exports.LocalApi =  api;
