function Netstring(){}

Netstring.prototype.encode = function(str){
	var b = new Buffer(str,'utf8');
	return Buffer.concat(
		[new Buffer(b.length.toString(),'ascii')
		,new Buffer(':','ascii'),
		b,
		new Buffer(',','ascii')]
	);
}

Netstring.prototype.decode = function(buf,encoding){
	encoding = encoding || 'utf8';
	var i =0,len ='',c;
	if(buf.length < 3){
		return;
	}
	while(i<buf.length){
		c = String.fromCharCode(buf[i++]);
		if(c >= '0' && c <= '9'){
			len += c;
		}else if(c == ':'){
			len = parseInt(len,10);
			break;
		} else {
			throw new Error('Invalid Netstring character ' + c);
		}
	}
	if (!len || i + len + 1 > buf.length) {
		return;
	}
	var str = buf.toString(encoding, i, i + len);
	c = String.fromCharCode(buf[i + len]);
	if(c != ','){
		throw new Error('Missing Netstring comma');
	}
	return {
		next:i + len + 1,
		data:str
	};
}
module.exports = new Netstring();
