var Connection = require('./connection').Connection;

var localPool 	= _require('common/lib/local-pool'); 
var Monitor 	= _require('common/lib/monitor');



function Connections(){
	this.connections = {};
	var that = this;
	localPool.ee.on('snDeleteUser',function(d){
		if(that.connections[d.token] && that.connections[d.token].ssh){
			that.connections[d.token].ssh.end();
		}
		delete that.connections[d.token];
	});
}
Connections.prototype.create = function(m){
	var that = this;
	m.destroy = function(){
		delete that.connections[m.token];
	}
	this.connections[m.token] = new Connection(m);
	return true;
}
Connections.prototype.login = function(m){
	this.create(m);
	this.connections[m.token].setMessageId(m.msgId,m.serverId);
	m.data.token = m.token;
	this.connections[m.token].connect(m.data);
	return true;
}
Connections.prototype.password = function(m){
	if(this.connections[m.token]){
		this.connections[m.token].setMessageId(m.msgId,m.serverId);
		this.connections[m.token].cb(m.data.password);
		return true;
	}
}
Connections.prototype.publicKey = function(m){
	if(this.connections[m.token]){
		this.connections[m.token].setMessageId(m.msgId,m.serverId);
		if(m.data.publicKey){
			this.connections[m.token].cb(new Buffer(m.data.publicKey,'base64'));
		}else{
			this.connections[m.token].cb('');
		}
		return true;
	}
}
Connections.prototype.publicKeySigned = function(m){
	if(this.connections[m.token]){
		this.connections[m.token].setMessageId(m.msgId,m.serverId);
		if(m.data.signature){
			this.connections[m.token].cb(new Buffer(m.data.signature,'base64'));
		}else{
			this.connections[m.token].cb('');
		}
		return true;
	}
}
Connections.prototype.keyboardInteractive = function(m){
	if(this.connections[m.token]){
		this.connections[m.token].setMessageId(m.msgId,m.serverId);
		if(m.data.answer && this.connections[m.token].answers ){
			this.connections[m.token].answers.push(m.data.answer);
			if(this.connections[m.token].prompts.length){
				var params = {result:{
					stage:'keyboard-interactive',
					token:m.token,
					prompt:this.connections[m.token].prompts.shift()
				}};
				Monitor.sendResponse(m.msgId,params,m.serverId);
			}else{
				var a = this.connections[m.token].answers;
				this.connections[m.token].cb(a);
				delete this.connections[m.token].answers;
			}
		}else{
			this.connections[m.token].cb(m.data.answers);
		}
		return true;
	}
}
module.exports.Connections = new Connections();
