var net  = require('net');
var WebSocket = require('ws');

var checkGatewayServerIdentity = require('../check-gateway-server-identity');

var Network = _require('common/lib/config/network');

exports.connect = function(o){
	var ws = new WebSocket(o.url,{
		checkServerIdentity:checkGatewayServerIdentity,
		rejectUnauthorized:Network.data.rejectUnauthorized
	});

	var tcp = net.connect({port:o.port});
	
	ws.on('open',function(){});
	ws.on('message',function(data,flags){tcp.write(data);});
	ws.on('close',function(){tcp.end();});
	
	tcp.on('open',function(){});
	tcp.on('data',function(data,flags){
		try{
			if(ws.bufferedAmount > 100000){	
				tcp.pause();
				ws.send(data,function(){
					tcp.resume();
				});
			}else{
				ws.send(data);
			}
		}catch(e){
			console.log(e.message);
			ws.close();
			tcp.destroy();
		}
	});
	tcp.on('error',function(err){
		console.log('tcp - err',err);
		ws.close();
		tcp.destroy();
	});
	tcp.on('end',function(){
		ws.close();
	});
	tcp.on('close',function(had_error){
		ws.close();
		tcp.end();
	});
	
}